Attribute VB_Name = "Color"
Option Explicit
Option Compare Text

Public iRed As Integer              'RGB color code
Public iGreen As Integer            'RGB color code
Public iBlue As Integer             'RGB color code
Public sCurrentColor As String
Public sColorNames(140) As String   'Array with color names


'******************************************************************
'This section deals with colors                                   *
'******************************************************************

Sub FillColorNamesArray()
'Fills the sColorNames array

    sColorNames(0) = "aliceblue"
    sColorNames(1) = "antiquewhite"
    sColorNames(2) = "aqua"
    sColorNames(3) = "aquamarine"
    sColorNames(4) = "azure"
    sColorNames(5) = "beige"
    sColorNames(6) = "bisque"
    sColorNames(7) = "black"
    sColorNames(8) = "blanchedalmond"
    sColorNames(9) = "blue"
    sColorNames(10) = "blueviolet"
    sColorNames(11) = "brown"
    sColorNames(12) = "burlywood"
    sColorNames(13) = "cadetblue"
    sColorNames(14) = "chartreuse"
    sColorNames(15) = "chocolate"
    sColorNames(16) = "coral"
    sColorNames(17) = "cornflowerblue"
    sColorNames(18) = "cornsilk"
    sColorNames(19) = "crimson"
    sColorNames(20) = "cyan"
    sColorNames(21) = "darkblue"
    sColorNames(22) = "darkcyan"
    sColorNames(23) = "darkgoldenrod"
    sColorNames(24) = "darkgray"
    sColorNames(25) = "darkgreen"
    sColorNames(26) = "darkkhaki"
    sColorNames(27) = "darkmagenta"
    sColorNames(28) = "darkolivegreen"
    sColorNames(29) = "darkorange"
    sColorNames(30) = "darkorchid"
    sColorNames(31) = "darkred"
    sColorNames(32) = "darksalmon"
    sColorNames(33) = "darkseagreen"
    sColorNames(34) = "darkslateblue"
    sColorNames(35) = "darkslategray"
    sColorNames(36) = "darkturquoise"
    sColorNames(37) = "darkviolet"
    sColorNames(38) = "deeppink"
    sColorNames(39) = "deepskyblue"
    sColorNames(40) = "dimgray"
    sColorNames(41) = "dodgerblue"
    sColorNames(42) = "firebrick"
    sColorNames(43) = "floralwhite"
    sColorNames(44) = "forestgreen"
    sColorNames(45) = "fuchsia"
    sColorNames(46) = "gainsboro"
    sColorNames(47) = "ghostwhite"
    sColorNames(48) = "gold"
    sColorNames(49) = "goldenrod"
    sColorNames(50) = "gray"
    sColorNames(51) = "green"
    sColorNames(52) = "greenyellow"
    sColorNames(53) = "honeydew"
    sColorNames(54) = "hotpink"
    sColorNames(55) = "indianred"
    sColorNames(56) = "indigo"
    sColorNames(57) = "ivory"
    sColorNames(58) = "khaki"
    sColorNames(59) = "lavender"
    sColorNames(60) = "lavenderblush"
    sColorNames(61) = "lawngreen"
    sColorNames(62) = "lemonchiffon"
    sColorNames(63) = "lightblue"
    sColorNames(64) = "lightcoral"
    sColorNames(65) = "lightcyan"
    sColorNames(66) = "lightgoldenrodyellow"
    sColorNames(67) = "lightgreen"
    sColorNames(68) = "lightgrey"
    sColorNames(69) = "lightpink"
    sColorNames(70) = "lightsalmon"
    sColorNames(71) = "lightseagreen"
    sColorNames(72) = "lightskyblue"
    sColorNames(73) = "lightslategray"
    sColorNames(74) = "lightsteelblue"
    sColorNames(75) = "lightyellow"
    sColorNames(76) = "lime"
    sColorNames(77) = "limegreen"
    sColorNames(78) = "linen"
    sColorNames(79) = "magenta"
    sColorNames(80) = "maroon"
    sColorNames(81) = "mediumaquamarine"
    sColorNames(82) = "mediumblue"
    sColorNames(83) = "mediumorchid"
    sColorNames(84) = "mediumpurple"
    sColorNames(85) = "mediumseagreen"
    sColorNames(86) = "mediumslateblue"
    sColorNames(87) = "mediumspringgreen"
    sColorNames(88) = "mediumturquoise"
    sColorNames(89) = "mediumvioletred"
    sColorNames(90) = "midnightblue"
    sColorNames(91) = "mintcream"
    sColorNames(92) = "mistyrose"
    sColorNames(93) = "moccasin"
    sColorNames(94) = "navajowhite"
    sColorNames(95) = "navy"
    sColorNames(96) = "oldlace"
    sColorNames(97) = "olive"
    sColorNames(98) = "olivedrab"
    sColorNames(99) = "orange"
    sColorNames(100) = "orangered"
    sColorNames(101) = "orchid"
    sColorNames(102) = "palegoldenrod"
    sColorNames(103) = "palegreen"
    sColorNames(104) = "paleturquoise"
    sColorNames(105) = "palevioletred"
    sColorNames(106) = "papayawhip"
    sColorNames(107) = "peachpuff"
    sColorNames(108) = "peru"
    sColorNames(109) = "pink"
    sColorNames(110) = "plum"
    sColorNames(111) = "powderblue"
    sColorNames(112) = "purple"
    sColorNames(113) = "red"
    sColorNames(114) = "rosybrown"
    sColorNames(115) = "royalblue"
    sColorNames(116) = "saddlebrown"
    sColorNames(117) = "salmon"
    sColorNames(118) = "sandybrown"
    sColorNames(119) = "seagreen"
    sColorNames(120) = "seashell"
    sColorNames(121) = "sienna"
    sColorNames(122) = "silver"
    sColorNames(123) = "skyblue"
    sColorNames(124) = "slateblue"
    sColorNames(125) = "slategray"
    sColorNames(126) = "snow"
    sColorNames(127) = "springgreen"
    sColorNames(128) = "steelblue"
    sColorNames(129) = "tan"
    sColorNames(130) = "teal"
    sColorNames(131) = "thistle"
    sColorNames(132) = "tomato"
    sColorNames(133) = "turquoise"
    sColorNames(134) = "violet"
    sColorNames(135) = "wheat"
    sColorNames(136) = "white"
    sColorNames(137) = "whitesmoke"
    sColorNames(138) = "yellow"
    sColorNames(139) = "yellowgreen"

End Sub

'******************************************************************
'The next functions convert colors, e.g. Windows' Long to RGB Hex *
'******************************************************************

Public Function LongToRGB(ByVal lColor) As Long
'Converts a long to RGB.
'Used as first step in converting the commondialog
'color from Windows' Long to RGB values.
'Copied from http://www.redleif.com/vb/vbtips.html

Dim lMask As Long

lMask = (lColor And &HFF) Xor (lColor \ &H10000)
LongToRGB = lColor Xor (lMask * &H10001)
End Function

Public Function RgbToHex(ByVal RGBValue) As String
'Converts RGB values to HEX as used on a website.
'Copied (and modified) from http://www.codearchive.com/~dreamvb/VbTips.htm

Dim sRgbHex As String
Dim iLen As Integer

sRgbHex = Hex(RGBValue)
iLen = Len(sRgbHex)
If iLen = 5 Then sRgbHex = "0" & sRgbHex
If iLen = 4 Then sRgbHex = "00" & sRgbHex
If iLen = 3 Then sRgbHex = "000" & sRgbHex
If iLen = 2 Then sRgbHex = "0000" & sRgbHex
If iLen = 1 Then sRgbHex = "00000" & sRgbHex
RgbToHex = "#" & sRgbHex
End Function


Public Function HexToRgb(ByRef sHexCode) As Integer
'Converts a RGB color in Hex to its integer value.
'An RGB color is 6 characters e.g. 7FFFD4. The two
'First are for blue, the next for green and the two
'last for red. This function converts one pair.
'The first and second char is one of
'[0,1,2,3,4,5,6,7,8,9,A,B,C,D,E,F]
'A,B,C,D,E and F are converted to integer values
'from 10 to 15 by the function RGBHexToVal.
'The RGB integer value is calculated with this formula:
'First integer * 16 + second integer.
'For example "FF" will be 15 * 16 + 15 = 255

HexToRgb = RGBHexToVal(Left$(sHexCode, 1)) * 16 + RGBHexToVal(Right$(sHexCode, 1))

End Function

Private Function RGBHexToVal(ByRef sChar) As Integer
'Converts a Hex char to an integer.

Select Case sChar
    Case "A"
        RGBHexToVal = 10
    Case "B"
        RGBHexToVal = 11
    Case "C"
        RGBHexToVal = 12
    Case "D"
        RGBHexToVal = 13
    Case "E"
        RGBHexToVal = 14
    Case "F"
        RGBHexToVal = 15
    Case Else
        RGBHexToVal = Val(sChar)
End Select

End Function


Public Function ColornameToHex(sColor) As String

Select Case sColor
    Case 0  ' aliceblue
        ColornameToHex = "F0F8FF"
    Case 1  ' antiquewhite
        ColornameToHex = "FAEBD7"
    Case 2  ' aqua
        ColornameToHex = "00FFFF"
    Case 3  ' aquamarine
        ColornameToHex = "7FFFD4"
    Case 4  ' azure
        ColornameToHex = "F0FFFF"
    Case 5  ' beige
        ColornameToHex = "F5F5DC"
    Case 6  ' bisque
        ColornameToHex = "FFE4C4"
    Case 7  ' black
        ColornameToHex = "000000"
    Case 8  ' blanchedalmond
        ColornameToHex = "FFEBCD"
    Case 9  ' blue
        ColornameToHex = "0000FF"
    Case 10  ' blueviolet
        ColornameToHex = "8A2BE2"
    Case 11  ' brown
        ColornameToHex = "A52A2A"
    Case 12  ' burlywood
        ColornameToHex = "DEB887"
    Case 13  ' cadetblue
        ColornameToHex = "5F9EA0"
    Case 14  ' chartreuse
        ColornameToHex = "7FFF00"
    Case 15  ' chocolate
        ColornameToHex = "D269E1"
    Case 16  ' coral
        ColornameToHex = "FF7F50"
    Case 17  ' cornflowerblue
        ColornameToHex = "6495ED"
    Case 18  ' cornsilk
        ColornameToHex = "FFF8DC"
    Case 19  ' crimson
        ColornameToHex = "DC143C"
    Case 20  ' cyan
        ColornameToHex = "00FFFF"
    Case 21  ' darkblue
        ColornameToHex = "00008B"
    Case 22  ' darkcyan
        ColornameToHex = "008B8B"
    Case 23  ' darkgoldenrod
        ColornameToHex = "B8860B"
    Case 24  ' darkgray
        ColornameToHex = "A9A9A9"
    Case 25  ' darkgreen
        ColornameToHex = "006400"
    Case 26  ' darkkhaki
        ColornameToHex = "BDB76B"
    Case 27  ' darkmagenta
        ColornameToHex = "8B008B"
    Case 28  ' darkolivegreen
        ColornameToHex = "556B2F"
    Case 29  ' darkorange
        ColornameToHex = "FF8C00"
    Case 30  ' darkorchid
        ColornameToHex = "9932CC"
    Case 31  ' darkred
        ColornameToHex = "8B0000"
    Case 32  ' darksalmon
        ColornameToHex = "E9967A"
    Case 33  ' darkseagreen
        ColornameToHex = "8FBC8F"
    Case 34  ' darkslateblue
        ColornameToHex = "483D8B"
    Case 35  ' darkslategray
        ColornameToHex = "2F4F4F"
    Case 36  ' darkturquoise
        ColornameToHex = "00CED1"
    Case 37  ' darkviolet
        ColornameToHex = "9400D3"
    Case 38  ' deeppink
        ColornameToHex = "FF1493"
    Case 39  ' deepskyblue
        ColornameToHex = "00BFFF"
    Case 40  ' dimgray
        ColornameToHex = "696969"
    Case 41  ' dodgerblue
        ColornameToHex = "1E90FF"
    Case 42  ' firebrick
        ColornameToHex = "B22222"
    Case 43  ' floralwhite
        ColornameToHex = "FFFAF0"
    Case 44  ' forestgreen
        ColornameToHex = "228B22"
    Case 45  ' fuchsia
        ColornameToHex = "FF00FF"
    Case 46  ' gainsboro
        ColornameToHex = "DCDCDC"
    Case 47  ' ghostwhite
        ColornameToHex = "F8F8FF"
    Case 48  ' gold
        ColornameToHex = "FFD700"
    Case 49  ' goldenrod
        ColornameToHex = "DAA520"
    Case 50  ' gray
        ColornameToHex = "808080"
    Case 51  ' green
        ColornameToHex = "008000"
    Case 52  ' greenyellow
        ColornameToHex = "ADFF2F"
    Case 53  ' honeydew
        ColornameToHex = "F0FFF0"
    Case 54  ' hotpink
        ColornameToHex = "FF69B4"
    Case 55  ' indianred
        ColornameToHex = "CD5C5C"
    Case 56  ' indigo
        ColornameToHex = "4B0082"
    Case 57  ' ivory
        ColornameToHex = "FFFFF0"
    Case 58  ' khaki
        ColornameToHex = "F0E6C8"
    Case 59  ' lavender
        ColornameToHex = "E6E6FA"
    Case 60  ' lavenderblush
        ColornameToHex = "FFF0F5"
    Case 61  ' lawngreen
        ColornameToHex = "7CFC00"
    Case 62  ' lemonchiffon
        ColornameToHex = "FFFACD"
    Case 63  ' lightblue
        ColornameToHex = "ADD8E6"
    Case 64  ' lightcoral
        ColornameToHex = "F08080"
    Case 65  ' lightcyan
        ColornameToHex = "E0FFFF"
    Case 66  ' lightgoldenrodyellow
        ColornameToHex = "FAFAD2"
    Case 67  ' lightgreen
        ColornameToHex = "90EE90"
    Case 68  ' lightgrey
        ColornameToHex = "D3D3D3"
    Case 69  ' lightpink
        ColornameToHex = "FFB6C1"
    Case 70  ' lightsalmon
        ColornameToHex = "FFA07A"
    Case 71  ' lightseagreen
        ColornameToHex = "20B2AA"
    Case 72  ' lightskyblue
        ColornameToHex = "87CEFA"
    Case 73  ' lightslategray
        ColornameToHex = "778899"
    Case 74  ' lightsteelblue
        ColornameToHex = "B0C4DE"
    Case 75  ' lightyellow
        ColornameToHex = "FFFFE0"
    Case 76  ' lime
        ColornameToHex = "00FF00"
    Case 77  ' limegreen
        ColornameToHex = "32CD32"
    Case 78  ' linen
        ColornameToHex = "FAF0E6"
    Case 79  ' magenta
        ColornameToHex = "FF00FF"
    Case 80  ' maroon
        ColornameToHex = "800000"
    Case 81  ' mediumaquamarine
        ColornameToHex = "66CDAA"
    Case 82  ' mediumblue
        ColornameToHex = "0000CD"
    Case 83  ' mediumorchid
        ColornameToHex = "BA55D3"
    Case 84  ' mediumpurple
        ColornameToHex = "9370DB"
    Case 85  ' mediumseagreen
        ColornameToHex = "C3B371"
    Case 86  ' mediumslateblue
        ColornameToHex = "7B68EE"
    Case 87  ' mediumspringgreen
        ColornameToHex = "00FA9A"
    Case 88  ' mediumturquoise
        ColornameToHex = "48D1CC"
    Case 89  ' mediumvioletred
        ColornameToHex = "C71585"
    Case 90  ' midnightblue
        ColornameToHex = "191970"
    Case 91  ' mintcream
        ColornameToHex = "F5FFFA"
    Case 92  ' mistyrose
        ColornameToHex = "FFE4E1"
    Case 93  ' moccasin
        ColornameToHex = "FFE4B5"
    Case 94  ' navajowhite
        ColornameToHex = "FFDEAD"
    Case 95  ' navy
        ColornameToHex = "000080"
    Case 96  ' oldlace
        ColornameToHex = "FDF5E6"
    Case 97  ' olive
        ColornameToHex = "808000"
    Case 98  ' olivedrab
        ColornameToHex = "6B8E23"
    Case 99  ' orange
        ColornameToHex = "FFA500"
    Case 100  ' orangered
        ColornameToHex = "FF4500"
    Case 101  ' orchid
        ColornameToHex = "DA70D6"
    Case 102  ' palegoldenrod
        ColornameToHex = "EEE8AA"
    Case 103  ' palegreen
        ColornameToHex = "98FB98"
    Case 104  ' paleturquoise
        ColornameToHex = "AFEEEE"
    Case 105  ' palevioletred
        ColornameToHex = "DB7093"
    Case 106  ' papayawhip
        ColornameToHex = "FFEFD5"
    Case 107  ' peachpuff
        ColornameToHex = "FFDAB9"
    Case 108  ' peru
        ColornameToHex = "CD853F"
    Case 109  ' pink
        ColornameToHex = "FFC0CB"
    Case 110  ' plum
        ColornameToHex = "DDA0DD"
    Case 111  ' powderblue
        ColornameToHex = "B0E0E6"
    Case 112  ' purple
        ColornameToHex = "800080"
    Case 113  ' red
        ColornameToHex = "FF0000"
    Case 114  ' rosybrown
        ColornameToHex = "BC8F8F"
    Case 115  ' royalblue
        ColornameToHex = "4169E1"
    Case 116  ' saddlebrown
        ColornameToHex = "8B4513"
    Case 117  ' salmon
        ColornameToHex = "FA8072"
    Case 118  ' sandybrown
        ColornameToHex = "F4A460"
    Case 119  ' seagreen
        ColornameToHex = "2E8B57"
    Case 120  ' seashell
        ColornameToHex = "FFF5EE"
    Case 121  ' sienna
        ColornameToHex = "A0522D"
    Case 122  ' silver
        ColornameToHex = "C0C0C0"
    Case 123  ' skyblue
        ColornameToHex = "87CEEB"
    Case 124  ' slateblue
        ColornameToHex = "6A5ACD"
    Case 125  ' slategray
        ColornameToHex = "708090"
    Case 126  ' snow
        ColornameToHex = "FFFAFA"
    Case 127  ' springgreen
        ColornameToHex = "O0FF7F"
    Case 128  ' steelblue
        ColornameToHex = "4682B4"
    Case 129  ' tan
        ColornameToHex = "D2B48C"
    Case 130  ' teal
        ColornameToHex = "008080"
    Case 131  ' thistle
        ColornameToHex = "D8BFD8"
    Case 132  ' tomato
        ColornameToHex = "FF6347"
    Case 133  ' turquoise
        ColornameToHex = "40E0D0"
    Case 134  ' violet
        ColornameToHex = "EE82EE"
    Case 135  ' wheat
        ColornameToHex = "F5DEB3"
    Case 136  ' white
        ColornameToHex = "FFFFFF"
    Case 137  ' whitesmoke
        ColornameToHex = "F5F5F5"
    Case 138  ' yellow
        ColornameToHex = "FFFF00"
    Case 139  ' yellowgreen
        ColornameToHex = "9ACD32"
    Case Else
        ColornameToHex = "000000"
End Select

End Function


Function ColorImportConvert(ByVal sComvalue) As String
'Checks imported color code (be it Hex or not) and
'converts it to Hex with a leading #.
Dim lCount As Long
Dim bColor As Boolean

If Len(sComvalue) = 0 Then Exit Function
On Error GoTo ErrorHandle

bColor = False

If Left$(sComvalue, 1) = "#" Then       'If the first char is # the string is truncated.
    If Len(sComvalue) < 7 Then
        MsgBox sComvalue & " is not a valid RGB Hex color. " & _
        "It has been changed to black.", vbCritical, "Error in input color string"
        sComvalue = "#000000"   'Sets color to black
    End If
Else
'   We check if it is a proper color name
    For lCount = 0 To 140
        If sComvalue = sColorNames(lCount) Then 'If there's a match
            bColor = True                       'bColor is true
            Exit For                            'and we exit the loop
        End If
    Next
'   If a match wasn't found
    If bColor = False Then
        MsgBox sComvalue & " is not a proper color. " & _
        "It has now been changed to black.", , "Error in input color string"
        sComvalue = "#000000"    'Sets color to black
    Else
'       Converts the color name to RGB Hex
        sComvalue = "#" & ColornameToHex(Str$(lCount))
    End If
End If

ColorImportConvert = sComvalue

Exit Function
ErrorHandle:
MsgBox Err.Description & vbNewLine & "An error occured in Function ColorImportConvert.", , "Error"
End Function

