Attribute VB_Name = "Files"
Option Explicit
Option Compare Text
Public m_cHookDlg As cCommonDialog
Public spubPath As String


Public Sub LoadTextFile(ByVal sFullPath, ByRef sStringToFill)
'Opens a file and returns the text as a string to the
'calling procedure.

Dim iFileNumber As Integer

On Error GoTo ErrorHandler

iFileNumber = FreeFile  'Gets a free filenumber from the OS

Open sFullPath For Input As #iFileNumber

'The file text is copied to sStringToFill
sStringToFill = Input(LOF(iFileNumber), iFileNumber)

Close #iFileNumber  'Closes file
Exit Sub
ErrorHandler:
MsgBox Err.Description & vbNewLine & "Error in Procedure LoadTextFile.", vbCritical, "Error"
End Sub
Sub SaveFileAs(sText As String, ByVal sExtension As String)
Dim sDirectory As String

On Error GoTo ErrorHandler

Call SaveFileAsDialog("Save File As", sExtension, "", "", "single", sText)

Exit Sub
ErrorHandler:
MsgBox Err.Description & vbNewLine & "Error in Procedure SaveFileAs, Module Files.", vbCritical, "Error"
End Sub
Sub SaveFileAsDialog(ByRef sTitle, ByVal sFilter As String, sPath As String, _
sInitDir As String, sFlags As String, sText As String)

'sTitle is the dialogs caption
'sFilter the file type filter
'sPath the returned string = the selected file + path
'sInitDir is the directory where the dialog is to start
'sText is the content/text of the new file

Dim sExtension As String

On Error GoTo cmdHookError

If m_cHookDlg Is Nothing Then
    Set m_cHookDlg = New cCommonDialog
End If

If Len(sFlags) = 0 Or sFlags = "single" Then
    sFlags = OFN_OVERWRITEPROMPT
ElseIf sFlags = "multi" Then
    sFlags = OFN_ALLOWMULTISELECT
End If

sExtension = LCase(sFilter)

Select Case sFilter
    Case "CSS"
        sFilter = "Css files (*.css)|*.css|"
    Case "PGN"
        sFilter = "Pgn files (*.pgn)|*.pgn|"
    Case "EXE"
        sFilter = "Exe files (*.exe)|*.exe|"
    Case "HTM"
        sFilter = "HTML files (*.htm)|*.htm|"
End Select

With m_cHookDlg
    .DialogTitle = sTitle
    .CancelError = True
    .Flags = sFlags
    .InitDir = sInitDir
    .Filter = sFilter
    '.Filter = "HTML files (*.HTM)|*.HTM|Text files (*.TXT)|*.TXT|All Files (*.*)|*.*"
    .FilterIndex = 1
    .HookDialog = True
    .ShowSave
    sPath = .Filename
End With

'We now check the extension of the new filename
If InStr(1, sPath, ".") = 0 Then
    sPath = sPath & "." & sExtension
Else
    If Right$(sPath, 3) <> sExtension Then
        sPath = Left$(sPath, Len(sPath) - 3)
        sPath = sPath & sExtension
    End If
End If

Call Savefile(sPath, sText, False, True)

Select Case sExtension
    Case "pgn"
'       If it is a pgnfile the path property is set.
        cWebPages(lAW).PgnFiles(lAP).FilePath = sPath
    Case "css"
    
    Case "htm"
End Select

Exit Sub

Abort:
Exit Sub
cmdHookError:
   If (Err.Number <> 20001) Then
      MsgBox "Error: " & Err.Description
   End If

End Sub
Sub OpenFileDialog(ByRef sTitle, ByVal sFilter As String, sPath As String, _
sInitDir As String, sFlags As String)

'sTitle is the dialogs caption
'sFilter the file type filter
'sPath the returned string = the selected file + path
'sInitDir is the directory where the dialog is to start


Dim sDir As String
Dim sFiles() As String
Dim iFileCount As Long
Dim lCount As Long


On Error GoTo cmdHookError

If m_cHookDlg Is Nothing Then
    Set m_cHookDlg = New cCommonDialog
End If

If Len(sFlags) = 0 Or sFlags = "single" Then
    sFlags = OFN_OVERWRITEPROMPT
ElseIf sFlags = "multi" Then
    sFlags = OFN_ALLOWMULTISELECT
End If

Select Case sFilter
    Case "CSS"
        sFilter = "Css files (*.css)|*.css|"
    Case "PGN"
        sFilter = "Pgn files (*.pgn)|*.pgn|"
    Case "EXE"
        sFilter = "Exe files (*.exe)|*.exe|"
    Case "HTM"
        sFilter = "HTML files (*.HTM*)|*.HTM*|All Files (*.*)|*.*"
    Case "insert"
        sFilter = "HTML files (*.HTM*)|*.HTM*|Text Files (*.txt)|*.txt|"
    Case "image"
        sFilter = "Graphics (*.gif;*.jpg;*.jpeg;*.bmp;*.png)|*.gif;*.jpg;*.jpeg;*.bmp;*.png|All Files (*.*)|*.*"
End Select

With m_cHookDlg
    .DialogTitle = sTitle
    .CancelError = True
    .Flags = sFlags
    .InitDir = sInitDir
    .Filter = sFilter
    '.Filter = "HTML files (*.HTM)|*.HTM|Text files (*.TXT)|*.TXT|All Files (*.*)|*.*"
    .FilterIndex = 1
    .HookDialog = True
    .ShowOpen
    
    If sFlags = OFN_ALLOWMULTISELECT Then
        Call .ParseMultiFileName(sDir, sFiles(), iFileCount)
        If Right$(sDir, 1) = "\" Then
            sDir = Left$(sDir, Len(sDir) - 1)
        End If
        If iFileCount > 1 Then
            For lCount = 1 To iFileCount
                sPath = sPath & sDir & "\" & sFiles(lCount) & ";"
            Next
        Else
            sPath = .Filename
        End If
    Else
        sPath = .Filename
    End If
End With
   
   
Exit Sub

Abort:
Exit Sub
cmdHookError:
   If (Err.Number <> 20001) Then
      MsgBox "Error: " & Err.Description
   End If

End Sub
Sub Savefile(ByVal sFile As String, sFileText As String, bReadOnly As Boolean, bOverWrite As Boolean)
'Opens a text file and saves it with a new content.
'The file name is passed from the calling procedure in sFile,
'and the file text is in sFileText.
'The boolean value bReadOnly tells whether the file is to be
'saved as readonly or not.

Dim iFileNumber As Integer  'Used by the OS to assign a free number.
Dim sAnswer As String

On Error GoTo ErrorHandler

If FileCheck(sFile) Then
    If bOverWrite = False Then
        sAnswer = MsgBox("Replace existing " & sFile & "?", vbYesNo, "Replace?")
        If sAnswer = vbNo Then Exit Sub
    End If
    SetAttr sFile, vbNormal
End If

'Gets a free number from the OS and saves the file
iFileNumber = FreeFile
Open sFile For Output As #iFileNumber

Print #iFileNumber, sFileText
Close #iFileNumber

If bReadOnly Then
    SetAttr sFile, vbReadOnly
End If

Exit Sub

ErrorHandler:
MsgBox Err.Description & vbNewLine & "Unexpected error in procedure SaveFile", vbCritical, "Error"
End Sub

Private Sub m_cHookDlg_InitDialog(ByVal hDlg As Long)
   'm_cHookDlg.CentreDialog hDlg, Me
End Sub




