Attribute VB_Name = "Functions"
Private Declare Function IsCharAlphaNumericA Lib "User32" (ByVal byChar As Byte) As Long
Option Explicit

Function FileCheck(sPath) As Boolean
'Returns true if a given file exists. The argument
'"sPath" is passed from the calling procedure and
'contains filename + full path.

'Dim sFile As String

On Error GoTo ErrorHandler

'Checks if the there's a period in the path. The path
'could be a directory name only, and if it contains a
'file, a file name would be returned. E.G. "Dir(C:\)"
'would return "Command.com".
If InStr(1, sPath, ".", vbTextCompare) = 0 Then Exit Function

'sFile = Dir(sPath)       'Returns the file name + extension if it exists

'If the file name is longer than 0.
If Len(Dir(sPath)) > 0 Then FileCheck = True

Exit Function
ErrorHandler:
MsgBox Err.Description & vbNewLine & "Unexpected error in function FileCheck.", vbCritical, "Error"
End Function
Public Function bSameFolder() As Boolean
'Returns true if the source folder and the HTML target folder are the same.
Dim sHtmlTarget As String
Dim sSource As String

On Error GoTo ErrorHandle

With cLayouts(lAL)
    sHtmlTarget = .PathHtml & "\"
    If .Ini2.HtmlType <> "magviewer" Then
        sSource = cWebPages(lAW).PgnFiles(lAP).PgnDir
    Else
        sSource = App.path & "\Resource\"
    End If
End With

If sHtmlTarget = sSource Then bSameFolder = True

Exit Function
ErrorHandle:
bAbort = True
MsgBox Err.Description & vbNewLine & "Function bSameFolder", vbCritical, "Error"
End Function

Function dhIsCharAlphanumeric(sText As String) As Boolean
'A very fast API call function that checks whether
'a char is alphanumeric. Cut from "VBA Developer's Handbook"
'by Ken Getz and Mike Gilbert.

On Error GoTo ErrorHandle
If Len(sText) = 0 Then Exit Function
dhIsCharAlphanumeric = CBool(IsCharAlphaNumericA(Asc(sText)))

Exit Function
ErrorHandle:
MsgBox Err.Description & vbNewLine & "Unexpected error in Function dhIsCharAlphanumeric", , "Error"
End Function

Public Function StripChar(ByVal sString, ByVal sException1, ByVal sException2, ByVal sException3, ByVal sException4) As String
'Strips a string of leading and tailing chars that are not
'alphanumeric. The sExceptions may not be stripped.
'The length of sException must be 1 (one).

Dim sChar As String * 1

On Error GoTo ErrorHandle

Do
    If Len(sString) = 0 Then Exit Function
    sChar = Left$(sString, 1)
    If dhIsCharAlphanumeric(sChar) Then Exit Do 'If sChar is alphanumeric
    'If sChar is not alphanumeric
    If sChar <> sException1 And sChar <> sException2 And sChar <> sException3 And sChar <> sException4 Then
        'If different from the exceptions
        sString = Right$(sString, Len(sString) - 1)
    Else
        Exit Do
    End If
Loop
Do
    If Len(sString) = 0 Then Exit Function
    sChar = Right$(sString, 1)
    If dhIsCharAlphanumeric(sChar) Then Exit Do
    If sChar <> sException1 And sChar <> sException2 And sChar <> sException3 And sChar <> sException4 Then
        sString = Left$(sString, Len(sString) - 1)
    Else
        Exit Do
    End If
Loop

StripChar = sString
Exit Function
ErrorHandle:
MsgBox Err.Description & Chr(10) & "Unexpected error in Function StripChar", , "Error"
End Function

Public Function StripAsc0To32(ByVal sText As String) As String
'Strips a string of any leading or trailing character
'that are below ASCII 33.

Dim sChar As String * 1 'A one char string

On Error GoTo ErrorHandler

'First we strip any leading characters.
Do
    If Len(sText) = 0 Then Exit Function
    
    sChar = Left$(sText, 1)
    If Asc(sChar) < 33 Then 'If sChar is below ASCII 33
        sText = Right$(sText, Len(sText) - 1)
    Else
        Exit Do
    End If
Loop

'Next we strip any trailing characters.
Do
    If Len(sText) = 0 Then Exit Function
    
    sChar = Right$(sText, 1)
    If Asc(sChar) < 33 Then
        sText = Left$(sText, Len(sText) - 1)
    Else
        Exit Do
    End If
Loop

StripAsc0To32 = sText
Exit Function

ErrorHandler:
MsgBox Err.Description & Chr(10) & "Unexpected error in Function StripAsc0To32", , "Error"
bAbortCss = True
End Function

Public Function NextLine(sText, lPos) As Long
'Finds position of next line in a text.
'This is done by finding a linefeed character.
NextLine = InStr(lPos, sText, Chr(10))
End Function

Function ExtractCommand(ByVal lPos, ByVal lPos2, sText) As String
'Extracts a command from the ini file and trims any
'trailing non-alphanumeric characters (like e.g. space).

On Error GoTo ErrorHandle
ExtractCommand = Mid$(sText, lPos, lPos2 - lPos)
ExtractCommand = Trim(ExtractCommand)
ExtractCommand = StripChar(ExtractCommand, "#", ".", "#", "")

Exit Function
ErrorHandle:
MsgBox Err.Description & vbNewLine & "Unexpected error in Function ExtractCommand", , "Error"
End Function

Function ExtractComVal(ByVal lPos, ByVal lPos2, sText) As String
'Extracts an ini file command value

On Error GoTo ErrorHandle

ExtractComVal = Mid$(sText, lPos, lPos2 - lPos)
ExtractComVal = Trim(ExtractComVal)
'Strips non-alphanumeric characters except "#" "." and "/"
ExtractComVal = StripChar(ExtractComVal, "#", ".", "/", "")

Exit Function
ErrorHandle:
MsgBox Err.Description & vbNewLine & "Unexpected error in Function ExtractComVal", , "Error"
End Function

Public Function ReturnDir(sPath) As String
'Returns the path without filename

Dim bFound As Boolean
Dim lPos As Long     'Pointer
Dim lPos2 As Long    'Pointer

On Error GoTo ErrorHandler
If Len(sPath) = 0 Then Exit Function

If FileCheck(sPath) = False Then
    ReturnDir = sPath
    If InStr(1, ReturnDir, ".") = 0 Then Exit Function
End If

bFound = False

lPos = InStr(1, sPath, "\") 'Finds position of first "\" in string
If lPos > 0 Then
    Do
        lPos2 = lPos
        lPos = InStr(lPos + 1, sPath, "\")      'Finds next if any
        If lPos = 0 Or lPos = Len(sPath) Then   'If none found
            bFound = True
        End If
    Loop Until bFound
'   The path without filename
    ReturnDir = Left$(sPath, lPos2 - 1)
Else
'   If there is no "\" in the string it must be the root
    ReturnDir = Left$(sPath, 2)
End If


Exit Function
ErrorHandler:
MsgBox Err.Description & vbNewLine & "Unexpected error in function ReturnDir", vbCritical, "Error"
End Function

Public Function ValidPath(path) As Boolean
'Returns true if a path is valid.

'ValidPath = False

If Len(path) < 2 Then Exit Function

If InStr(1, path, ".") > 0 Then
    ValidPath = FileCheck(path)
Else
    ValidPath = DirCheck(path)
End If

End Function

Public Function DirCheck(sDirPath) As Boolean
'Returns true if a directory exists. The directory name +
'path is passed in the argument sDirPath from the calling
'procedure/function.

If Len(sDirPath) < 2 Then Exit Function
If Len(Dir(sDirPath, vbDirectory)) > 0 Then DirCheck = True

End Function
Public Function lOnOff(sCommandVal) As Long
'From a passed command value that is either "On" or "Off",
'the function returns 1 or 0. This is e.g. used to
'check or uncheck checkboxes like e.g. "Flip Board on/off"

Select Case Len(sCommandVal)
    Case 2                  '"On"
        lOnOff = 1
    Case 3                  '"Off"
        lOnOff = 0
    Case Else
        lOnOff = 0
End Select
End Function
Public Function sOnOff(intInteger) As String
'Returns a commandvalue "on" or "off" depending
'on the passed value. The passed value is an integer
'like that of the state of a checkbox, which can be
'1 for checked or 0 for unchecked.

Select Case intInteger
    Case 1
        sOnOff = "on"
    Case 0
        sOnOff = "off"
    Case Else
        sOnOff = "off"
End Select
End Function
Public Function sBoolOnOff(bBool As Boolean) As String
'Returns a commandvalue "on" or "off" depending
'on the passed boolean value.

If bBool Then
    sBoolOnOff = "on"
Else
    sBoolOnOff = "off"
End If

End Function

Public Function ConvertSubstring(ByVal sText, ByVal sFind, ByVal sReplace) As String
'Replaces all occurences of a substring.
'sText is the whole string.
'sFind is the substring to be replaced
'sReplace is the replacement

Dim iLenFind As Integer     'Length of substring to be replaced
Dim iLenReplace As Integer  'Length of replacement
Dim lPos As Long            'Pointer

iLenFind = Len(sFind)
iLenReplace = Len(sReplace)
lPos = 1

Do
    lPos = InStr(lPos, sText, sFind, vbTextCompare)
    If lPos > 0 Then    'If there's a match
        sText = Left$(sText, lPos - 1) & sReplace & Mid$(sText, lPos + iLenFind)
    End If
Loop Until lPos = 0

ConvertSubstring = sText
End Function
Public Function FindUnit(sText) As String
'Returns a CSS size unit from a string.

If InStr(1, sText, "pt") > 0 Then
    FindUnit = "pt"
    Exit Function
End If

If InStr(1, sText, "px") > 0 Then
    FindUnit = "px"
    Exit Function
End If

If InStr(1, sText, "em") > 0 Then
    FindUnit = "em"
    Exit Function
End If

If InStr(1, sText, "%") > 0 Then
    FindUnit = "%"
    Exit Function
End If

If InStr(1, sText, "pc") > 0 Then
    FindUnit = "pc"
    Exit Function
End If

If InStr(1, sText, "cm") > 0 Then
    FindUnit = "cm"
    Exit Function
End If

If InStr(1, sText, "mm") > 0 Then
    FindUnit = "mm"
    Exit Function
End If

If InStr(1, sText, "in") > 0 Then
    FindUnit = "in"
    Exit Function
End If

FindUnit = ""

End Function
Public Function CheckCssNameMatch(ByVal sName As String) As Boolean
Dim vName As Layout

On Error GoTo ErrorHandler

For Each vName In cLayouts
    If sName = vName.Key Then
        CheckCssNameMatch = True
        Set vName = Nothing
        Exit Function
    End If
Next

Set vName = Nothing
Exit Function
ErrorHandler:
Set vName = Nothing
MsgBox Err.Description & vbNewLine & _
"Error in function CheckCssNameMatch.", vbCritical, "Error"
End Function
Public Function UserInput(ByVal sPrompt As String, ByVal sDefault As String) As String

UserInput = InputBox(sPrompt, "Crosstable Characters", sDefault)
   

End Function
'**********************************************************************
'The following functions deal with the conversion of DOS paths to URLs.
'The user informs the program where his HTML files, piece images, board
'images etc. are stored on the hard disk.
'To be of any use in the Palview ini file this information must be
'transformed from DOS paths to relative URLs. If not we can't show the
'html page in the internal browser, but we must also assume that the
'hard disk structure is a mirror of the real server's directory structure.
'If we didn't offer this facility everybody would be forced to keep their
'image files etc. in a fixed directory like e.g. Palview/jpc.
'************************************************************************

Public Function MakeUrl(sHome, sLink) As String
'This function returns the URL of sLink relative to sHome given
'their DOS paths.
'This is used in the Palview ini file for URLs to piece images,
'board, conpanels, comment symbols and flags.

Dim bLinkIsFile As Boolean  'True if the link is to a file and not a directory.
Dim sFile As String         'File name (if any) in link path.
Dim sHomeFile As String     'File name (if any) in home path.
Dim sLinkDir As String      'The link's path without file name (if any)

On Error GoTo ErrorHandler

'If no home
If Len(sHome) < 2 Then Exit Function

'If no target
If Len(sLink) < 2 Then Exit Function

sLinkDir = sLink

If FileCheck(sLink) Then bLinkIsFile = True       'Is it a file name?

If bLinkIsFile Then         'If the link is a file name
    sFile = Dir(sLink)      'Returns file name only
'   Returns path without file name and leading backslash.
    sLinkDir = Left(sLink, Len(sLink) - Len(sFile) - 1)
End If

'If the path to home contains a file name,
'the file name + leading backslash is removed
If FileCheck(sHome) Then
    sHomeFile = Dir(sHome)
    sHome = Left(sHome, Len(sHome) - Len(sHomeFile) - 1)
End If

'If the paths of Home and Link are identical
If sHome = sLinkDir Then
    If bLinkIsFile Then
        MakeUrl = sFile 'The URL is just the file name.
    Else
        MakeUrl = ""    'Nothing
    End If
    Exit Function
End If

'If the link is in a subdirectory to the web page,
'the path of the page (sHome) is a substring to the link's path.
If InStr(1, sLinkDir, sHome) > 0 Then
'   Returns sub structure
    If bLinkIsFile Then
        MakeUrl = Right$(sLink, Len(sLink) - Len(sHome) - 1)
    Else
        MakeUrl = Right$(sLinkDir, Len(sLinkDir) - Len(sHome) - 1)
    End If
'   Converts "\" to "/"
    MakeUrl = ConvertSubstring(MakeUrl, "\", "/")
    Exit Function
End If

'If the link isn't to a subdirectory of the web page,
'things are a bit more complicated. Then we have to
'determine how much the paths share, and where they meet.
'This work is done in the function ReturnRelUrl.
If bLinkIsFile = False Then
    MakeUrl = ReturnRelUrl(sHome, sLinkDir)
Else
    If InStr(1, sHome, sLinkDir) Then
        MakeUrl = ReturnRelUrl(sHome, sLinkDir)
        MakeUrl = MakeUrl & sFile
    Else
        MakeUrl = ReturnRelUrl(sHome, sLink)
    End If
End If

Exit Function
ErrorHandler:
MsgBox Err.Description & vbNewLine & "Error in function MakeUrl.", vbCritical, "Error"
End Function

Function ReturnRelUrl(ByVal sHome, ByVal sLink) As String
'Compares two paths and returns the URL of sLink relative to sHome.
'If for instance sHome is C:\Chess\MyWebSite\2001\HTML
'and sLink is C:\Chess\MyWebSite\Pictures\Jpegs\kasparov.jpg
'the returned string will be "../../Pictures/Jpegs/kasparov.jpg"

Dim bEqual As Boolean       'True when truncated paths are identical.
Dim iDirNo As Integer       'Counts number of directories up to where the paths meet.
Dim iPos As Integer         'Pointer in string
Dim iPos2 As Integer        'Second pointer
Dim iCount As Integer       'Counter
Dim sNewHome As String      'String variable
Dim sNewLink As String      'String variable
Dim sBeforeLink As String   'String variable for the leading "../"

On Error GoTo ErrorHandler

If StrComp(Left$(sHome, 1), Left$(sLink, 1), vbTextCompare) <> 0 Then
    If Right$(sLink, 3) = "pgn" Then
        MsgBox "The pgnfile is on a different drive than the webpage. " & _
        "So unless you (during pgn selection) allows PalMate to copy the " & _
        "pgnfile to the Html target folder, you cannot put a pgn-link on the " & _
        "page.", vbInformation, "Cannot Link To Pgn"
        Exit Function
    Else
        MsgBox "Because " & sLink & " and " & sHome & " are on different drives PalMate cannot " & _
        "create a relative URL (link). To avoid any problems you should keep all files used in " & _
        "the project on the same drive and make a mirror of your website." & _
        "Please move the file and start again.", vbInformation, "Cannot make URL"
        Exit Function
    End If
End If

sNewHome = sHome
sNewLink = sLink
iDirNo = 0
bEqual = False

'Now we loop through sHome and sLink until their paths meet.
'The two strings are truncated until identical (which
'could ultimately be the root, e.g. "C:\").
'Each directory in sHome that is not shared with sLink is counted.
Do  'Outer loop
    iPos = 1
    
    Do  'Inner loop. Loops until no more backslash in current sNewHome.
        iPos = iPos + 1
        If Mid$(sNewHome, iPos, 1) = "\" Then
'           Stores position of backslash
            iPos2 = iPos
        End If
'   The loop stops when remaining text from pointer
'   to end of string has no more backslashes.
    Loop Until InStr(iPos, sNewHome, "\") = 0

'   The two strings are truncated to one character before last backslash.
    sNewHome = Left$(sNewHome, iPos2 - 1)
    sNewLink = Left$(sNewLink, iPos2 - 1)
'   Directory count
    iDirNo = iDirNo + 1
'   If strings are identical the paths meet
'   and bEqual is set to true to stop the loop
    If StrComp(sNewHome, sNewLink, vbTextCompare) = 0 Then
        bEqual = True
    End If
Loop Until bEqual = True

'Unless the home is a subdirectory to the link,
'the relative URL is the text "below" the meeting point - or in other
'words the text to the right of the first shared directory.
'If "home" is a subdirectory to the link the same applies, but
'then it is the text "below" in the sHome string.
If iDirNo > 0 Then
'   If sHome is a subdirectory to sLink
    If InStr(1, sHome, sLink) Then
        sNewLink = Empty
    Else
        sNewLink = Right$(sLink, Len(sLink) - iPos2)
    End If
Else
    sNewLink = Empty
End If

'Backslashes are now converted to "/"
sNewLink = ConvertSubstring(sNewLink, "\", "/")
sBeforeLink = ""

'Now the code for directories up to the meeting point is written.
'Before this function was called, we checked if paths were identical,
'or if sLink was a subdirectory to sHome.
For iCount = 1 To iDirNo
    sBeforeLink = sBeforeLink & "../"
Next

sNewLink = sBeforeLink & sNewLink
ReturnRelUrl = sNewLink

Exit Function
ErrorHandler:
MsgBox Err.Description & vbNewLine & "Error in function ReturnRelUrl", vbCritical, "Error"
End Function

Public Function MakeHtmlName(sPgnPath As String) As String
Dim sText As String
Dim sNo As String

On Error GoTo ErrorHandler

sText = Dir(sPgnPath)

sText = Left$(sText, Len(sText) - 4)
MakeHtmlName = sText & ".htm"

Exit Function
ErrorHandler:
MsgBox Err.Description & vbNewLine & _
"Error in function MakeHtmlName.", vbCritical, "Error"
bAbort = True
End Function


