VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "Layouts"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"Layout"
Attribute VB_Ext_KEY = "Member0" ,"Layout"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

'local variable to hold collection
Private mCol As Collection
Public Sub RestoreLayout()
Attribute RestoreLayout.VB_Description = "Restores the original ini and css files in case the user doesn't want to save changes to the style."
'This procedure restores the original ini file
'in case the user doesn't want to save changes to the style.
Dim sTarget As String
Dim sBackup As String

On Error GoTo ErrorHandler

sTarget = App.path & "\resource\" & cLayouts(lAL).Key & ".ini"
sBackup = App.path & "\resource\" & cLayouts(lAL).Key & ".bni"

'If backup exists restore original ini file
If FileCheck(sBackup) Then
    SetAttr sTarget, vbNormal
    SetAttr sBackup, vbNormal
    Kill sTarget
    Name sBackup As sTarget
    SetAttr sTarget, vbReadOnly
Else
    MsgBox "Ini file backup could not be found. Unable to restore ini file.", vbCritical, "Unable To Restore Ini File"
End If

Exit Sub

ErrorHandler:
MsgBox Err.Description & vbNewLine & _
"Error restoring the original style ini file.", vbCritical, "Error"
End Sub

Public Sub SaveLayout()
Attribute SaveLayout.VB_Description = "Saves a layout by writing an inifile, a stylesheet and changes to the layouts.lst. Ini and Css files are named after the layout."
'This procedure saves a layout. That means writing
'new ini and css files plus updated information to
'the layouts.lst file.

Dim lCount As Long
Dim sFile As String
Dim sFileBak As String  'Filename of ini backup file
Dim sHtmlType As String
Dim cStyle As CssBlock

On Error GoTo ErrorHandler


With cLayouts(lAL)
    sHtmlType = .Ini2.HtmlType
'   Page stylesheet
    If .StyleSheet.Changed Then
        .StyleSheet.WriteNewCss
        sFile = App.path & "\Resource\" & .Key & ".css"
'       The current stylesheet is saved
        Call Savefile(sFile, .StyleSheet.NewCss, True, True)
        .StyleSheet.NewCss = Empty
'       The original is replaced by the current
        Call CopyFile(sFile, cWebPages(lAW).PathWebCss & "\" & .Key & ".css")
    End If
    
'   If it is a crosstable page
    If sHtmlType = "batch" Then
        .CrossStyle.WriteNewCss
        sFile = App.path & "\CrossCss\" & .CrossStylesheetName
        Call Savefile(sFile, .CrossStyle.NewCss, True, True)
        .CrossStyle.NewCss = Empty
        Call CopyFile(sFile, cWebPages(lAW).PathWebCss & "\" & .CrossStylesheetName)
    End If

'   If it is an iframe or multiple iframes page that uses an iframe stylesheet.
    If sHtmlType = "iframe" Or sHtmlType = "muliframe" Or sHtmlType = "magviewer" Then
        If Not (.Iframe Is Nothing) Then
            .Iframe.WriteNewCss
            sFile = App.path & "\IframCss\" & .IframeCssName
            Call Savefile(sFile, .Iframe.NewCss, True, True)
            .Iframe.NewCss = Empty
            Call CopyFile(sFile, cWebPages(lAW).PathWebCss & "\" & .IframeCssName)
        End If
    End If
    
    .WriteNewIni
    sFile = App.path & "\Resource\" & .Key & ".ini"
    Call Savefile(sFile, .NewIni, True, True)
    
'   This may be a brand new style made on the basis of another, and
'   in that case a backup of the ini file is made.
    sFileBak = Left$(sFile, Len(sFile) - 4) & ".bni"
    If FileCheck(sFileBak) = False Then
        FileCopy sFile, sFileBak
    End If
    
    .Saved = True
    
    .WriteNewLst (Me(lAL).Key)
    
    .Changed = False
    .Ini1.Changed = False
    .Ini2.Changed = False
    .Ini3.Changed = False
    .StyleSheet.Changed = False
    For Each cStyle In .StyleSheet
        cStyle.Changed = False
    Next
End With

Set cStyle = Nothing

Exit Sub
ErrorHandler:
MsgBox Err.Description & vbNewLine & "An error occured when saving " & _
"the layout. Procedure SaveLayout in class collection Layouts.", vbCritical, "Error"
End Sub

Public Function Add(Key As String, Optional sKey As String, Optional Before As Variant, Optional After As Variant) As Layout
    'create a new object
    Dim objNewMember As Layout
    Set objNewMember = New Layout


    'set the properties passed into the method
    objNewMember.Key = Key
    'objNewMember.Key = Key
    'objNewMember.Key = Key




    If Len(sKey) = 0 Then
        mCol.Add objNewMember, Key, Before, After
    Else
        mCol.Add objNewMember, sKey, Before, After
    End If


    'return the object created
    Set Add = objNewMember
    Set objNewMember = Nothing

    cStyles(Key).InUse = True
    
End Function

Public Property Get Item(vntIndexKey As Variant) As Layout
Attribute Item.VB_UserMemId = 0
    'used when referencing an element in the collection
    'vntIndexKey contains either the Index or Key to the collection,
    'this is why it is declared as a Variant
    'Syntax: Set foo = x.Item(xyz) or Set foo = x.Item(5)
  Set Item = mCol(vntIndexKey)
End Property



Public Property Get Count() As Long
    'used when retrieving the number of elements in the
    'collection. Syntax: Debug.Print x.Count
    Count = mCol.Count
End Property


Public Sub Remove(vntIndexKey As Variant)
    'used when removing an element from the collection
    'vntIndexKey contains either the Index or Key, which is why
    'it is declared as a Variant
    'Syntax: x.Remove(xyz)


    mCol.Remove vntIndexKey
End Sub


Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    'this property allows you to enumerate
    'this collection with the For...Each syntax
    Set NewEnum = mCol.[_NewEnum]
End Property


Private Sub Class_Initialize()
    'creates the collection when this class is created
    Set mCol = New Collection
End Sub


Private Sub Class_Terminate()
    'destroys collection when this class is terminated
    Set mCol = Nothing
End Sub

