VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "Magazine"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Description = "Class for a magazine"
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"No"
Option Explicit

'local variable(s) to hold property value(s)
Private mvarKey As String 'local copy
Private mvarOrigText As String 'local copy
Private mvarHtmSaved As Boolean 'local copy
Private mvarHtmChanged As Boolean 'local copy
Private mvarOrigChanged As Boolean 'local copy
Private mvarOrigBackup As String 'local copy
Private mvarHtmlTemplateName As String 'local copy
Private mvarHtmlTemplate As String 'local copy
Public Property Let HtmlTemplate(ByVal vData As String)
Attribute HtmlTemplate.VB_Description = "Local DOS path to the original HTML-file used for a magazine. This is the file into which we insert our Palview comments and commands to make a magazine."
    mvarHtmlTemplate = vData
End Property
Public Property Get HtmlTemplate() As String
    HtmlTemplate = mvarHtmlTemplate
End Property
Public Property Let HtmlTemplateName(ByVal vData As String)
Attribute HtmlTemplateName.VB_Description = "Name of the html template file (without path) that is used to create a magazine."
    mvarHtmlTemplateName = vData
End Property
Public Property Get HtmlTemplateName() As String
    HtmlTemplateName = mvarHtmlTemplateName
End Property
Public Property Let OrigBackup(ByVal vData As String)
Attribute OrigBackup.VB_Description = "When an htm template is opened, PalMate makes a backup of the original template file and renames it, so it can be restored later. This variable contains the path and filename of the backupfile."
    mvarOrigBackup = vData
End Property
Public Property Get OrigBackup() As String
    OrigBackup = mvarOrigBackup
End Property
Public Property Let OrigChanged(ByVal vData As Boolean)
Attribute OrigChanged.VB_Description = "Is set to TRUE once the template is modyfied and changed."
    mvarOrigChanged = vData
End Property
Public Property Get OrigChanged() As Boolean
    OrigChanged = mvarOrigChanged
End Property
Public Property Let HtmChanged(ByVal vData As Boolean)
Attribute HtmChanged.VB_Description = "Tirns toTRUE when the RTF-text window's change event is triggered, and turns to FALSE when the HtmSaved is set to true. When set to TRUE it will  change  the HtmSaved to FALSE."
    mvarHtmChanged = vData
    If mvarHtmChanged Then
        HtmSaved = False
        cWebPages(lAW).Changed = True
    End If
End Property
Public Property Get HtmChanged() As Boolean
    HtmChanged = mvarHtmChanged
End Property
Public Property Let HtmSaved(ByVal vData As Boolean)
Attribute HtmSaved.VB_Description = "True if the htm template has been saved."
    mvarHtmSaved = vData
    If mvarHtmSaved = True Then
        HtmChanged = False
    End If
End Property
Public Property Get HtmSaved() As Boolean
    HtmSaved = mvarHtmSaved
End Property
Public Property Let OrigText(ByVal vData As String)
Attribute OrigText.VB_Description = "The strin variable that will hold the text of the html template file."
    mvarOrigText = vData
End Property
Public Property Get OrigText() As String
    OrigText = mvarOrigText
End Property
Public Sub MakeNewMag()
Attribute MakeNewMag.VB_Description = "Takes the necessary steps to create a new magazine."
'P4 addition.
'This procedure takes the necessary steps to create a new magazine.

Dim sPath As String
Dim sText As String
Dim sHtmPrefix As String
Dim sPgnPrefix As String
Dim lPeriodPos As Long

On Error GoTo ErrorHandle

sPgnPrefix = cWebPages(lAW).PgnFiles(1).Key
sPgnPrefix = Left$(sPgnPrefix, Len(sPgnPrefix) - 4)

Do
    Call OpenFileDialog("Select HTML Template File", "htm", sPath, sPathPgn, "")
    'If no file selected
    If Len(sPath) = 0 Then
        MsgBox "No Html file selected. You'll not be able to build a magazine", , "No file selected"
        bAbort = True
        Exit Sub
    End If
    sHtmPrefix = Dir(sPath)
    lPeriodPos = InStr(1, sHtmPrefix, ".")
    sHtmPrefix = Left$(sHtmPrefix, 6)
    'We check if the template and the pgn have identical names.
    If sHtmPrefix = sPgnPrefix Then
        MsgBox "The magazine's HTML template must have a different name than the pgn file.", vbInformation, "Identical Names Problem"
    Else
        Exit Do
    End If
Loop


With Me
    .HtmlTemplate = sPath
    .HtmlTemplateName = Dir(sPath)
    Call LoadTextFile(.HtmlTemplate, sText)
    .OrigBackup = App.path & "\Backup\" & .HtmlTemplateName
    FileCopy .HtmlTemplate, .OrigBackup
End With

OrigText = sText
sText = Empty

Exit Sub
bAbort = True
ErrorHandle:
MsgBox Err.Description & vbNewLine & "Unexpected error in procedure MakeNewMag.", vbCritical, "Error"

End Sub
Public Property Let Key(ByVal vData As String)
    mvarKey = vData
End Property
Public Property Get Key() As String
    Key = mvarKey
End Property
Private Sub Class_Terminate()

Dim fForm As Form

On Error Resume Next

If bpubMakingPage Or cLayouts(lAL).Ini2.HtmlType <> "magazine" Then GoTo ByBy

'Unloads the editor form
For Each fForm In Forms
    If fForm.Caption = HtmlTemplateName Then
        fForm.Form_Unload (1)
        Exit For
    End If
Next

ByBy:
Set fForm = Nothing

End Sub

Public Sub RestoreOriginal()
    
Dim sTemp As String

On Error GoTo ErrorHandle

    FileCopy Me.OrigBackup, Me.HtmlTemplate
    Call LoadTextFile(Me.HtmlTemplate, sTemp)
    Me.OrigText = sTemp
Exit Sub
ErrorHandle:
MsgBox Err.Description & vbNewLine & "Procedure RestoreOriginal, class Magazine", vbCritical, "Error"
End Sub
