Attribute VB_Name = "Module1"
Option Explicit
Option Compare Text

Public Const LF_FACESIZE = 32
Public Const LF_FULLFACESIZE = 64

Type LOGFONT
        lfHeight As Long
        lfWidth As Long
        lfEscapement As Long
        lfOrientation As Long
        lfWeight As Long
        lfItalic As Byte
        lfUnderline As Byte
        lfStrikeOut As Byte
        lfCharSet As Byte
        lfOutPrecision As Byte
        lfClipPrecision As Byte
        lfQuality As Byte
        lfPitchAndFamily As Byte
        lfFaceName(LF_FACESIZE) As Byte
End Type

Type NEWTEXTMETRIC
        tmHeight As Long
        tmAscent As Long
        tmDescent As Long
        tmInternalLeading As Long
        tmExternalLeading As Long
        tmAveCharWidth As Long
        tmMaxCharWidth As Long
        tmWeight As Long
        tmOverhang As Long
        tmDigitizedAspectX As Long
        tmDigitizedAspectY As Long
        tmFirstChar As Byte
        tmLastChar As Byte
        tmDefaultChar As Byte
        tmBreakChar As Byte
        tmItalic As Byte
        tmUnderlined As Byte
        tmStruckOut As Byte
        tmPitchAndFamily As Byte
        tmCharSet As Byte
        ntmFlags As Long
        ntmSizeEM As Long
        ntmCellHeight As Long
        ntmAveWidth As Long
End Type

' ntmFlags field flags
Public Const NTM_REGULAR = &H40&
Public Const NTM_BOLD = &H20&
Public Const NTM_ITALIC = &H1&

'  tmPitchAndFamily flags
Public Const TMPF_FIXED_PITCH = &H1

Public Const TMPF_VECTOR = &H2
Public Const TMPF_DEVICE = &H8
Public Const TMPF_TRUETYPE = &H4

Public Const ELF_VERSION = 0
Public Const ELF_CULTURE_LATIN = 0

'  EnumFonts Masks
Public Const RASTER_FONTTYPE = &H1
Public Const DEVICE_FONTTYPE = &H2
Public Const TRUETYPE_FONTTYPE = &H4

Declare Function EnumFontFamilies Lib "gdi32" Alias _
     "EnumFontFamiliesA" _
     (ByVal hdc As Long, ByVal lpszFamily As String, _
     ByVal lpEnumFontFamProc As Long, lParam As Any) As Long

Declare Function GetDC Lib "User32" (ByVal hwnd As Long) As Long
Declare Function ReleaseDC Lib "User32" (ByVal hwnd As Long, _
     ByVal hdc As Long) As Long

Public Declare Function WaitForSingleObject Lib "kernel32" _
   (ByVal hHandle As Long, ByVal dwMilliseconds As Long) As Long

Public Declare Function CloseHandle Lib "kernel32" _
   (ByVal hObject As Long) As Long
   
Public Declare Function OpenProcess Lib "kernel32" _
   (ByVal dwDesiredAccess As Long, ByVal bInheritHandle As Long, _
    ByVal dwProcessId As Long) As Long

'The following constants are for use with calling and waiting
'for Palview to execute. "Infinite" should maybe be milliseconds
'to catch if things go wrong.
Public Const Infinite = -1&
Public Const Synchronize = &H100000

'End API functions

Public cLayouts As Layouts
Public cPgnFiles As PgnFiles
Public cStyleSheet As StyleSheet
Public cWebPages As WebPages
Public cStyles As Styles

Public colLayoutNames As Collection
Public colDescriptions As Collection
Public colHtmlTypes As Collection           'P4 addition
Public colPathPieces As Collection
Public colPathBoard As Collection
Public colPathConpanel As Collection
Public colPathSymbols As Collection
Public colPathBGImage As Collection
Public colPathBGCrossImage As Collection    'Crosstable css backgrounds
Public colPathBGIframeImage As Collection   'Iframe stylesheet background images
Public colPathCrossSource As Collection     'Crosstable source css path
Public colPathIframeCssSource As Collection 'Iframe source css path
Public colPathHtml As Collection
Public colPathCss As Collection
Public colPathFenImg As Collection          'P4 addition
Public colPathFlags As Collection
Public colPathRedirect As Collection        'DOS paths to html files to redirect to.
Public colCrossStyles As Collection         'Collection of available crosstable stylesheets.
Public colIframeStyles As Collection        'Collection of available Iframe stylesheets.
Public colPathHelpImg As Collection         'Help image paths
Public colPathHelpUrl As Collection         'Paths to help files.
Public colPathIndexCss As Collection        'Paths to Index Css sources.
Public colPathMagazineCss As Collection     'Paths to magazine css sources.
Public colPathMailToImg As Collection       'Paths to mail-to images.


'Long variables
Public lAL As Long                  'Index number of active layout.
Public lAP As Long                  'Index number of active Pgn.
Public lAW As Long                  'Index number of active WebPage project.
Public lAS As Long                  'Index number of active selector in stylesheet.
Public lAC As Long                  'Index number of active selector in crosstable stylesheet.
Public lAI As Long                  'Index number of active selector in Iframe stylesheet.
Public lASty As Long                'Index number of active style in Styles. P4 addition.
Public lpubBodyIndex As Long        'The BODY selector's number in the active Stylesheet.
Public lpubBodyCrossIndex As Long   'The BODY selector's number in the crosstable stylesheet.
Public lpubBodyIframeIndex As Long  'The BODY selector's number in the I-frame stylesheet.
Public lpubPicHeight As Long        'Used for image-link insertion in magazine
Public lpubPicWidth As Long

'Strings
Public sPathPalview As String       'Path to Palview.
Public sPathPgn As String           'Last used path to pgn files.
Public spubPathPalIni As String
Public spubPathTempPgn As String
Public sLocalUrl As String          'URL for built in browser
Public sDelim As String * 1         'Directory delimiter. "/" if help via the Internet, "\" if local help.
Public sPathPalManual As String     'Path to Palview Manual (HTML Files). Can be either local or on the Internet.
Public sAction As String            'Used a lot to determine what the current action is.
Public sAction2 As String           'Used as a secondary measure to check the current action. P4 addition.
Public sFilesToRemember As String   'Files the user didn't want to overwrite during startup.
'P4 additions
Public sInput1 As String            'Parameters passed to the frmInput
Public sInput2 As String
Public sInput3 As String

'Flags (Boolean)
Public bpubPreview As Boolean       'True if a Palview page is being previewed.
Public bpubBrowserLoaded As Boolean 'True if the browser is loaded (may not be visible).
Public bpubHelpMode As Boolean      'True if helppage is being showed.
Public bCssBarVisible As Boolean    'True if the CssBar is visible
Public bpubCssBarLoaded As Boolean  'True if the cssbar is loaded (may not be visible).
Public bUnloadCssBar As Boolean     'If false the CssBar will hide, not unload
Public bpubShowCssBar As Boolean    'True if the CssBar is to be shown. Value is saved.
Public bAbort As Boolean
Public bAbortCss As Boolean
Public bpubHlpOnline As Boolean         'True if the Palview manual is to be accessed via the Internet.
Public bpubProgramEnd As Boolean        'True if the Program is closing
Public bpubMakingPage As Boolean        'True if a page is being created and the selection procedure is going on.
'P4 addition
Public bpubMakingViewer As Boolean      'True if a viewer's classes is being set up
Public bpubUnloadMag As Boolean         'True if the viewer has already been unloaded.
Public bpubUnloadViewer As Boolean      'True if the viewer form isn't yet unloaded.
Public bpubEdit As Boolean              'True if the magazine editor is the active form
Public bpubPgnEdit As Boolean           'True if the pgn editor is the active form
'End P4 addition
Public bpubSaveProject As Boolean       'True if project is being saved (not temp view)
Public bHtmPreviewVisible As Boolean    'Show/don't show
Public bBrowserVisible As Boolean       'Show/don't show
Public bUnloadHtmPreview As Boolean
Public bfrmCssEditorOpen As Boolean     'Is frmCssEditor loaded or not.
Public bpubPMHelpVisible As Boolean     'True if PalMate help index is loaded.
Public bpubPWHelpVisible As Boolean     'True if Palview help index is loaded.

'Variables to save ToolBar and Webbrowser position on form
Public CssBarPositionX As Integer
Public CssBarPositionY As Integer
Public CssBarHeight As Integer
Public CssBarWidth As Integer
Public iHtmPreviewPosX As Integer   'HtmBrowser window's X-position
Public iHtmPreviewPosY As Integer   'HtmBrowser window's Y-position
Public iHtmPreviewWidth As Integer  'HtmBrowser width
Public iHtmPreviewHeight As Integer 'Htmbrowser height
Public iHelpPosX As Integer         'Browser window's X-pos in help mode
Public iHelpPosY As Integer         'Browser window's Y-pos in help mode
Public iHelpWidth As Integer        'Browser window's width in help mode
Public iHelpHeight As Integer       'Browser window's height in help mode

'Form variables
Public fHelpForm As frmHelp
Public fLayoutForm As frmPgnText
Public fHtmForm As frmHtmPreview
Public frmHtml As frmHtmText
Public fPgnEdit As frmPgnEdit
Public fMainForm As frmMain
Function EnumFontFamProc(lpNLF As LOGFONT, lpNTM As NEWTEXTMETRIC, _
     ByVal FontType As Long, lParam As ComboBox) As Long
Dim FaceName As String
Dim FullName As String
    FaceName = StrConv(lpNLF.lfFaceName, vbUnicode)
    lParam.AddItem Left$(FaceName, InStr(FaceName, vbNullChar) - 1)
    EnumFontFamProc = 1
End Function
Sub FillListWithFonts(CBO As ComboBox)
'Fills a combobox with the system's fonts.

Dim hdc As Long
    CBO.Clear
    hdc = GetDC(CBO.hwnd)
    EnumFontFamilies hdc, vbNullString, AddressOf EnumFontFamProc, CBO
    ReleaseDC CBO.hwnd, hdc
End Sub

Sub Main()
'This procedure is run when the program starts

Dim bFirstTime As Boolean
Dim sPath As String

On Error GoTo ErrorHandler

If InStr(1, App.path, Chr(32)) Then
    MsgBox "You have installed PalMate to a folder where there is a " & _
    "space in the path." & vbNewLine & App.path & vbNewLine & _
    "This means that Palview cannot locate the ini files written by " & _
    "PalMate. Please read the documentation about installing PalMate and " & _
    "then reinstall the program. The bad folder is probably suggested as default " & _
    "by Windows, when you run Setup, and then you must browse for another location, " & _
    "where there is no space in the path." & vbNewLine & _
    "Thank you.", vbCritical, "Please Reinstall"
    
    End
End If

sPath = App.path & "\Resource\palmate.cfg"
bFirstTime = False

If FileCheck(sPath) = False Then
'   If the configuration file doesn't exist, it is
'   probably the first time PalMate is executed.
    bFirstTime = True
Else
    Call ReadCfg(sPath)     'Read config file with saved settings.
End If

FillColorNamesArray         'Fills an array with all color names
Set fMainForm = New frmMain 'Initialise a copy of the main form
fMainForm.Show              'Shows a copy of the Main form

'If it is the first time PalMate is executed
If bFirstTime Then
    MsgBox "Welcome to PalMate. You will now be asked for the location of the Palview " & _
    "program. When that has been taken care of you can create a new webpage by " & _
    "selecting ""File - New Webpage"". You will also have to select a style. Beware " & _
    "that you'll need to check and probably change paths to board image, piece images etc. according to your setup.", , "Welcome to PalMate"
    Call OpenFileDialog("Show path to Palview4.exe", "EXE", sPathPalview, App.path, "")
    
    If FileCheck(sPathPalview) = False Then
        MsgBox "PalMate must know the path to Palview.", vbCritical, "Mandatory"
        fMainForm.mnuFileNewWebPage.Enabled = False
    Else
        fMainForm.mnuFileNewWebPage.Enabled = True
        bCssBarVisible = True
        CssBarPositionX = 9255
        CssBarPositionY = 1935
        CssBarHeight = 1800
        CssBarWidth = 4335
        bHtmPreviewVisible = False
        iHtmPreviewPosX = 60
        iHtmPreviewPosY = 60
        iHtmPreviewWidth = 15480
        iHtmPreviewHeight = 11220
        iHelpPosX = 3030
        iHelpPosY = 1590
        iHelpWidth = 11715
        iHelpHeight = 6720
    End If
End If

Set cStyles = New Styles
cStyles.InitStyles


Exit Sub
ErrorHandler:
MsgBox Err.Description & vbNewLine & _
"Error initialising PalMate", vbCritical, "Error"
End Sub

Sub ReadCfg(sPath As String)
'Reads the program's configuration file.
'This contains information about the path
'to the Palview console program and the last
'used path to pgn files.

Dim sCfgTxt As String
Dim sSubString As String
Dim sCommand As String
Dim sComvalue As String
Dim lPos1 As Long
Dim lPos2 As Long
Dim lPos3 As Long

On Error GoTo ErrorHandler

Call LoadTextFile(sPath, sCfgTxt)

lPos1 = 1

Do
    lPos2 = NextLine(sCfgTxt, lPos1)
    If lPos2 = 0 Then Exit Do
    sSubString = Mid$(sCfgTxt, lPos1, lPos2 - lPos1)
    lPos3 = InStr(lPos1, sCfgTxt, "=")
    If lPos3 = 0 Or lPos3 > lPos2 Then GoTo Proceed
    sCommand = ExtractCommand(lPos1, lPos3, sCfgTxt)
    sComvalue = ExtractComVal(lPos3 + 1, lPos2, sCfgTxt)
    Call SetCfgVariables(sCommand, sComvalue)
Proceed:
    lPos1 = lPos2 + 1
    If lPos1 >= Len(sCfgTxt) Then Exit Do
Loop

Exit Sub
ErrorHandler:
MsgBox Err.Description & vbNewLine & "Unexpected error in procedure ReadCfg."
End Sub
Sub SetCfgVariables(sCommand As String, sComvalue As String)
'This procedure is called by ReadCfg every time
'a command and its value has been extracted from
'the programs Cfg-file.
'The procedure sets the variables with the values saved.

Dim sPath As String

On Error GoTo ErrorHandler

Select Case sCommand
    Case "sPathPalview"
        If Len(sComvalue) < 3 Then
            MsgBox "Palview needs to know the path to the Palview console program " & _
            """Palview2.exe""", , "Missing Path"
            Do
                Call OpenFileDialog("Show path to Palview4.exe", "EXE", sPath, App.path, "")
            Loop Until Len(sPath) > 0
            sComvalue = sPath
        End If
        sPathPalview = sComvalue
        
    Case "sPathPalManual"
            If ValidPath(sComvalue) Then
                sPathPalManual = sComvalue
                bpubHlpOnline = False
                sDelim = "\"
                If Right$(sPathPalManual, 1) <> "\" Then
                    sPathPalManual = sPathPalManual & "\"
                End If
            Else
                sPathPalManual = "http://www.enpassant.dk/chess/palview/manual/"
                bpubHlpOnline = True
                sDelim = "/"
            End If
    
    Case "sPathPgn"
        If Len(sComvalue) < 3 Or DirCheck(sComvalue) = False Then
            sPathPgn = App.path
        Else
            sPathPgn = sComvalue
        End If

    Case "bCssBarVisible"
        Select Case sComvalue
            Case "False"
                bCssBarVisible = False
            Case Else
                bCssBarVisible = True
        End Select

    Case "CssBarPositionX"
        If Val(sComvalue) = 0 Then
            CssBarPositionX = 3500
        Else
            CssBarPositionX = Val(sComvalue)
        End If
        
    Case "CssBarPositionY"
        If Val(sComvalue) = 0 Then
            CssBarPositionY = 2000
        Else
            CssBarPositionY = Val(sComvalue)
        End If

    Case "CssBarWidth"
        If Val(sComvalue) > 0 Then
            CssBarWidth = Val(sComvalue)
        End If

    Case "CssBarHeight"
        If Val(sComvalue) > 0 Then
            CssBarHeight = Val(sComvalue)
        End If

    Case "bHtmPreviewVisible"
        Select Case sComvalue
            Case "False"
                bHtmPreviewVisible = False
            Case Else
                bHtmPreviewVisible = True
        End Select

    Case "iHtmPreviewPosX"
        If Val(sComvalue) = 0 Then
            iHtmPreviewPosX = 1500
        Else
            iHtmPreviewPosX = Val(sComvalue)
        End If

    Case "iHtmPreviewWidth"
        If Val(sComvalue) > 0 Then
            iHtmPreviewWidth = Val(sComvalue)
        End If

    Case "iHtmPreviewHeight"
        If Val(sComvalue) > 0 Then
            iHtmPreviewHeight = Val(sComvalue)
        End If

    Case "iHtmPreviewPosY"
        If Val(sComvalue) = 0 Then
            iHtmPreviewPosY = 3500
        Else
            iHtmPreviewPosY = Val(sComvalue)
        End If

    Case "iHelpPosX"
        If Val(sComvalue) = 0 Then
            iHelpPosX = 1500
        Else
            iHelpPosX = Val(sComvalue)
        End If

    Case "iHelpPosY"
        If Val(sComvalue) = 0 Then
            iHelpPosY = 3500
        Else
            iHelpPosY = Val(sComvalue)
        End If

    Case "iHelpHeight"
        If Val(sComvalue) > 0 Then
            iHelpHeight = Val(sComvalue)
        End If

    Case "iHelpWidth"
        If Val(sComvalue) > 0 Then
            iHelpWidth = Val(sComvalue)
        End If

End Select

Exit Sub
ErrorHandler:
MsgBox Err.Description & vbNewLine & "Error in procedure SetCfgVariables. " & _
"One or more of the saved settings, like e.g. paths, may not be restored.", vbCritical, "Error"
End Sub
Sub WriteCfg()
'Writes or overwrites the program's own configuration file.

Dim sCfg As String
Dim sPath As String

On Error GoTo ErrorHandler

sCfg = "%" & vbNewLine & "sPathPalview=" & sPathPalview & vbNewLine & _
"sPathPgn=" & sPathPgn & vbNewLine & _
"sPathPalManual=" & sPathPalManual & vbNewLine & _
"bCssBarVisible=" & bpubShowCssBar & vbNewLine & _
"CssBarPositionX=" & CssBarPositionX & vbNewLine & _
"CssBarPositionY=" & CssBarPositionY & vbNewLine & _
"CssBarHeight=" & CssBarHeight & vbNewLine & _
"CssBarWidth=" & CssBarWidth & vbNewLine & _
"bHtmPreviewVisible=" & bHtmPreviewVisible & vbNewLine & _
"iHtmPreviewPosX=" & iHtmPreviewPosX & vbNewLine & _
"iHtmPreviewPosY=" & iHtmPreviewPosY & vbNewLine & _
"iHtmPreviewWidth=" & iHtmPreviewWidth & vbNewLine & _
"iHtmPreviewHeight=" & iHtmPreviewHeight & vbNewLine & _
"iHelpPosX=" & iHelpPosX & vbNewLine & _
"iHelpPosY=" & iHelpPosY & vbNewLine & _
"iHelpWidth=" & iHelpWidth & vbNewLine & _
"iHelpHeight=" & iHelpHeight & vbNewLine

sPath = App.path & "\Resource\palmate.cfg"
If FileCheck(sPath) = False Then
    If DirCheck(ReturnDir(sPath)) = False Then
        MkDir (App.path & "\Resource")
    End If
End If

Call Savefile(sPath, sCfg, True, True)

Exit Sub
ErrorHandler:
MsgBox Err.Description & vbNewLine & _
"Error writing configuration file. Procedure WriteCfg.", vbCritical, "Error"
End Sub

Sub NewWebPage()
'Creates a new webpage project.

Dim sPageName As String     'Name (key) of webpage project
Dim cStyle As CssBlock

On Error GoTo ErrorHandler

'The global flag for abort is set to false.
bAbort = False

'If the WebPage collection hasn't been created,
'we do it now
If cWebPages Is Nothing Then Set cWebPages = New WebPages

'The creation of a new webpage project
'is controlled by the WebPages Class collection.
cWebPages.MakeNewPage

'If the user aborted
If bAbort Then GoTo Terminate

With cLayouts(lAL)
    .Changed = False
    .StyleSheet.Changed = False
    .Ini1.Changed = False
    .Ini2.Changed = False
    .Ini3.Changed = False
    For Each cStyle In .StyleSheet
        cStyle.Changed = False
    Next
End With

Set cStyle = Nothing    'Free memory

Exit Sub
ErrorHandler:
bAbort = True
MsgBox Err.Description & vbNewLine & "Unexpected error in procedure NewWebPage.", vbCritical, "Error"
Exit Sub
Terminate:
bAbort = True
End Sub
Sub ReadLayoutList()
'Builds a list with available layouts and shows
'it to the user.

Dim bLoadCheck As Boolean
Dim bLoaded As Boolean
Dim cLayoutClass As Layout
Dim lCount As Long
Dim sValue As String

On Error GoTo ErrorHandler


'If there's at least one layout loaded, we set a flag to check
'if the layout is already loaded.
If Not (cLayouts Is Nothing) Then
    If cLayouts.Count > 0 Then
        bLoadCheck = True
    End If
End If


If bpubMakingViewer Then
    sAction = "Select Style For Gameviewer"
End If

frmLayouts.Show vbModal, fMainForm



If bAbort Then GoTo Terminate

'If the user picked a layout and used an existing
'stylesheet, the StyleSheet Collection was instantiated
'in frmLayouts. If not we create it now.
With cLayouts(lAL)
    If .StyleSheet Is Nothing Then
        Set .StyleSheet = New StyleSheet
        .BuildLayout    'Reads ini-file values and sets the Layouts properties accordingly.
    End If
    
    sValue = .Ini2.HtmlType
    
'   If it is a crosstable page the crosstable stylesheet is
'   loaded into the Crosstable class collection.
    If sValue = "batch" Then
        If .CrossStyle Is Nothing Then
            Set .CrossStyle = New CrossStyle
            If FileCheck(.PathCrossSource) = False Then
                MakeCssCollection
                sAction = "Select Crosstable Stylesheet"
                frmLayouts.Show vbModal, fMainForm
                sAction = Empty
                If bAbort Then GoTo Terminate
            End If
        End If
        If .CrossStyle.Count = 0 Then
            .CrossStyle.HandleCss (.PathCrossSource)
        End If
    End If
    
'   If the layout/style is a page with iframes and if
'   information about a stylesheet for iframes has been
'   stored, this stylesheet is loaded into the Iframe class collection.
    If sValue = "iframe" Or sValue = "muliframe" Or sValue = "magviewer" Then
        If Len(.PathIframeCssSource) > 0 Then
            If .Iframe Is Nothing Then
                Set .Iframe = New Iframe
                If FileCheck(.PathIframeCssSource) = False Then
                    MakeIFCssCollection
                    sAction = "Select Stylesheet For Iframe"
                    frmLayouts.Show vbModal, fMainForm
                    sAction = Empty
                    If bAbort Then GoTo Terminate
                End If
            End If
            If .Iframe.Count = 0 Then
                .Iframe.HandleCss (.PathIframeCssSource)
            End If
        End If
    End If
End With

Exit Sub
ErrorHandler:
MsgBox Err.Description & vbNewLine & "An error occurred in procedure ReadLayoutList", vbCritical + vbOKOnly, "Error"
bAbort = True
Exit Sub
Terminate:
bAbort = True
End Sub


Sub TerminateWebProject()
'Terminates the web page project

Dim sCaption As String
Dim fForm As Form
Dim lCount As Long
Dim bMag As Boolean

On Error GoTo ErrorHandler

'P4 addition/change
If lAL = lAW Then   'If it isn't a viewer
    If Not (cLayouts Is Nothing) Then
        If lAL > 0 Then
            cLayouts.Remove (lAL)
        End If
    End If
    If Not (cWebPages Is Nothing) Then
        cWebPages.Remove (lAW)
    End If
Else
    If bpubMakingViewer Then
        If Not (cLayouts Is Nothing) Then
            If lAL > 0 Then
                If cLayouts(lAL).Ini2.HtmlType = "magazine" Then
                    sCaption = cLayouts(lAL).CaptionName
                    cLayouts.Remove (lAL)
                End If
            End If
        End If
        If Not (cWebPages Is Nothing) Then
            cWebPages.Remove (lAW)
            lAW = lAW - 1
            cWebPages.Remove (lAW)
            If Len(sCaption) > 0 Then
                For Each fForm In Forms
                    If fForm.Caption = sCaption Then
                        Unload fForm
                        Exit For
                    End If
                Next
            End If
        End If
    Else
        cWebPages.Remove (lAW)
    End If
End If

'P4 addition/change
With fMainForm
    .mnuFileNewWebPage.Enabled = True
    If cLayouts.Count > 1 Then
        For lCount = 1 To cLayouts.Count
            If cLayouts(lCount).Ini2.HtmlType = "magazine" Then
                bMag = True
                Exit For
            End If
        Next
    End If
    If bMag = False Then
        .mnuMagazine.Visible = False
        .mnuViewer.Visible = False
    End If
End With

bAbort = False

If Not (cWebPages Is Nothing) Then
    lAW = cWebPages.Count
Else
    lAW = Empty
End If

If Not (cLayouts Is Nothing) Then
    lAL = cLayouts.Count
Else
    lAL = Empty
End If

UpdateMenu

bpubMakingViewer = False
bpubMakingPage = False
Screen.MousePointer = vbDefault

Exit Sub
ErrorHandler:
MsgBox Err.Description & vbNewLine & _
"Error terminating webproject. Procedure TerminateWebProject.", vbCritical, "Error"
bAbort = False
bpubMakingPage = False
End Sub

Sub SetActiveLayout(sCaption As String)
'If more than one style/layout is open and the user
'switches between layout forms, we need to activate
'the layout tied to the activated form.
'This is done from the forms activate procedure, which
'calls this procedure passing the form's caption, which
'is the layout's CaptionName property.

Dim lCount As Long

On Error GoTo ErrorHandler

For lCount = 1 To cLayouts.Count
    If cLayouts(lCount).CaptionName = sCaption Then
        lAL = lCount
        Exit For
    End If
Next

Exit Sub
ErrorHandler:
MsgBox Err.Description & vbNewLine & "Error in procedure SetActiveLayout.", vbCritical, "Error"
End Sub
Function SetActiveWebPage(ByVal sCaption As String) As Long
'If more than one webpage/style/layout is open and the user
'switches between layout forms, we need to activate
'the layout and webpage tied to the activated form.
'This is done from the forms activate procedure, which
'calls this function passing the form's caption, which
'is the layout's CaptionName property.

Dim lCount As Long

On Error GoTo ErrorHandler

With cWebPages
    For lCount = 1 To .Count
        If .Item(lCount).Layout.CaptionName = sCaption Then
            SetActiveWebPage = lCount
            Exit For
        End If
    Next
End With

Exit Function
ErrorHandler:
MsgBox Err.Description & vbNewLine & "Error in function SetActivebPage.", vbCritical, "Error"
End Function

Sub ShowInBrowser()
'Processes the selected pgn file(s) with Palview
'Shows the html page in the internal browser and
'saves the project.
'If any INI or CSS settings have changed, a new
'ini or css file is written first.

Dim sIniPath As String
Dim sHtmlType As String

On Error GoTo ErrorHandler

If cWebPages Is Nothing Then Exit Sub
If cWebPages.Count = 0 Then Exit Sub

sHtmlType = cLayouts(lAL).Ini2.HtmlType

'Ini file to use
sIniPath = App.path & "\Resource\" & cLayouts(lAL).Key & ".ini"
    
With cWebPages(lAW)
    If .Previewed = False Or .Changed = True Then
        If .Previewed = False Then
            bpubSaveProject = True  'If not previewed before all files are saved
        Else
            bpubSaveProject = False 'If previewed before only changed files are saved
        End If
        bpubPreview = True
        SaveProject
    End If
End With

If bAbort Then Exit Sub

If sHtmlType = "magazine" And bSameFolder = False Then FindFilesBefore

Call ConvertPgn(sIniPath)
If bAbort Then
    Screen.MousePointer = vbDefault
    Exit Sub
End If

cWebPages(lAW).Previewed = True

If sHtmlType <> "magviewer" Then
    With frmHtmPreview
        If bpubBrowserLoaded Then
            .timTimer.Enabled = True
            .brwPreview.Navigate (sLocalUrl)
            .timTimer_Timer
            If .Visible = False Then
                .Show
            End If
        Else
            .Show    'Show the page in the browser.
        End If
    End With
End If

Screen.MousePointer = vbDefault

CleanUp

bpubPreview = False
bpubSaveProject = False

Exit Sub

ErrorHandler:
bAbort = True
Screen.MousePointer = vbDefault
MsgBox Err.Description & vbNewLine & _
"Error showing page in browser, procedure ShowInBrowser.", vbCritical, "Error"

End Sub

Sub SaveProject()
'P4 change
'Processes the selected pgn file(s) with Palview and saves the project.
'If any INI or CSS settings have changed, a new
'ini or css file is written first.

Dim bCross As Boolean   'True if a stylesheet for crosstable exists.
Dim bIframe As Boolean  'True if an I-frame stylesheet is used
Dim lCount As Long
Dim lPgnCount As Long
Dim sIniPath As String
Dim sCssPath As String
Dim sCrossCssPath As String 'Full (target) local path of CSS for crosstable.
Dim sHtmlType As String
Dim sIframeCssPath As String    'Full target path for Iframe CSS.
Dim sHtmlTargetFile As String
Dim sHtmlTargetDir As String
Dim vAnswer As Variant
Dim vFile As Variant


On Error GoTo ErrorHandler

If cWebPages Is Nothing Then
    bAbort = True
    Exit Sub
End If
If cWebPages.Count = 0 Then
    bAbort = True
    Exit Sub
End If

With cLayouts(lAL)
    sHtmlType = .Ini2.HtmlType
    
'   Ini file to use
    sIniPath = App.path & "\Resource\" & .Key & ".ini"
'   Target Css file
    sCssPath = .PathWebCss & "\" & .Key & ".css"
    
'   Crosstable page?
    If sHtmlType = "batch" Then
        bCross = True
'       Target crosstable stylesheet.
        sCrossCssPath = .PathWebCss & "\" & .CrossStylesheetName
    End If
    
'   Is an I-frame stylesheet used?
    If Len(.PathIframeCssSource) > 0 Then
        bIframe = True
'       Target I-frame stylesheet.
        sIframeCssPath = .PathWebCss & "\" & .IframeCssName
    End If
    
    'We now check if files are to be saved, and in case there some pre-session files
    'with identical names, we prompt the user for permission to overwrite.
    
    'Page stylesheet
    If cWebPages(lAW).Previewed = False Then
        If FileCheck(sCssPath) Then
            vAnswer = MsgBox("Palview will now replace an old stylesheet with the same name as the page stylesheet. " & _
            "Do you want to continue?", vbQuestion + vbYesNo, "Replace Page Stylesheet?")
            If vAnswer = vbNo Then
                bAbort = True
                Exit Sub
            End If
            .StyleSheet.Changed = True
        End If
    
        'Crosstable stylesheet
        If bCross Then
                If FileCheck(sCrossCssPath) Then
                    vAnswer = MsgBox("PalMate will now replace an old stylesheet with the same " & _
                    "name as the crosstable stylesheet. Do you want to continue?", vbYesNo + vbQuestion, "Replace Crosstable Stylesheet?")
                    If vAnswer = vbNo Then
                        bAbort = True
                        Exit Sub
                    End If
                    .CrossStyle.Changed = True
                End If
        End If
    
        'I-frame stylesheet
        If bIframe Then
            If FileCheck(sIframeCssPath) Then
                vAnswer = MsgBox("PalMate will now replace an old stylesheet with the same " & _
                "name as the I-frame stylesheet. Do you want to continue?", vbYesNo + vbQuestion, "Replace I-frame Stylesheet?")
                If vAnswer = vbNo Then
                    bAbort = True
                    Exit Sub
                End If
                .Iframe.Changed = True
            End If
        End If
    
        'Html files
        sHtmlTargetDir = cLayouts(lAL).PathHtml & "\"
    
        If sHtmlType <> "magviewer" Then    'If not a magviewer
            For Each vFile In cWebPages(lAW).PgnFiles(lAP).HtmlNames
                'Define target file name
                sHtmlTargetFile = sHtmlTargetDir & vFile
                If FileCheck(sHtmlTargetFile) Then
                    vAnswer = MsgBox("PalMate will now replace at least one old html file " & vbNewLine & _
                    sHtmlTargetFile & vbNewLine & "and maybe more. Do you want to continue?", vbQuestion + vbYesNo, "Replace?")
                    If vAnswer = vbNo Then
                        bAbort = True
                        Exit Sub
                    Else
                        Exit For
                    End If
                End If
            Next
        Else
            'If it is a magviewer the html file name isn't made from a pgn file.
            sHtmlTargetFile = sHtmlTargetDir & cLayouts(lAL).Ini3.ViewerName
            If FileCheck(sHtmlTargetFile) Then
                vAnswer = MsgBox("PalMate will now replace an old html file and a js-file" & vbNewLine & _
                sHtmlTargetFile & vbNewLine & "and maybe more. Do you want to continue?", vbQuestion + vbYesNo, "Replace?")
                If vAnswer = vbNo Then
                    bAbort = True
                    Exit Sub
                End If
            End If
        End If
    End If  'End overwrite check
'End overwrite check
'****************************************************************
    
    Screen.MousePointer = vbHourglass
    'Write section
    
    'If we're not saving the project but only preparing
    'previewing, files are only saved if necessary.
    If bpubSaveProject = False And bpubPreview = True Then
        If .Changed Then
            'Ini file
            If .Ini1.Changed Or .Ini2.Changed Or .Ini3.Changed Then
                .WriteNewIni
                Call Savefile(sIniPath, .NewIni, True, True)
            End If
            
            'Page stylesheet
            If .StyleSheet.Changed Then
                .StyleSheet.WriteNewCss
                Call Savefile(sCssPath, .StyleSheet.NewCss, False, True)
                .StyleSheet.NewCss = Empty
            End If
    
            'Stylesheet for crosstable
            If bCross Then
                If .CrossStyle.Changed Then
                    .CrossStyle.WriteNewCss
                    Call Savefile(sCrossCssPath, .CrossStyle.NewCss, False, True)
                    .CrossStyle.NewCss = Empty
                End If
            End If
        
            'I-frame stylesheet
            If bIframe Then
                If .Iframe.Changed Then
                    .Iframe.WriteNewCss
                    Call Savefile(sIframeCssPath, .Iframe.NewCss, False, True)
                    .Iframe.NewCss = Empty
                End If
            End If
        End If
    End If

    'If the project is being saved or viewed for the first time
    'all files are processed and saved.
    If bpubSaveProject Then
        'Ini file
        .WriteNewIni
        Call Savefile(sIniPath, .NewIni, True, True)

        'Stylesheet
        .StyleSheet.WriteNewCss
        Call Savefile(sCssPath, .StyleSheet.NewCss, False, True)
        .StyleSheet.NewCss = Empty
        
        'Stylesheet for crosstable
        If bCross Then
            .CrossStyle.WriteNewCss
            Call Savefile(sCrossCssPath, .CrossStyle.NewCss, False, True)
            .CrossStyle.NewCss = Empty
        End If
        
        'I-frame stylesheet
        If bIframe Then
            .Iframe.WriteNewCss
            Call Savefile(sIframeCssPath, .Iframe.NewCss, False, True)
            .Iframe.NewCss = Empty
        End If
    End If
End With

'If the project is being saved and not shown in browser
'we process all pgnfiles and don't show in browser.
If bpubSaveProject And bpubPreview = False Then
    If sHtmlType <> "magviewer" Then
        lPgnCount = cWebPages(lAW).PgnFiles.Count
    Else
        lPgnCount = 1
    End If
    For lCount = 1 To lPgnCount
        lAP = lCount
        If sHtmlType = "magazine" And bSameFolder = False Then
            FindFilesBefore
        End If
        Call ConvertPgn(sIniPath)
        If bAbort Then
            Screen.MousePointer = vbDefault
            Exit Sub
        End If
    Next
    If bSameFolder = False Then FindFilesAfter
    If bAbort Then Exit Sub
    CleanUp 'Deletes temporary files and sets changed-flags to false.
    cWebPages(lAW).Saved = True
End If

Set vFile = Nothing

Exit Sub

ErrorHandler:
bAbort = True
Set vFile = Nothing
Screen.MousePointer = vbDefault
MsgBox Err.Description & vbNewLine & _
"Error saving project, procedure SaveProject, Module1.", vbCritical, "Error"
End Sub
Sub FindFilesBefore()
'Stores the date of the newest file in the folder.
'Later we use that to find newer files.

Dim sDir As String
Dim sFile As String
Dim datDate1 As Date
Dim datDate2 As Date

On Error GoTo ErrorHandle


With cWebPages(lAW)
    sDir = .PgnFiles(1).PgnDir

        sFile = Dir(sDir)
        If Len(sFile) > 0 Then
            datDate1 = FileDateTime(sDir & sFile)
        Else
            .DatYongest = Now
            Exit Sub
        End If

    Do
        sFile = Dir
        If Len(sFile) > 0 Then
            datDate2 = FileDateTime(sDir & sFile)
            If DateDiff("s", datDate1, datDate2) > 0 Then
                datDate1 = datDate2
            End If
        Else
            Exit Do
        End If
    Loop
    .DatYongest = datDate1  'FileDateTime of the youngest file
End With

Exit Sub
ErrorHandle:
bAbort = True
MsgBox Err.Description & vbNewLine & "Procedure FindFilesBefore", vbCritical, "Error"
End Sub
Sub FindFilesAfter()
Dim sDir As String
Dim sFile As String
Dim datDate1 As Date
Dim datDate2 As Date

On Error GoTo ErrorHandle

'If it is a magviewer we check if there's
'a temporary viewer-htm and -js file in the
'Resource folder. If so they are deleted.
If cLayouts(lAL).Ini2.HtmlType = "magviewer" Then Exit Sub

With cWebPages(lAW)
    sDir = .PgnFiles(1).PgnDir
    Set .FilesToCopyAndKill = Nothing
    Set .FilesToCopyAndKill = New Collection
    'FileDateTime of the youngest file before we processed the magazine
    datDate1 = .DatYongest
    
    'Finds first file in folder
    sFile = Dir(sDir)
    If Len(sFile) > 0 Then
        datDate2 = FileDateTime(sDir & sFile)
        If DateDiff("s", datDate1, datDate2) > 0 Then
            .FilesToCopyAndKill.Add sDir & sFile, sDir & sFile
        End If
    End If
    
    'Finds subsequent files
    Do
        sFile = Dir
        If Len(sFile) > 0 Then
            datDate2 = FileDateTime(sDir & sFile)
            If DateDiff("s", datDate1, datDate2) > 0 Then
                .FilesToCopyAndKill.Add sDir & sFile, sDir & sFile
            End If
        Else
            Exit Do
        End If
    Loop
End With

Exit Sub

ErrorHandle:
bAbort = True
MsgBox Err.Description & vbNewLine & "Procedure FindFilesAfter", vbCritical, "Error"

End Sub
Sub CleanSourceFolder()
Dim vFile
On Error GoTo ErrorHandle

For Each vFile In cWebPages(lAW).FilesToCopyAndKill
    Kill vFile
Next

Set vFile = Nothing

Exit Sub

ErrorHandle:
Set vFile = Nothing
bAbort = True
MsgBox Err.Description & vbNewLine & "Procedure CleanSourceFolder", vbCritical, "Error"

End Sub
Sub CleanUp()
'Deletes temporary files after Palview

On Error GoTo ErrorHandle

'Having updated the ini and css files the
'"Changed" flag is set to false.
With cLayouts(lAL)
    .Ini1.Changed = False
    .Ini2.Changed = False
    .Ini3.Changed = False
    .StyleSheet.Changed = False
    If .Ini2.HtmlType = "batch" Then .CrossStyle.Changed = False
    If Len(.PathIframeCssSource) > 0 Then .Iframe.Changed = False
End With

With cWebPages(lAW)
    .Changed = False
    .Saved = True
End With

'Delete temporary source files. To speed up the proces this is done
'after showing the htm file in the browser.
KillTempFiles

Exit Sub
ErrorHandle:
bAbort = True
Screen.MousePointer = vbDefault
MsgBox Err.Description & vbNewLine & _
"Error in procedure CleanUp, Module1.", vbCritical, "Error"

End Sub
Sub ConvertPgn(ByVal sIniPath As String)
'Converts a pgnfile with Palview

Dim bMagazine As Boolean        'True if making a magazine
Dim bMagviewer As Boolean       'True if processing a magviewer
Dim sRunPalview As String       'Will contain the command for running Palview
Dim sHtmlFileName As String     'Name of the html file created by Palview
Dim sHtmlTargetFile As String   'Name and path of html target file
Dim sHtmlTargetDir As String    'Html target directory
Dim sHtmlTemplate As String     'The original htm-magazine to be converted
Dim sPgnName As String          'Name of Pgn file to convert
Dim sSourceDir As String           'Directory of source pgn file
Dim sPalDir As String           'Directory of Palview
Dim sHtmlType As String
Dim sJavaSourceFile As String   'Name of separate JavaScript file (if used)
Dim sJavaTargetFile As String
Dim sErrorString As String      'Error message from Palview
Dim lTask As Long               'Handle for API
Dim lRetVal As Long             'Returned value from API
Dim lHandle As Long             'Handle for API
Dim lFileNumber As Long         'Number of html files to create
Dim lMilliSeconds As Long       'Milliseconds to wait for Palview to finish
Dim vAnswer As Variant
Dim vFile As Variant

On Error GoTo ErrorHandler

sHtmlType = cLayouts(lAL).Ini2.HtmlType
Select Case sHtmlType
    Case "magazine"
        bMagazine = True
    Case "magViewer"
        bMagviewer = True
End Select

'The time to wait for Palview to execute is defined as a
'function of the number of html files to create.
'P4 change. If a magazine we add time.
'If it is a magazine we add more time irrespective
'of the pgn-file number.
If bMagazine Then
    lFileNumber = 101
ElseIf bMagviewer Then
    lFileNumber = 1
Else
    lFileNumber = cWebPages(lAW).PgnFiles(lAP).HtmlNames.Count
End If

Select Case lFileNumber
    Case Is < 2
        lMilliSeconds = 10000
    Case Is > 1
        lMilliSeconds = lFileNumber * 5000
    Case Is > 100
        lMilliSeconds = lFileNumber * 4000
End Select

If bMagviewer = False Then
    sPgnName = cWebPages(lAW).PgnFiles(lAP).FilePath
Else
    sPgnName = "the gameviewer"
End If

'P4 change to include magazine option
If bMagazine Then
    sHtmlTemplate = cWebPages(lAW).Magazine.HtmlTemplate
    'Constructs the DOS command line for running Palview.
    sRunPalview = sPathPalview & " " & sHtmlTemplate & " " & sPgnName & " " & sIniPath & " -x"
ElseIf bMagviewer Then
    sRunPalview = sPathPalview & " " & sIniPath & " -x"
Else
    sRunPalview = sPathPalview & " " & sPgnName & " " & sIniPath & " -x"
End If
'End P4 change


'Now we call Palview. At the same time we get a handle from
'the OS, which returns a value when the shell action has finished.
'Meanwhile we wait.
lTask = Shell(sRunPalview)
'Get the handle
lHandle = OpenProcess(Synchronize, False, lTask)
'Yawn! - wait for the "done-message" from the OS.
'The timeout, lMilliSeconds, is set above.
lRetVal = WaitForSingleObject(lHandle, lMilliSeconds)

'If you open a handle you must close it when the task is done.
lRetVal = CloseHandle(lHandle)

'Now Palview has created the html file(s) from the source pgn -
'or without if it is a magviewer.
'Before we proceed with copying, showing etc. we check if the
'files have been created properly. This is done by checking
'for a Palview error logfile in the Palview folder directory.

If bMagviewer = False Then
    sSourceDir = cWebPages(lAW).PgnFiles(lAP).PgnDir   'pgn file directory
Else
    sSourceDir = ReturnDir(sIniPath) & "\"   'Gameviewers are written to the ini folder
End If

sPalDir = ReturnDir(sPathPalview) & "\"


'We now check for an error-log file. If Palview has encountered an error
'it will place a file "palog.txt" in the Palview directory.
If FileCheck(sPalDir & "palog.txt") Then
    Call LoadTextFile(sPalDir & "palog.txt", sErrorString)
    If Len(sErrorString) < 3 Then
        sErrorString = "Palview's error log doesn't tell the nature of the " & _
        "problem, but you may get a screen message if you process the file manually."
    End If
    MsgBox "Palview encountered a problem converting " & sPgnName & " to HTML." & vbNewLine & vbNewLine & _
    sErrorString, vbCritical, "Conversion Error"
    If bMagazine Then FindFilesAfter
    If bAbort Then Exit Sub
    KillTempFiles     'Delete temporary files in pgndir or (if gameviewer) in resource folder
    bAbort = True
    Exit Sub
End If

'If the html target directory isn't identical to the pgn source
'we check if the file is processed for the first time. If it is
'and an identical file name exist in the html target directory,
'we prompt for an overwrite permission.

sHtmlTargetDir = cLayouts(lAL).PathHtml & "\"

'If we're to copy the html files
If sHtmlTargetDir <> sSourceDir Then
    If bMagviewer Then
        sHtmlFileName = sSourceDir & cLayouts(lAL).Ini3.ViewerName
        sHtmlTargetFile = sHtmlTargetDir & Dir(sHtmlFileName)
        FileCopy sHtmlFileName, sHtmlTargetFile
        sHtmlFileName = Dir(sHtmlFileName)
    ElseIf bMagazine Then
        FindFilesAfter
        'Defines the local URL for the internal browser.
        For Each vFile In cWebPages(lAW).FilesToCopyAndKill
            'Define target file name
            sHtmlTargetFile = sHtmlTargetDir & Dir(vFile)
            'Define source file name
            sHtmlFileName = vFile
            'Copy
            FileCopy sHtmlFileName, sHtmlTargetFile
        Next
        sLocalUrl = sHtmlTargetDir & cWebPages(lAW).PgnFiles(lAP).HtmlFirstPage
    Else    'If not a magviewer or magazine
        For Each vFile In cWebPages(lAW).PgnFiles(lAP).HtmlNames 'HtmlFileNames
            'Define target file name
            sHtmlTargetFile = sHtmlTargetDir & vFile
            'Define source file name
            sHtmlFileName = sSourceDir & vFile
            'Copy
            If Len(Dir(sHtmlFileName)) > 0 Then
                FileCopy sHtmlFileName, sHtmlTargetFile
            Else
                MsgBox "Expected html file " & sHtmlFileName & "not found in pgn source folder.", vbCritical, "File Not Found"
            End If
        Next
        sHtmlFileName = cWebPages(lAW).PgnFiles(lAP).HtmlFirstPage
        'Defines the local URL for the internal browser.
        sLocalUrl = sHtmlTargetDir & sHtmlFileName
    End If

'   If a separate js file is used, we copy that too.
    If cLayouts(lAL).Ini2.JsFile = "on" Then
        sJavaSourceFile = sSourceDir & Left$(sHtmlFileName, Len(sHtmlFileName) - 3) & "js"
        sJavaTargetFile = sHtmlTargetDir & Left$(sHtmlFileName, Len(sHtmlFileName) - 3) & "js"
        If Len(Dir(sJavaSourceFile)) > 0 Then
            FileCopy sJavaSourceFile, sJavaTargetFile
        Else
            If sHtmlType <> "batch" Then
                MsgBox "Expected javascript " & sJavaSourceFile & "not found.", vbCritical, "Javascript Not Found"
            Else
                If cLayouts(lAL).Ini2.CrossLink = "on" Then
                    MsgBox "Expected javascript " & sJavaSourceFile & "not found.", vbCritical, "Javascript Not Found"
                End If
            End If
        End If
    End If
Else
    If bMagviewer = False Then
        sHtmlFileName = cWebPages(lAW).PgnFiles(lAP).HtmlFirstPage
        sLocalUrl = sHtmlTargetDir & sHtmlFileName
    Else
        sLocalUrl = sHtmlTargetFile
    End If
    
End If


Set vFile = Nothing

SkipFile:
Exit Sub
ErrorHandler:
bAbort = True
MsgBox Err.Description & vbNewLine & "Error in procedure ConvertPgn.", vbCritical, "Error"
End Sub
Public Sub ProcessInSequence(sHtmlType As String)
'Controls the sequence in which a magazine and a magviewer
'will be processed.

On Error GoTo ErrorHandle

Select Case sHtmlType
    Case "magazine"
        lAW = lAW + 1
        lAL = lAL + 1
        lAS = lAS + 1
        ShowInBrowser
        lAW = lAW - 1
        lAL = lAL - 1
        lAS = lAS - 1
        If bAbort Then Exit Sub
        ShowInBrowser
        If bAbort Then Exit Sub
    Case "magviewer"
        ShowInBrowser
        If bAbort Then Exit Sub
        lAW = lAW - 1
        lAL = lAL - 1
        lAS = lAS - 1
        ShowInBrowser
        lAW = lAW + 1
        lAL = lAL + 1
        lAS = lAS + 1
End Select

Exit Sub
ErrorHandle:
MsgBox Err.Description & vbNewLine & "Procedure ProcessInSequence, Module1", vbCritical, "Error"
End Sub
Public Sub CheckUnloadState()

    If bpubUnloadMag And bpubUnloadViewer Then
        bpubUnloadMag = False
        bpubUnloadViewer = False
        fMainForm.mnuMagazine.Visible = False
        fMainForm.mnuViewer.Visible = False
        UpdateMenu
    End If
    If bpubUnloadMag And bpubUnloadViewer = False Then
        UnloadViewer
    ElseIf bpubUnloadMag = False And bpubUnloadViewer Then
        UnloadMag
    End If

End Sub
Public Sub UnloadViewer()
'P4 addition.
'Unloads the viewer if the magazine has already been unloaded.

Dim fForm As Form
Dim lLayoutsCount As Long
Dim lCount As Long
Dim sCaption As String

On Error GoTo ErrorHandle

lLayoutsCount = cLayouts.Count
With cLayouts
    'To unload the right frmPgnText associated with the viewer,
    'we need to find the form's caption.
    'We use the fact, that a magazine will always be the layout
    'just before the viewer.
    
    'If the first layout is a viewer, that is the
    'one we're looking for (as the magazine has been removed).
    If .Item(1).Ini2.HtmlType = "magviewer" Then
        sCaption = .Item(1).CaptionName
    Else
    'We find the first viewer that doesn't have a magazine
    'just before.
        For lCount = 2 To lLayoutsCount
            If .Item(lCount).Ini2.HtmlType = "magviewer" Then
                'If the layout just before isn't a magazine,
                'we have found our viewer.
                If .Item(lCount - 1).Ini2.HtmlType <> "magazine" Then
                    sCaption = .Item(lCount).CaptionName
                    Exit For
                End If
            End If
        Next
    End If

    For Each fForm In Forms
        If fForm.Caption = sCaption Then
            Unload fForm
            Exit For
        End If
    Next
End With

bpubUnloadMag = False
bpubUnloadViewer = False
Set fForm = Nothing

Exit Sub
ErrorHandle:
MsgBox Err.Description & vbNewLine & "Procedure UnloadViewer", vbCritical, "Error"
End Sub
Public Sub UnloadMag()
'P4 addition.
'Unloads the magazine if the viewer has been unloaded.

Dim fForm As Form
Dim lLayoutsCount As Long
Dim lCount As Long
Dim sCaption As String

On Error GoTo ErrorHandle

lLayoutsCount = cLayouts.Count

With cLayouts
    'To unload the right frmPgnText associated with the magazine,
    'we need to find the form's caption.
    'We use the fact, that a magazine will always be the layout
    'just before the viewer. So when we find a magazine not followed
    'by a viewer, we know that is the one.
    
    If lLayoutsCount = 1 Then
        sCaption = .Item(1).CaptionName
    Else
        For lCount = 1 To lLayoutsCount
            If .Item(lCount).Ini2.HtmlType = "magazine" Then
                If lCount = lLayoutsCount Then
                    sCaption = .Item(lCount).CaptionName
                Else
                    If .Item(lCount + 1).Ini2.HtmlType <> "magviewer" Then
                        sCaption = .Item(lCount).CaptionName
                        Exit For
                    End If
                End If
            End If
        Next
    End If

    For Each fForm In Forms
        If fForm.Caption = sCaption Then
            Unload fForm
            Exit For
        End If
    Next
End With

bpubUnloadMag = False
bpubUnloadViewer = False
Set fForm = Nothing

Exit Sub
ErrorHandle:
MsgBox Err.Description & vbNewLine & "Procedure UnloadMag", vbCritical, "Error"
End Sub
Public Sub UpdateMenu()
'Updates the main form menu according to the status
'of the active project.
Dim lBool As Long
Dim bState As Boolean
Dim sHtmlType As String
Dim lRefreshTime As Long
Dim lCount As Long

On Error GoTo ErrorHandler

With fMainForm
    If cWebPages Is Nothing Then
        bState = False
    Else
        If cWebPages.Count = 0 Then
            bState = False
            .mnuFileClose.Enabled = False
            .mnuFileSave.Enabled = False
            .mnuViewWebpageProperties.Enabled = False
            .mnuViewPreview.Enabled = False
            .tbToolBar.Buttons(1).ToolTipText = "Web Browser"
            .tbToolBar.Buttons(2).Visible = "False"
            .mnuViewMagView.Visible = False
            For lCount = 2 To .tbToolBar.Buttons.Count
                .tbToolBar.Buttons(lCount).Visible = False
            Next
            .mnuViewCssTextWindow.Enabled = False
        Else
            bState = True
            If cWebPages(lAW).PgnEditorOpen Then
                .mnuViewPgnEditor.Enabled = False
            Else
                .mnuViewPgnEditor.Enabled = True
            End If
            .mnuViewWebpageProperties.Enabled = True
            .mnuViewPreview.Enabled = True
            .tbToolBar.Buttons(1).ToolTipText = "Preview Page"
        End If
    End If
    
    .mnuStyle.Visible = bState
    .mnuPage.Visible = bState
    .mnuLayout.Visible = bState
    .mnuFormat.Visible = bState
    
    If bState = False Then Exit Sub
    
    sHtmlType = cLayouts(lAL).Ini2.HtmlType
    lBool = lOnOff(cLayouts(lAL).Ini2.Ns4Comp)

    .mnuColumns.Visible = False
    .mnuPageBasicLayout.Visible = True
    .mnuLayoutPlayerInfo.Visible = False
    .mnuPageMenuBar1.Visible = True
    .mnuPageMenuBar2.Visible = True
    .mnuPageBar4.Visible = True
    
    If sHtmlType = "normal" Or sHtmlType = "overview" Or sHtmlType = "overdb" Then
        .mnuPageLive.Visible = True
    Else
        .mnuPageLive.Visible = False
        .mnuPageLive.Checked = False
    End If
    
    If sHtmlType = "magazine" Or sHtmlType = "overview" Or sHtmlType = "problem" Then
        .mnuColumns.Visible = True
    Else
        .mnuColumns.Visible = False
    End If
    
    'If a livepage it is possible to edit player info for the ini file.
    If sHtmlType = "normal" And cLayouts(lAL).Ini1.RefreshTime > 0 Then
        .mnuLayoutPlayerInfo.Visible = True
    End If

'   If the page uses iframes
    If sHtmlType = "iframe" Or sHtmlType = "muliframe" Or sHtmlType = "magviewer" Then
        IframeMenu lBool
    Else
        'If the page doesn't use iframes, NS4-pages are enabled and
        'the iframe style-commands are disabled.
        If sHtmlType <> "magazine" Then .mnuPageNs4Comp.Visible = True
        .mnuStyleUseIframeCss.Visible = False
        .mnuStyleCopyIframeCss.Visible = False
        .mnuStyleBar1.Visible = False
    End If

    'If NS4 compatible
    If lBool = 1 Then
        'Language selection drop down is disabled and switched off
        .mnuPageLanguageSelection.Checked = False
        .mnuPageLanguageSelection.Visible = False
        .mnuPageBar4.Visible = False
        cLayouts(lAL).Ini2.MultiLang = "off"
        'The NS4 compatible menu item is checked
        .mnuPageNs4Comp.Checked = True
        'The Css border menu is disabled
        .mnuFormatBorder.Visible = False
        .mnuPageRedirect.Visible = False
    Else
        .mnuPageNs4Comp.Checked = False
        .mnuPageLanguageSelection.Visible = True
        .mnuPageBar4.Visible = True
        .mnuPageLanguageSelection.Checked = lOnOff(cLayouts(lAL).Ini2.MultiLang)
        .mnuFormatBorder.Visible = True
        .mnuPageRedirect.Visible = True
    End If

    If sHtmlType = "overview" Or sHtmlType = "overdb" Then
        .mnuPageLive.Checked = True
    Else
        If lRefreshTime = 0 Then
            .mnuPageLive.Checked = False
        Else
            .mnuPageLive.Checked = True
        End If
    End If

    'If it isn't a crosstable page
    If cWebPages(lAW).CrossLinkTable = False And cWebPages(lAW).CrossTableNoLinks = False Then
        NonCrosstableMenu lBool
    Else    'If it is a crosstable page
        CrosstableMenu lBool
    End If
        
    If sHtmlType = "magazine" Then
        MagazineMenu lBool
    Else
        .mnuMagazine.Visible = False
        If sHtmlType <> "magviewer" Then
            .tbToolBar.Buttons(2).Visible = False
            .mnuViewMagView.Visible = False
        End If
    End If
    
    If sHtmlType = "magviewer" Then
        MagviewerMenu
    Else
        .mnuViewer.Visible = False
        If sHtmlType <> "magazine" Then
            .tbToolBar.Buttons(2).Visible = False
            .mnuViewMagView.Visible = False
        End If
    End If
End With

Exit Sub
ErrorHandler:
MsgBox Err.Description & vbNewLine & _
"Error updating menu.", vbCritical, "Error"

End Sub
Sub NonCrosstableMenu(ByRef lBool As Long)

Dim lRefreshTime As Long

With fMainForm
    .mnuLayoutChessBoardAnalysis.Checked = lOnOff(cLayouts(lAL).Ini2.MovingPcs)
    .mnuPageCrossSettings.Visible = False
    .mnuStyleCopyCrosCss.Visible = False
    .mnuLayoutChessBoard.Visible = True
    .mnuLayoutChessPieces.Visible = True
    .mnuLayoutConPanel.Visible = True
    .mnuLayoutMoveText.Visible = True
    lRefreshTime = cLayouts(lAL).Ini1.RefreshTime

    'Layout menu
    Select Case cLayouts(lAL).Ini2.BoardValign
        Case "top"
            .mnuLayoutChessBoardAlignTop.Checked = True
            .mnuLayoutChessBoardAlignCentre.Checked = False
            .mnuLayoutChessBoardAlignBottom.Checked = False
        Case "center"
            .mnuLayoutChessBoardAlignTop.Checked = False
            .mnuLayoutChessBoardAlignCentre.Checked = True
            .mnuLayoutChessBoardAlignBottom.Checked = False
        Case "bottom"
            .mnuLayoutChessBoardAlignBottom.Checked = True
            .mnuLayoutChessBoardAlignCentre.Checked = False
            .mnuLayoutChessBoardAlignTop.Checked = False
        Case Else
            .mnuLayoutChessBoardAlignTop.Checked = False
            .mnuLayoutChessBoardAlignCentre.Checked = True
            .mnuLayoutChessBoardAlignBottom.Checked = False
            cLayouts(lAL).Ini2.BoardValign = "center"
    End Select

    If cLayouts(lAL).Ini2.ToolTipBoard = "on" Then
        .mnuLayoutChessBoardTooltip.Checked = True
    Else
        .mnuLayoutChessBoardTooltip.Checked = False
    End If
End With

End Sub
Sub IframeMenu(ByRef lBool As Long)

'It is possible to use an iframe stylesheet and
'NS4-pages are disabled.

With fMainForm
    .mnuStyleUseIframeCss.Visible = True
    .mnuStyleBar1.Visible = True
    .mnuPageNs4Comp.Checked = False
    .mnuPageNs4Comp.Visible = False
    
    'If an iframe stylesheet is used
    If Len(cLayouts(lAL).IframeCssName) > 0 Then
        .mnuStyleUseIframeCss.Checked = True    'The menu is checked
        .mnuStyleCopyIframeCss.Enabled = True   'Copying is enabled
    End If
    
    'If the page was previously NS4 compatible, NS4-compitability
    'is switched off and we inform the user.
    If lBool = 1 Then
        MsgBox "The page style isn't compatible with Netscape 4.*. " & _
        "NS4-compatibility has been switched off.", vbInformation, "Page Style & NS4"
        cLayouts(lAL).Ini2.Ns4Comp = "off"
        lBool = 0   'Flag for NS4-page set to false
    End If
End With

End Sub
Sub CrosstableMenu(ByRef lBool As Long)
    
With fMainForm
    .mnuPageCrossSettings.Visible = True
    .mnuStyleCopyCrosCss.Visible = True
    .mnuStyleBar1.Visible = True
    .mnuLayoutPlayerInfo.Visible = True
    If cWebPages(lAW).CrossTableNoLinks Then
        .mnuPageLanguageSelection.Visible = False
        .mnuLayoutChessBoard.Visible = False
        .mnuLayoutChessPieces.Visible = False
        .mnuLayoutConPanel.Visible = False
        .mnuLayoutMoveText.Visible = False
    End If
    If cWebPages(lAW).CrossLinkTable Then
        If lBool = 0 Then
            .mnuPageLanguageSelection.Visible = True
        End If
        .mnuLayoutChessBoard.Visible = True
        .mnuLayoutChessPieces.Visible = True
        .mnuLayoutConPanel.Visible = True
        .mnuLayoutMoveText.Visible = True
    End If
End With

End Sub
Sub MagazineMenu(ByRef lBool As Long)
    
With fMainForm
    .mnuMagazine.Visible = True
    .mnuPageBasicLayout.Visible = False
    .mnuPageCrossSettings.Visible = True
    .mnuPageMenuBar1.Visible = False
    .mnuPageBar4.Visible = False
    .mnuLayoutConPanel.Visible = False
    .mnuPageLanguageSelection.Visible = False
    .mnuViewMagView.Visible = True
    .tbToolBar.Buttons(2).Visible = True
    If cLayouts(lAL).Ini1.DiagramNo > 0 Then
        .mnuMagazineDiagramsWriteNumbers.Checked = True
        .mnuMagazineDiagramsFirstNumber.Enabled = True
        .mnuMagazineDiagramsNumbertext.Enabled = True
    Else
        .mnuMagazineDiagramsWriteNumbers.Checked = False
        .mnuMagazineDiagramsFirstNumber.Enabled = False
        .mnuMagazineDiagramsNumbertext.Enabled = False
    End If
    If cLayouts(lAL).Ini2.WriteMagLinks = "on" Then
        .mnuMagazineWriteGamelinks.Checked = True
    Else
        .mnuMagazineWriteGamelinks.Checked = False
    End If
    'If the page was previously NS4 compatible, NS4-compitability
    'is switched off and we inform the user.
    If lBool = 1 Then
        MsgBox "The page style isn't compatible with Netscape 4.*. " & _
        "NS4-compatibility has been switched off.", vbInformation, "Page Style & NS4"
        cLayouts(lAL).Ini2.Ns4Comp = "off"
        lBool = 0   'Flag for NS4-page set to false
    End If
End With

End Sub
Sub MagviewerMenu()
    
With fMainForm
    .mnuViewer.Visible = True
    .mnuPageBasicLayout.Visible = False
    .mnuPageMenuBar1.Visible = False
    .mnuPageMenuBar2.Visible = False
    .mnuPageBar4.Visible = False
    .mnuPageRedirect.Visible = False
    .mnuPageLanguageSelection.Visible = False
    .mnuViewMagView.Visible = True
    .mnuViewPgnEditor.Enabled = False
    .tbToolBar.Buttons(2).Visible = True
End With

End Sub
Public Sub KillTempFiles()
'Deletes htm and js files created by Palview in the (pgn) source directory.

Dim sPgnDir As String
Dim sHtmlTargetDir As String
Dim sHtmlType As String
Dim sFileName As String
Dim vFile As Variant
Dim cPgn As Pgn

On Error GoTo ErrorHandler

With cLayouts(lAL)
    sHtmlType = .Ini2.HtmlType
    Select Case sHtmlType
        Case "magazine"
            If bSameFolder = False Then
                CleanSourceFolder
            End If
        Case "magviewer"
            sFileName = App.path & "\Resource\" & cLayouts(lAL).Ini3.ViewerName
            If FileCheck(sFileName) Then Kill sFileName
            sFileName = Left$(sFileName, Len(sFileName) - 3) & "js"
            If FileCheck(sFileName) Then Kill sFileName
        Case Else
            'For each selected pgn file in the webpage project
            For Each cPgn In cWebPages(lAW).PgnFiles
                sPgnDir = cPgn.PgnDir 'pgn file directory
                sHtmlTargetDir = .PathHtml & "\"
                'If the pgn source directory isn't identical to the html target dir
                If sPgnDir <> sHtmlTargetDir Then
                    'Loop through the html file names associated with the pgn file
                    For Each vFile In cPgn.HtmlNames
                        sFileName = sPgnDir & vFile
                        If FileCheck(sFileName) Then
                            Kill sFileName  'Delete the file if it exists
                        End If
                    Next
                    'If a separate JavaScript file is used we delete that too.
                    If .Ini2.JsFile = "on" Then
                        sFileName = cPgn.HtmlFirstPage
                        sFileName = Left$(sFileName, Len(sFileName) - 3) & "js"
                        sFileName = sPgnDir & sFileName
                        If FileCheck(sFileName) Then Kill sFileName
                    End If
                End If
            Next
    End Select
End With
Set vFile = Nothing
Set cPgn = Nothing

Exit Sub

ErrorHandler:
bAbort = True
MsgBox Err.Description & vbNewLine & _
"Error deleting temporary html and JavaScript files " & _
"from the pgn source directory. Procedure KillTempFiles.", vbCritical, "Error"
Set vFile = Nothing
Set cPgn = Nothing

End Sub

Public Sub SaveOnExit()
Dim cPage As WebPage
Dim vAnswer As Variant
Dim lGamePage As Long
Dim lCrossPage As Long

On Error GoTo ErrorHandler

If cWebPages Is Nothing Then Exit Sub

For Each cPage In cWebPages
    If cPage.CrossLinkTable = False Then
        If cPage.Changed Then
            If cPage.PgnFiles.Count > 0 Then
                vAnswer = MsgBox("Do you want to process and save " & cPage.PgnFiles(1).HtmlFirstPage & "?", vbQuestion + vbYesNo, "Process and save " & cPage.PgnFiles(1).HtmlFirstPage & "?")
                If vAnswer = vbYes Then
                    cPage.SavePage
                End If
            End If
            vAnswer = MsgBox("Do you want to save changes to the style " & cPage.Layout.Key & "?", vbQuestion + vbYesNo, "Save " & cPage.Layout.Key & " style?")
            If vAnswer = vbYes Then
                cPage.Layout.SaveLayout
            Else
                cPage.Layout.RestoreLayout
            End If
        End If
    End If
Next

Set cPage = Nothing

If Len(Dir(App.path & "\resource\*.bni")) > 0 Then
    Kill App.path & "\resource\*.bni"
End If

Exit Sub
ErrorHandler:
MsgBox Err.Description & vbNewLine & _
"Error in procedure SaveOnExit.", vbCritical, "Error"
Set cPage = Nothing

End Sub

Public Sub CopyFile(ByRef sSource As String, ByRef sTarget As String)
'Copies a file

On Error GoTo ErrorHandler

If FileCheck(sTarget) Then SetAttr sTarget, vbNormal

FileCopy sSource, sTarget

SetAttr sTarget, vbNormal

Exit Sub
ErrorHandler:
MsgBox Err.Description & vbNewLine & _
"Error in procedure CopyFile.", vbCritical, "Error Copying File"

End Sub

Public Sub ShowHelp(ByRef sHelpUrl As String)

On Error GoTo ErrorHandler

bpubHelpMode = True

Set fHtmForm = New frmHtmPreview

With fHtmForm
    .timTimer.Enabled = True
    .brwPreview.Navigate sHelpUrl
    .Show vbModal, fMainForm
End With

bpubHelpMode = False
Set fHtmForm = Nothing

Exit Sub
ErrorHandler:
MsgBox Err.Description, vbCritical, "Error Showing Help Subject"
bpubHelpMode = False
End Sub

Public Sub MakeCssCollection()
'Creates a collection with the available
'crosstable stylesheets in the CrossCss directory.

Dim sPath As String
Dim sFileName As String
Dim sName As String
Dim sText As String

On Error GoTo ErrorHandler

Set colCrossStyles = Nothing
Set colCrossStyles = New Collection

sPath = App.path & "\CrossCss"

'If the directory IframCss doesn't exist
'we create it and make a dummy css file.
If ValidPath(sPath) = False Then
    MkDir (App.path & "\CrossCss")
    MsgBox "The directory with crosstable stylesheets " & App.path & "\CrossCss was not found. " & _
    "PalMate has recreated the directory and a sample Css file.", vbInformation, "Directory Not Found"
    sText = "BODY {}"
    Call Savefile(App.path & "\CrossCss\cssdummy.css", sText, False, True)
    Exit Sub
End If

'Loops through the available stylesheets
'and adds each name to the collection
'provided the name isn't identical to
'the ordinary stylesheet.
sFileName = sPath & "\*.css"

If Len(Dir(sFileName)) = 0 Then
    MsgBox "No crosstable stylesheets available"
Else
    sFileName = Dir(sFileName)
'   The filename's extension is removed
    sName = Left$(sFileName, Len(sFileName) - 4)
'   The name is compared with the names of the active layouts.
'   If the names match, the stylesheet is omitted from the list.
    If CheckCssNameMatch(sName) = False Then
        colCrossStyles.Add sFileName
    End If
    Do
        sFileName = Dir
        If Len(sFileName) > 0 Then
            sName = Left$(sFileName, Len(sFileName) - 4)
            If CheckCssNameMatch(sName) = False Then
                colCrossStyles.Add sFileName
            End If
        Else
            Exit Do
        End If
    Loop
End If

Exit Sub
ErrorHandler:
MsgBox Err.Description & vbNewLine & _
"Error creating list with crosstable stylesheets. Procedure MakeCssCollection.", vbCritical, "Error"
End Sub

Public Sub MakeIFCssCollection()
'Creates a collection with the available
'Iframe stylesheets in the IframCss directory.

Dim sPath As String
Dim sFileName As String
Dim sName As String
Dim sText As String

On Error GoTo ErrorHandler

Set colIframeStyles = Nothing
Set colIframeStyles = New Collection

sPath = App.path & "\IframCss"

'If the directory IframCss doesn't exist
'we create it and make a dummy css file.
If ValidPath(sPath) = False Then
    MkDir (App.path & "\IframCss")
    MsgBox "The directory with Iframe stylesheets " & App.path & "\IframCss was not found. " & _
    "PalMate has recreated the directory and a sample Css file.", vbInformation, "Directory Not Found"
    sText = "BODY {}"
    Call Savefile(App.path & "\IframCss\cssdummy.css", sText, False, True)
End If

'Loops through the available stylesheets
'and adds each name to the collection
'provided the name isn't identical to
'the ordinary stylesheet.
sFileName = sPath & "\*.css"

If Len(Dir(sFileName)) = 0 Then
    MsgBox "No Iframe stylesheets available"
Else
    sFileName = Dir(sFileName)
'   The filename's extension is removed
    sName = Left$(sFileName, Len(sFileName) - 4)
'   The name is compared with the names of the active layouts.
'   If the names match, the stylesheet is omitted from the list.
    If CheckCssNameMatch(sName) = False Then
        colIframeStyles.Add sFileName
    End If
    Do
        sFileName = Dir
        If Len(sFileName) > 0 Then
            sName = Left$(sFileName, Len(sFileName) - 4)
            If CheckCssNameMatch(sName) = False Then
                colIframeStyles.Add sFileName
            End If
        Else
            Exit Do
        End If
    Loop
End If

Exit Sub
ErrorHandler:
MsgBox Err.Description & vbNewLine & _
"Error creating list with Iframe stylesheets. Procedure MakeIFCssCollection.", vbCritical, "Error"
End Sub

