VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "Pgn"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Description = "A single pgn file"
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"No"
Attribute VB_Ext_KEY = "Member0" ,"Players"
Option Explicit

'set this to 0 to disable debug code in this class
#Const DebugMode = 1


#If DebugMode Then
    'local variable to hold the serialized class ID that was created in Class_Initialize
    Private mlClassDebugID As Long
#End If
Public Key As String
'local variable(s) to hold property value(s)
Private mvarChanged As Boolean 'local copy
Private mvarFilePath As String 'local copy
Private mvarPgnDir As String 'local copy
Private mvarHtmlFirstPage As String 'local copy
Private mvarTempFile As Boolean 'local copy
Private mvarGameNumbers As Collection 'local copy
Private mvarWhitePlayers As Collection 'local copy
Private mvarBlackPlayers As Collection 'local copy
Private mvarResults As Collection 'local copy
Private mvarFromPos As Collection 'local copy
Private mvarToPos As Collection 'local copy
Private mvarNestedStartTags As Collection 'local copy
Private mvarNestedEndTags As Collection 'local copy
Private mvarEventList As Collection 'local copy
Private mvarPlayerList As Collection 'local copy
Private mvarHtmlNames As Collection 'local copy
Private mvarGameEvents As Collection 'local copy
Private mvarPlayers As Players
'local variable(s) to hold property value(s)
Private mvarPgnBackup As String 'local copy
Public Property Let PgnBackup(ByVal vData As String)
Attribute PgnBackup.VB_Description = "Complete path to the original pgn file saved in PalMate's Bacup folder."
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.PgnBackup = 5
    mvarPgnBackup = vData
End Property


Public Property Get PgnBackup() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.PgnBackup
    PgnBackup = mvarPgnBackup
End Property




Public Function ExtractTag(stag As String, ByVal lPos As Long) As String
'Extract the value of a tag, e.g. White's name.
Dim lPos2 As Long

On Error GoTo ErrorHandler

lPos2 = InStr(lPos + 1, stag, """")
If lPos2 = 0 Then
    MsgBox "There's an error in game number " & Me.GameNumbers.Count & _
    ". Missing quotation mark in pgn tag " & "[" & stag & "]", vbCritical, "Syntax Error"
    lPos2 = Len(stag)
End If

ExtractTag = Mid$(stag, lPos + 1, lPos2 - lPos - 1)
ExtractTag = Trim(ExtractTag)
ExtractTag = StripChar(ExtractTag, ".", ", ", ")", "")

Exit Function
ErrorHandler:
MsgBox Err.Description & vbNewLine & "Unexpected error in function ExtractTag " & _
"in class module Pgn.", vbCritical, "Error"
End Function

Public Sub CheckTag(ByVal stag As String)
'Checks if the tag contains either "White",
'"Black" or "Result".
'As a P4 addition "Event" has been added.
'If it does the value is extracted and added to
'the relevant collection.

Dim lPos1 As Long
Dim lPos2 As Long
Dim lCount As Long      'Used for Event-check. P4 addition.
Dim sEvent As String    'Used for Event. P4 addition.
Dim bMatch As Boolean   'Used for Event check. P4 addition
Dim sPlayer As String

On Error GoTo ErrorHandler

lPos1 = InStr(1, stag, """")

lPos2 = InStr(1, stag, "White")

If lPos2 > 0 Then
    If lPos1 > lPos2 Then
'       If the next char isn't alfanumeric we avoid traps like "Whiteelo"
        If dhIsCharAlphanumeric(Mid$(stag, lPos2 + 5, 1)) = False Then
            Me.WhitePlayers.Add Me.ExtractTag(stag, lPos1)
            Exit Sub
        End If
    End If
End If

lPos2 = InStr(1, stag, "Black")
If lPos2 > 0 Then
    If lPos1 > lPos2 Then
'       If the next char isn't alfanumeric we avoid traps like "Blackelo"
        If dhIsCharAlphanumeric(Mid$(stag, lPos2 + 5, 1)) = False Then
            Me.BlackPlayers.Add (Me.ExtractTag(stag, lPos1))
            Exit Sub
        End If
    End If
End If

lPos2 = InStr(1, stag, "Result")
If lPos2 > 0 Then
    If lPos1 > lPos2 Then
        Me.Results.Add (Me.ExtractTag(stag, lPos1))
        Exit Sub
    End If
End If

bMatch = False

'P4 addition - Event
lPos2 = InStr(1, stag, "Event")
If lPos2 > 0 Then
    If lPos1 > lPos2 Then
'       If the next char isn't alfanumeric we avoid traps like "Eventdate"
        If dhIsCharAlphanumeric(Mid$(stag, lPos2 + 5, 1)) = False Then
            sEvent = (Me.ExtractTag(stag, lPos1))
            'The game's event is added to the collection GamesEvents
            Me.GameEvents.Add sEvent
'           We now compare the event to the events already in the collection.
'           We only want to add new events.
            For lCount = 1 To Me.EventList.Count
                If sEvent = Me.EventList(lCount) Then
                    bMatch = True
                    Exit For    'If it is a match we leave the for-next loop.
                End If
            Next
            If bMatch = False Then
                Me.EventList.Add sEvent 'If bMatch is still false, the event is added to the collection.
            End If
            Exit Sub
        End If
    End If
End If

Exit Sub
ErrorHandler:
MsgBox Err.Description & vbNewLine & "Unexpected error parsing the pgn file. " & _
"The problem arose in procedure CheckTag in class Pgn.", vbCritical, "Error"

End Sub

Public Sub ParseAdvanced(sText As String, lPos1 As Long, lPos2 As Long, lPos3 As Long, lPos4 As Long)

Dim sChar As String * 1
Dim sSubString As String
Dim lCount As Long
Dim lNestedStartTagsCount
Dim bNestedStarts As Boolean
Dim bNestedEnds As Boolean
Dim bNoMoreNestedStarts As Boolean
Dim bNoMoreNestedEnds As Boolean


On Error GoTo ErrorHandler

If Me.NestedStartTags Is Nothing Then
    bNestedStarts = False
    bNoMoreNestedStarts = True
Else
    bNestedStarts = True
    bNoMoreNestedStarts = False
End If

If Me.NestedEndTags Is Nothing Then
    bNestedEnds = False
    bNoMoreNestedEnds = True
Else
    bNestedEnds = True
    bNoMoreNestedEnds = False
End If

Do
    
'   If there are no more nested tags we shift to the simpler procedure
    If bNoMoreNestedStarts And bNoMoreNestedEnds Then
        GoTo ShiftToSimple
    End If
    
'   If there are no nested start tags
    If bNestedStarts = False Or bNoMoreNestedStarts = True Then
        lPos2 = InStr(lPos1, sText, "[")        'Find next "["
        If lPos2 = 0 Then                       'If none found it must be the last game.
            Me.ToPos.Add (Len(sText))           'End of last game = end of file.
            Exit Sub                            'Exit sub
        End If
    End If
    
    lNestedStartTagsCount = Me.NestedStartTags.Count
    
    If bNestedStarts = True And bNoMoreNestedStarts = False Then
'       If there are nested start tags we loop to find the next
'       that is not nested.
        Do
            lPos2 = InStr(lPos1, sText, "[")        'Find next "["
            If lPos2 = 0 Then                       'If none found it must be the last game.
                Me.ToPos.Add (Len(sText))           'End of last game = end of file.
                Exit Sub                            'Exit sub
            End If
'           If lPos2 is bigger than the last position in NestedStartTags
'           there are no more nested "[".
            If lPos2 > Me.NestedStartTags(lNestedStartTagsCount) Then
'               If there are no more nested end tags we proceed in the
'               less complicated and faster procedure ParseSimple.
                If bNoMoreNestedEnds Then
                    GoTo ShiftToSimple
                Else
                    bNoMoreNestedStarts = True
                    Exit Do
                End If
            End If
'           We now check if the start tag is nested.
            For lCount = 1 To lNestedStartTagsCount
'               If nested we increment lPos1 to find the next "["
                If lPos2 = Me.NestedStartTags(lCount) Then
                    lPos1 = Me.NestedStartTags(lCount) + 1
'               If smaller than the saved position the current
'               lPos2 can't be nested, so we exit the loop.
                ElseIf lPos2 < Me.NestedStartTags(lCount) Then
                    Exit Do
                End If
            Next
        Loop
    End If
    
    If lPos1 = 1 Then           'If lPos1=1 the first game starts at lPos2
        Me.FromPos.Add (lPos2)  'Start position is saved
        Me.GameNumbers.Add (1)  'Game number added
    Else
'       If there are more than 3 chars between last "]"
'       and the new "[" we may have come to a new game.
        If lPos2 - lPos3 > 3 Then
            lPos4 = lPos3 + 1
'       We loop through the chars after the last "]".
'       If a char is alfanumeric we're dealing with
'       game moves and the "[" we found at lPos2 must
'       be the first tag of a new game.
            Do
                sChar = Mid$(sText, lPos4, 1)
                If dhIsCharAlphanumeric(sChar) Then
                    Me.FromPos.Add (lPos2)
                    Me.GameNumbers.Add (Me.GameNumbers.Count + 1)
                    Me.ToPos.Add (lPos2 - 1)
                    Exit Do
                End If
                lPos4 = lPos4 + 1
            Loop Until lPos4 = lPos2 - 1
        End If
    End If
    
'   Now's the time to find the next not-nested end-tag
'   If there are no (or no more) nested end tags.
    If bNestedEnds = False Or bNoMoreNestedEnds = True Then
        lPos3 = InStr(lPos2 + 1, sText, "]")
        If lPos3 = 0 Then GoTo Abort
    End If
    
'   If there are nested End tags
    If bNestedEnds = True And bNoMoreNestedEnds = False Then
        lPos4 = lPos2
        Do
            lPos3 = InStr(lPos4 + 1, sText, "]")
            If lPos3 = 0 Then GoTo Abort
'           We now check if the current lPos3 is nested.
            If lPos3 > Me.NestedEndTags(Me.NestedEndTags.Count) Then
                bNoMoreNestedEnds = True
                Exit Do
            End If
            For lCount = 1 To Me.NestedEndTags.Count
                If lPos3 = Me.NestedEndTags(lCount) Then
                    lPos4 = Me.NestedEndTags(lCount) + 1
                ElseIf lPos3 < Me.NestedEndTags(lCount) Then
                    Exit Do
                End If
            Next
        Loop
    End If
    
    sSubString = Mid$(sText, lPos2 + 1, lPos3 - lPos2 - 1)

'   Checks the tag. If it is either "White", "Black" or "Result"
'   it is added to the relevant collections.
'   P4 addition: Event
    Call Me.CheckTag(sSubString)
    
    lPos1 = lPos3 + 1
Loop Until lPos1 = 0


Exit Sub
ShiftToSimple:
Call ParseSimple(sText, lPos1, lPos2, lPos3, lPos4)
Exit Sub
Abort:
MsgBox "Syntax error in Pgn file - missing ""]""", vbCritical, "Syntax error"
Exit Sub
ErrorHandler:
MsgBox Err.Description & vbNewLine & "Unexpected error in procedure ParseAdvanced in class module Pgn.", vbCritical, "Error"

End Sub

Public Sub ParseSimple(sText As String, lPos1 As Long, lPos2 As Long, lPos3 As Long, lPos4 As Long)

Dim sChar As String * 1
Dim sSubString As String

On Error GoTo ErrorHandler

Do
    lPos2 = InStr(lPos1, sText, "[")        'Find next "["
    If lPos2 = 0 Then                       'If none found it must be the last game.
        Me.ToPos.Add (Len(sText))           'End of last game = end of file.
        Exit Do                             'Exit loop
    End If
    If lPos1 = 1 Then           'If lPos1=1 the first game starts at lPos2
        Me.FromPos.Add (lPos2)  'Start position is saved
        Me.GameNumbers.Add (1)  'Game number added
    Else
'       If there are more than 3 chars between last "]"
'       and the new "[" we may have come to a new game.
        If lPos2 - lPos3 > 3 Then
            lPos4 = lPos3 + 1
'       We loop through the chars after the last "]".
'       If a char is alfanumeric we're dealing with
'       game moves and the "[" we found at lPos2 must
'       be the first tag of a new game.
            Do
                sChar = Mid$(sText, lPos4, 1)
                If dhIsCharAlphanumeric(sChar) Then
                    Me.FromPos.Add (lPos2)
                    Me.GameNumbers.Add (Me.GameNumbers.Count + 1)
                    Me.ToPos.Add (lPos2 - 1)
                    Exit Do
                End If
                lPos4 = lPos4 + 1
            Loop Until lPos4 = lPos2 - 1
        End If
    End If
    
    
    lPos3 = InStr(lPos2 + 1, sText, "]")
    If lPos3 = 0 Then GoTo Abort
    sSubString = Mid$(sText, lPos2 + 1, lPos3 - lPos2 - 1)

'   Checks the tag. If it is either "White", "Black" or "Result"
'   it is added to the relevant collections.
    Call Me.CheckTag(sSubString)
    
    lPos1 = lPos3 + 1
Loop Until lPos1 = 0


Exit Sub
Abort:
MsgBox "Syntax error in Pgn file - missing ""]""", vbCritical, "Syntax error"
Exit Sub
ErrorHandler:
MsgBox Err.Description & vbNewLine & "Unexpected error in procedure ParseSimple in class module Pgn.", vbCritical, "Error"
End Sub

Public Property Set NestedEndTags(ByVal vData As Object)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.NestedEndTags = Form1
    Set mvarNestedEndTags = vData
End Property


Public Property Get NestedEndTags() As Collection
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.NestedEndTags
    Set NestedEndTags = mvarNestedEndTags
End Property



Public Property Set NestedStartTags(ByVal vData As Object)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.NestedStartTags = Form1
    Set mvarNestedStartTags = vData
End Property


Public Property Get NestedStartTags() As Collection
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.NestedStartTags
    Set NestedStartTags = mvarNestedStartTags
End Property



Public Sub CheckForNestedTags(sText As String)
'This is the first step in parsing a pgn file.
'The procedure checks if any Pgn start or end tags
'("[" or "]") are nested inside comments.
'This is not likely, but it must be checked.
'If any start or end tags are indeed nested, the
'positions are stored in the collections
'"NestedStartTags" and "NestedEndTags" for later reference.

Dim lPos1 As Long
Dim lPos2 As Long
Dim lPos3 As Long
Dim lPos4 As Long

On Error GoTo ErrorHandler

'The collections for nested positions are
'created (or emptied if they exist allready).
If Me.NestedStartTags Is Nothing Then
    Set Me.NestedStartTags = New Collection
Else
    With Me.NestedStartTags
        For lPos1 = .Count To 1 Step -1
            .Remove (lPos1)
        Next
    End With
End If

If Me.NestedEndTags Is Nothing Then
    Set Me.NestedEndTags = New Collection
Else
    With Me.NestedEndTags
        For lPos1 = .Count To 1 Step -1
            .Remove (lPos1)
        Next
    End With
End If

lPos1 = 1

'We now loop through the pgn file
Do
    lPos1 = InStr(lPos1, sText, "{")    'Find next comment begin
    If lPos1 = 0 Then Exit Do           'If none found we exit loop
    lPos2 = InStr(lPos1, sText, "}")    'Find next comment end
    If lPos2 = 0 Then GoTo Abort        'If none found we abort with error message
    lPos4 = lPos1
    
'   Now we check if there are any start tags nested
'   inside the comment. If there are, the positions
'   are stored in the collection NestedStartTags.
    With NestedStartTags
        Do
            lPos3 = InStr(lPos4 + 1, sText, "[")    'Find next "[" after comment begin.
            If lPos3 > lPos2 Or lPos3 = 0 Then      'If not nested then
                Exit Do                             'exit inner loop
            Else                                    'If inside comment
                .Add (lPos3)         'and store pointer in collection
            End If
            lPos4 = lPos3                           'Move start pointer
        Loop
    End With
        
    '   We now check for any nested "End tags" (])
        lPos4 = lPos1
    With NestedEndTags
        Do
            lPos3 = InStr(lPos4 + 1, sText, "]")
            If lPos3 > lPos2 Or lPos3 = 0 Then
                Exit Do
            Else
                .Add (lPos3)
            End If
            lPos4 = lPos3
        Loop
    End With
    lPos1 = lPos2 + 1   'Move pointer
Loop Until lPos1 = 0

Exit Sub
ErrorHandler:
MsgBox Err.Description & vbNewLine & "Unexpected error in procedure CheckForNestedTags.", vbCritical, "Error"
Exit Sub
Abort:
MsgBox "Error in pgn file. Missing ""}""", vbCritical, "Error in pgn file"
End Sub

Public Property Set ToPos(ByVal vData As Object)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.ToPos = Form1
    Set mvarToPos = vData
End Property


Public Property Get ToPos() As Collection
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.ToPos
    Set ToPos = mvarToPos
End Property



Public Property Set FromPos(ByVal vData As Object)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.FromPos = Form1
    Set mvarFromPos = vData
End Property


Public Property Get FromPos() As Collection
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.FromPos
    Set FromPos = mvarFromPos
End Property



Public Property Set Results(ByVal vData As Object)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.Results = Form1
    Set mvarResults = vData
End Property


Public Property Get Results() As Collection
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Results
    Set Results = mvarResults
End Property



Public Property Set BlackPlayers(ByVal vData As Object)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.BlackPlayers = Form1
    Set mvarBlackPlayers = vData
End Property


Public Property Get BlackPlayers() As Collection
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.BlackPlayers
    Set BlackPlayers = mvarBlackPlayers
End Property



Public Property Set WhitePlayers(ByVal vData As Object)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.WhitePlayers = Form1
    Set mvarWhitePlayers = vData
End Property


Public Property Get WhitePlayers() As Collection
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.WhitePlayers
    Set WhitePlayers = mvarWhitePlayers
End Property



Public Property Set GameNumbers(ByVal vData As Object)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.GameNumbers = Form1
    Set mvarGameNumbers = vData
End Property


Public Property Get GameNumbers() As Collection
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.GameNumbers
    Set GameNumbers = mvarGameNumbers
End Property



Public Sub MakeGameList()
Attribute MakeGameList.VB_Description = "Parses Pgn file and makes a list of the games."
'Makes a list of the games in the pgn file.
'The elements of the list are:
'1.Game number
'2.White Player
'3.Black Player
'4.Result
'5.From-to pointers (where in file)
'6.Events (P4 addition)
'7.Event of each game
'The elements are stored in 7 collections.

Dim bNestedStart As Boolean
Dim bNestedEnd As Boolean
Dim sText As String     'String to hold pgn text
Dim lPos1 As Long       'Pointer
Dim lPos2 As Long       '   -
Dim lPos3 As Long       '   -
Dim lPos4 As Long       '   -

On Error GoTo ErrorHandler

Screen.MousePointer = vbHourglass

Call LoadTextFile(Me.FilePath, sText)

If Len(sText) = 0 Then
    MsgBox "Empty pgn file", vbCritical, "No games in pgn file"
    GoTo Terminate
End If

'First we check if any tags ([tag]) are nested inside comments)
Call Me.CheckForNestedTags(sText)

'If there are no nested tags we free memory by setting the
'collections to nothing.
If Me.NestedStartTags.Count = 0 Then
    Set Me.NestedStartTags = Nothing
Else
    bNestedStart = True
End If

If Me.NestedEndTags.Count = 0 Then
    Set Me.NestedEndTags = Nothing
Else
    bNestedEnd = True
End If


'The necessary collections are initialised or
'emptied if they exist allready.
If GameNumbers Is Nothing Then
    Set GameNumbers = New Collection
Else
    Set GameNumbers = Nothing
    Set GameNumbers = New Collection
End If

If BlackPlayers Is Nothing Then
    Set BlackPlayers = New Collection
Else
    Set BlackPlayers = Nothing
    Set BlackPlayers = New Collection
End If

If WhitePlayers Is Nothing Then
    Set WhitePlayers = New Collection
Else
    Set WhitePlayers = Nothing
    Set WhitePlayers = New Collection
End If

If Results Is Nothing Then
    Set Results = New Collection
Else
    Set Results = Nothing
    Set Results = New Collection
End If

If FromPos Is Nothing Then
    Set FromPos = New Collection
Else
    Set FromPos = Nothing
    Set FromPos = New Collection
End If

If ToPos Is Nothing Then
    Set ToPos = New Collection
Else
    Set ToPos = Nothing
    Set ToPos = New Collection
End If

'P4 addition.
'An eventlist is created for use with magazines.
'Also a list with the event of each game.
If EventList Is Nothing Then
    Set EventList = New Collection
Else
    Set EventList = Nothing
    Set EventList = New Collection
End If

If GameEvents Is Nothing Then
    Set GameEvents = New Collection
Else
    Set GameEvents = Nothing
    Set GameEvents = New Collection
End If

lPos1 = 1
lPos2 = 1
lPos3 = 1
lPos4 = 1

'If there are no nested comments we call the
'ParseSimple procedure. Else we call the ParseAdvanced.
If bNestedStart = False And bNestedEnd = False Then
    Call Me.ParseSimple(sText, lPos1, lPos2, lPos3, lPos4)
Else
    Call Me.ParseAdvanced(sText, lPos1, lPos2, lPos3, lPos4)
End If

sText = Empty

Set NestedStartTags = Nothing
Set NestedEndTags = Nothing

Screen.MousePointer = vbDefault

Exit Sub
ErrorHandler:
Screen.MousePointer = vbDefault
MsgBox Err.Description & vbNewLine & "Unexpected error in procedure MakeGameList.", vbCritical, "Error"
Exit Sub
Terminate:
Screen.MousePointer = vbDefault
TerminateWebProject
End Sub

Public Property Let FilePath(ByVal vData As String)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.FilePath = 5
    mvarFilePath = vData
End Property


Public Property Get FilePath() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.FilePath
    FilePath = mvarFilePath
End Property

Public Sub MakePlayerList()

Dim lCount As Long
Dim lCount2 As Long
Dim sPlayer As String
Dim vPlayer As Player
Dim bTwin As Boolean

On Error GoTo ErrorHandler

'If Me.Players.Count > 0 Then
'    Exit Sub
'End If

If Me.WhitePlayers Is Nothing Then
    Me.MakeGameList
End If

Set vPlayer = New Player

bTwin = False

For lCount = 1 To Me.WhitePlayers.Count
    sPlayer = Me.WhitePlayers(lCount)
    bTwin = False
    For Each vPlayer In Me.Players
        If sPlayer = vPlayer.Key Then
            bTwin = True
            Exit For
        End If
    Next
    If bTwin = False Then
        Me.Players.Add sPlayer, sPlayer
    End If
Next

For lCount = 1 To Me.BlackPlayers.Count
    sPlayer = Me.BlackPlayers(lCount)
    bTwin = False
    For Each vPlayer In Me.Players
        If sPlayer = vPlayer.Key Then
            bTwin = True
            Exit For
        End If
    Next
    If bTwin = False Then
        Me.Players.Add sPlayer, sPlayer
    End If
Next

Set vPlayer = Nothing

Exit Sub
ErrorHandler:
MsgBox Err.Description & vbNewLine & _
"Error creating players list from the pgn file. Procedure MakePlayerList in class Pgn.", , "Error"
End Sub





Private Sub Class_Initialize()
    #If DebugMode Then
        'get the next available class ID, and print out
        'that the class was created successfully
        mlClassDebugID = GetNextClassDebugID()
        Debug.Print "'" & TypeName(Me) & "' instance " & mlClassDebugID & " created"
    #End If
    
End Sub


Private Sub Class_Terminate()

Set Players = Nothing
Set BlackPlayers = Nothing
Set WhitePlayers = Nothing
Set GameNumbers = Nothing
Set Results = Nothing
Set EventList = Nothing
Set PlayerList = Nothing
Set HtmlNames = Nothing
Set GameEvents = Nothing
Set ToPos = Nothing
Set FromPos = Nothing

    'the class is being destroyed
    #If DebugMode Then
        Debug.Print "'" & TypeName(Me) & "' instance " & CStr(mlClassDebugID) & " is terminating"
    #End If
End Sub


#If DebugMode Then
    Public Property Get ClassDebugID()
        'if we are in debug mode, surface this property that consumers can query
        ClassDebugID = mlClassDebugID
    End Property
#End If

Public Property Set GameEvents(ByVal vData As Object)
    Set mvarGameEvents = vData
End Property
Public Property Get GameEvents() As Collection
    Set GameEvents = mvarGameEvents
End Property
Public Property Set EventList(ByVal vData As Object)
    Set mvarEventList = vData
End Property
Public Property Get EventList() As Collection
    Set EventList = mvarEventList
End Property
Public Property Get Players() As Players
    If mvarPlayers Is Nothing Then
        Set mvarPlayers = New Players
    End If
    Set Players = mvarPlayers
End Property
Public Property Set Players(vData As Players)
    Set mvarPlayers = vData
End Property
Public Property Set PlayerList(ByVal vData As Object)
    Set mvarPlayerList = vData
End Property
Public Property Get PlayerList() As Collection
    Set PlayerList = mvarPlayerList
End Property
Public Property Let TempFile(ByVal vData As Boolean)
    mvarTempFile = vData
End Property
Public Property Get TempFile() As Boolean
    TempFile = mvarTempFile
End Property
Public Property Let HtmlFirstPage(ByVal vData As String)
    mvarHtmlFirstPage = vData
End Property
Public Property Get HtmlFirstPage() As String
    HtmlFirstPage = mvarHtmlFirstPage
End Property
Public Property Let PgnDir(ByVal vData As String)
'Saves the directory path of the selected pgn file,
'e.g. "C:\pgn\".
    mvarPgnDir = vData
End Property
Public Property Get PgnDir() As String
    PgnDir = mvarPgnDir
End Property
Public Property Set HtmlNames(ByVal vData As Object)
    Set mvarHtmlNames = vData
End Property
Public Property Get HtmlNames() As Collection
    Set HtmlNames = mvarHtmlNames
End Property
Public Property Let Changed(ByVal vData As Boolean)
    mvarChanged = vData
End Property
Public Property Get Changed() As Boolean
    Changed = mvarChanged
End Property

