VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "Players"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"No"
Attribute VB_Ext_KEY = "Collection" ,"Player"
Attribute VB_Ext_KEY = "Member0" ,"Player"
Option Explicit
Option Compare Text
'local variable to hold collection
Private mCol As Collection
Private mvarSelected As Long 'local copy
Public Sub ImportNames()
Attribute ImportNames.VB_Description = "Imports player names that were read from the ini file. The player names + title, elo etc. are stored as strings in the cLayouts(lal).ini3.Player collection."
'This procedure imports player information into the pgn file's
'players list. The information is imported from the ini3-class'
'Player-collection, which was built when player info was read
'from the style's ini file.

Dim vAnswer As Variant      'Users answer to messagebox
Dim vPlayer As Variant      'Variable to hold info string

On Error GoTo ErrorHandler

With cLayouts(lAL).Ini3
    vAnswer = MsgBox("The original ini file contains information about " & _
    .Player.Count & " players. Do you want to keep this information?", vbYesNo, "Import Player Info?")

    If vAnswer = vbNo Then
        Set .Player = Nothing
        Set .Player = New Collection
        Exit Sub
    End If

    'Fills this class' collection with player names from the pgn file.
    cWebPages(lAW).PgnFiles(lAP).MakePlayerList

    'Imports the player info from the ini3 class
    For Each vPlayer In .Player
        Call ParsePlayerInfo(vPlayer)
    Next
End With

Set vPlayer = Nothing

Exit Sub
ErrorHandler:
MsgBox Err.Description & vbNewLine & _
"Error importing player info from the original ini file.", vbCritical, "Error"

End Sub

Public Sub ParsePlayerInfo(ByVal sInfo As String)
'Parses the player information string from the original ini file.
Dim lPos As Long            'Pointer
Dim lPos2 As Long           'Pointer
Dim bInBase As Boolean      'True if an impoted player name is already in the base.
Dim sName As String         'Imported player name
Dim sString As String       'String parsed
Dim sCountry As String      'Imported country code
Dim sTitle As String        'Imported player title
Dim sElo As String          'Imported player elo
Dim sPelo As String         'Imported player performance elo
Dim vPlayer As Player       'Player class variable

On Error GoTo ErrorHandler

bInBase = False

'First we find the name
lPos = InStr(1, sInfo, ":")
If lPos = 0 Then Exit Sub

sName = Mid$(sInfo, 1, lPos - 1)
'   We now check if the name is already in the collection.
For Each vPlayer In Me
    If sName = vPlayer.Key Then
        bInBase = True
        Exit For
    End If
Next

If bInBase = False Then
    Me.Add sName, sName
End If

'Sets flag for selected
Me(sName).InBase = True

'We now find the title (if any)
sString = Right$(sInfo, Len(sInfo) - lPos)
lPos2 = InStr(1, sString, ":")
If lPos2 = 0 Then
    If Len(sString) > 0 Then
        Me(sName).Title = sString
    End If
    Exit Sub
End If
sTitle = Mid$(sString, 1, lPos2 - 1)
Me(sName).Title = sTitle

'We now find the elo (if any)
sString = Right$(sString, Len(sString) - lPos2)
lPos = InStr(1, sString, ":")
If lPos = 0 Then
    If Len(sString) > 0 Then
        Me(sName).Elo = sString
    End If
    Exit Sub
End If
sElo = Mid$(sString, 1, lPos - 1)
Me(sName).Elo = sElo

'We now find the country code (if any)
sString = Right$(sString, Len(sString) - lPos)
lPos2 = InStr(1, sString, ":")
If lPos2 = 0 Then
    If Len(sString) > 0 Then
        Me(sName).CountryCode = sString
    End If
    Exit Sub
End If
sCountry = Mid$(sString, 1, lPos2 - 1)
Me(sName).Title = sCountry

'Lastly we find any performance elo
sString = Right$(sString, Len(sString) - lPos2)
lPos = InStr(1, sString, ":")
If lPos = 0 Then
    If Len(sString) > 0 Then
        Me(sName).PerformanceElo = sString
    End If
    Exit Sub
End If
sPelo = Mid$(sString, 1, lPos2 - 1)
Me(sName).PerformanceElo = sPelo


Set vPlayer = Nothing

Exit Sub
ErrorHandler:
Set vPlayer = Nothing
MsgBox Err.Description & vbNewLine & _
"Error parsing player information string from ini file. Import may have failed.", vbCritical, "Error"
End Sub

Public Property Let Selected(ByVal vData As Long)
Attribute Selected.VB_Description = "Number of selected players on the list."
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.Selected = 5
    mvarSelected = vData
End Property


Public Property Get Selected() As Long
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Selected
    Selected = mvarSelected
End Property



Public Function Add(Key As String, Optional sKey As String) As Player
    'create a new object
    Dim objNewMember As Player
    Set objNewMember = New Player


    'set the properties passed into the method
    objNewMember.Key = Key




    If Len(sKey) = 0 Then
        mCol.Add objNewMember
    Else
        mCol.Add objNewMember, sKey
    End If


    'return the object created
    Set Add = objNewMember
    Set objNewMember = Nothing


End Function

Public Property Get Item(vntIndexKey As Variant) As Player
Attribute Item.VB_UserMemId = 0
    'used when referencing an element in the collection
    'vntIndexKey contains either the Index or Key to the collection,
    'this is why it is declared as a Variant
    'Syntax: Set foo = x.Item(xyz) or Set foo = x.Item(5)
  Set Item = mCol(vntIndexKey)
End Property



Public Property Get Count() As Long
    'used when retrieving the number of elements in the
    'collection. Syntax: Debug.Print x.Count
    Count = mCol.Count
End Property


Public Sub Remove(vntIndexKey As Variant)
    'used when removing an element from the collection
    'vntIndexKey contains either the Index or Key, which is why
    'it is declared as a Variant
    'Syntax: x.Remove(xyz)


    mCol.Remove vntIndexKey
End Sub


Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    'this property allows you to enumerate
    'this collection with the For...Each syntax
    Set NewEnum = mCol.[_NewEnum]
End Property


Private Sub Class_Initialize()
    'creates the collection when this class is created
    Set mCol = New Collection
End Sub


Private Sub Class_Terminate()
    'destroys collection when this class is terminated
    Set mCol = Nothing
End Sub

