VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "Styles"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"Style"
Attribute VB_Ext_KEY = "Member0" ,"Style"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

'local variable to hold collection
Private mCol As Collection
Public Function Add(Key As String, Optional sKey As String) As Style
    'create a new object
    Dim objNewMember As Style
    Set objNewMember = New Style

    'set the properties passed into the method
    objNewMember.Key = Key

    'set the properties passed into the method
    If Len(sKey) = 0 Then
        mCol.Add objNewMember
    Else
        mCol.Add objNewMember, sKey
    End If


    'return the object created
    Set Add = objNewMember
    Set objNewMember = Nothing


End Function
Public Sub InitStyles()
Attribute InitStyles.VB_Description = "Reads the layouts file and adds each layout as a style."

On Error GoTo ErrorHandle

Me.ReadLayoutList

If bAbort Then
    bAbort = False
    Exit Sub
End If

Exit Sub
ErrorHandle:
MsgBox Err.Description & vbNewLine & "Procedure InitStyles, class Styles", vbCritical, "Error"
End Sub

Sub ReadLayoutList()
'Builds a list with available layouts and shows
'it to the user.

Dim bLoadCheck As Boolean
Dim bLoaded As Boolean
Dim sPath As String
Dim sText As String
Dim sKeyword As String
Dim sValue As String
Dim cLayoutClass As Layout
Dim lPos As Long
Dim lPos2 As Long
Dim lPos3 As Long
Dim sChar As String * 1

On Error GoTo ErrorHandler

lASty = Me.Count

sPath = App.path & "\Resource\layouts.lst"
If FileCheck(sPath) Then
    Call LoadTextFile(sPath, sText)
Else
    MsgBox "No layouts available. You must make a new one.", , "No Layouts"
    bAbort = True
    Exit Sub
End If

bLoadCheck = False
bLoaded = False

'If there's at least one layout loaded, we set a flag to check
'if the layout is already loaded.
If Not (cLayouts Is Nothing) Then
    If cLayouts.Count > 0 Then
        bLoadCheck = True
    End If
End If

lPos = 1
lPos2 = 1

'We now parse the list of layouts loaded from the
'file layouts.lst.
Do
    Do
        If lPos >= Len(sText) Then GoTo ByBy        'If EOF exit
        lPos2 = NextLine(sText, lPos + 1)           'Find next linefeed.
        If lPos2 = 0 Then GoTo ByBy                 'If none exit
        sChar = Mid$(sText, lPos, 1)                'sChar is set = next char.
        If dhIsCharAlphanumeric(sChar) = False Then 'If sChar isn't alfanumeric
            lPos = lPos2 + 1                        'we move the pointer forward.
        Else
            lPos3 = InStr(lPos, sText, "=")         'Find position of "="
            If lPos3 > 0 Then                       'If found exit loop
                Exit Do
            Else
                lPos = lPos2 + 1                    'If not found move pointer forward
            End If
        End If
    Loop
    
    sKeyword = Mid$(sText, lPos, lPos3 - lPos)              'Extract selector/keyword
    sChar = Mid$(sText, lPos3 + 1, 1)                       'First char after the "="
    If dhIsCharAlphanumeric(sChar) = True Then              'If alfanumeric
        sValue = Mid$(sText, lPos3 + 1, lPos2 - 2 - lPos3)  'we extract the value.
    Else
        sValue = ""                                         'Else the string is empty.
    End If
    
'   We check if the layout is loaded already. If affirmative
'   the layout will be skipped.
    If bLoadCheck And sKeyword = "LayoutName" Then
        bLoaded = False
        For Each cLayoutClass In cLayouts
            If sValue = cLayoutClass.Key Then
                bLoaded = True
                Exit For
            End If
        Next
    End If
    
    Set cLayoutClass = Nothing

'   If the layout isn't loaded already, we add it and its
'   properties to the relevant collections.
    If bLoaded = False Then
'       We now add the values to the relevant collections
'       depending on the keyword.
        Select Case sKeyword
            Case "LayoutName"
                Me.Add sValue, sValue
                lASty = Me.Count
            Case "Description"
                Me(lASty).Description = sValue
            Case "sHtmlType"    'P4 addition
                Me(lASty).HtmlType = sValue
            Case "sPathPieces"
                Me(lASty).Pathpieces = sValue
            Case "sPathBoard"
                Me(lASty).PathBoard = sValue
            Case "sPathConpanel"
                Me(lASty).PathConpanel = sValue
            Case "sPathSymbols"
                Me(lASty).PathSymbols = sValue
            Case "sPathBGImage"
                Me(lASty).PathBGImage = sValue
            Case "sPathHtml"
                Me(lASty).PathHtml = sValue
            Case "sPathRedirect"
                Me(lASty).PathRedirect = sValue
            Case "sPathCss"
                Me(lASty).PathCss = sValue
            Case "sPathFenImg"
                Me(lASty).PathFenImg = sValue
            Case "sPathFlags"
                Me(lASty).PathFlags = sValue
            Case "sPathBGCrossImage"
                Me(lASty).PathBGCrossImage = sValue
            Case "sPathCrossSource"
                Me(lASty).PathCrossSource = sValue
            Case "sPathIframeCssSource"
                Me(lASty).PathIframeCssSource = sValue
            Case "sPathBGIframeImage"
                Me(lASty).PathBGIframeImage = sValue
            Case "sPathHelpImg"
                Me(lASty).PathHelpImg = sValue
            Case "sPathHelpUrl"
                Me(lASty).PathHelpUrl = sValue
            Case "sPathIndexCss"
                Me(lASty).PathIndexCss = sValue
            Case "sPathMagazineCss"
                Me(lASty).PathMagazineCss = sValue
            Case "sPathMailtoImg"
                Me(lASty).PathMailtoImg = sValue
            Case Else
                MsgBox "Error in file Layouts.lst"
                Exit Sub
        End Select
    End If

    lPos = lPos2 + 1    'Move pointer forward
Loop

ByBy:

Exit Sub
ErrorHandler:
MsgBox Err.Description & vbNewLine & "An error occurred in procedure ReadLayoutList", vbCritical + vbOKOnly, "Error"
Set colPathPieces = Nothing
Set colPathBoard = Nothing
Set colPathConpanel = Nothing
Set colPathSymbols = Nothing
Set colPathBGImage = Nothing
Set colPathHtml = Nothing
Set colPathRedirect = Nothing
Set colPathCss = Nothing
Set colPathFenImg = Nothing
Set colPathFlags = Nothing
Set colPathBGCrossImage = Nothing
Set colPathCrossSource = Nothing
Set colPathBGIframeImage = Nothing
Set colPathIframeCssSource = Nothing
bAbort = True
Exit Sub
Terminate:
bAbort = True
End Sub

Public Property Get Item(vntIndexKey As Variant) As Style
Attribute Item.VB_UserMemId = 0
    'used when referencing an element in the collection
    'vntIndexKey contains either the Index or Key to the collection,
    'this is why it is declared as a Variant
    'Syntax: Set foo = x.Item(xyz) or Set foo = x.Item(5)
  Set Item = mCol(vntIndexKey)
End Property



Public Property Get Count() As Long
    'used when retrieving the number of elements in the
    'collection. Syntax: Debug.Print x.Count
    Count = mCol.Count
End Property


Public Sub Remove(vntIndexKey As Variant)
    'used when removing an element from the collection
    'vntIndexKey contains either the Index or Key, which is why
    'it is declared as a Variant
    'Syntax: x.Remove(xyz)


    mCol.Remove vntIndexKey
End Sub


Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    'this property allows you to enumerate
    'this collection with the For...Each syntax
    Set NewEnum = mCol.[_NewEnum]
End Property


Private Sub Class_Initialize()
    'creates the collection when this class is created
    Set mCol = New Collection
End Sub


Private Sub Class_Terminate()
    'destroys collection when this class is terminated
    Set mCol = Nothing
End Sub

