VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "WebPage"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"No"
Attribute VB_Ext_KEY = "Member0" ,"Layout"
Attribute VB_Ext_KEY = "Member1" ,"Magazine"
Attribute VB_Ext_KEY = "Member2" ,"PgnFiles"
Option Explicit

'set this to 0 to disable debug code in this class
#Const DebugMode = 1


#If DebugMode Then
    'local variable to hold the serialized class ID that was created in Class_Initialize
    Private mlClassDebugID As Long
#End If
Public Key As String
'local variable(s) to hold property value(s)
Private mvarLayout As Layout 'local copy
Private mvarPgnFiles As PgnFiles 'local copy
Private mvarMultiplePgn As Boolean 'local copy
Private mvarPathHtml As String 'local copy
Private mvarPathWebCss As String 'local copy
Private mvarHtmlFileNames As Collection 'local copy
Private mvarPreviewed As Boolean 'local copy
Private mvarCrossLinkTable As Boolean 'local copy
Private mvarCrossTableNoLinks As Boolean 'local copy
Private mvarSaved As Boolean 'local copy
Private mvarChanged As Boolean 'local copy
Private mvarFormCreated As Boolean 'local copy
Private mvarActiveSheet As String 'local copy
Private mvarPropWindowVisible As Boolean 'local copy
Private mvarPropertyList As Collection 'local copy
Private mvarOldPageType As String 'local copy
Private mvarHtmlTemplate As String 'local copy
Private mvarMagazine As Magazine
Private mvarHtmlTemplateName As String 'local copy
Private mvarDatYongest As Date 'local copy
Private mvarFilesToCopyAndKill As Collection 'local copy
'local variable(s) to hold property value(s)
Private mvarPgnEditorOpen As Boolean 'local copy
Public Property Let PgnEditorOpen(ByVal vData As Boolean)
Attribute PgnEditorOpen.VB_Description = "Flag. True if the pgn file editor is open displaying the webpage's pgn file text. Used to activate/de-activate the View-menu's pgneditor menu."
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.PgnEditorOpen = 5
    mvarPgnEditorOpen = vData
End Property


Public Property Get PgnEditorOpen() As Boolean
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.PgnEditorOpen
    PgnEditorOpen = mvarPgnEditorOpen
End Property



Public Property Set FilesToCopyAndKill(ByVal vData As Object)
Attribute FilesToCopyAndKill.VB_Description = "Collection of files to copy and/or kill. The files are the ones that are younger than DatYoungest. Used when making a magazine, where it isn't known beforehand how many files will be created."
    Set mvarFilesToCopyAndKill = vData
End Property
Public Property Get FilesToCopyAndKill() As Collection
    Set FilesToCopyAndKill = mvarFilesToCopyAndKill
End Property
Public Property Let DatYongest(ByVal vData As Date)
Attribute DatYongest.VB_Description = "FileDateTime of youngest file in a directory. Used to find newer files for copying and deletion."
    mvarDatYongest = vData
End Property
Public Property Get DatYongest() As Date
    DatYongest = mvarDatYongest
End Property
Public Property Get Magazine() As Magazine
    Set Magazine = mvarMagazine
End Property
Public Property Set Magazine(vData As Magazine)
    Set mvarMagazine = vData
End Property
Public Property Let OldPageType(ByVal vData As String)
Attribute OldPageType.VB_Description = "If the basic page style is changed from the Page menu, the old page style (e.g. ""normal"") is saved in this property. This enables the program to restore the htmltype if the conversion fails. This could happen if there are no available stylesheets for crosstables."
'When the basic page style is changed, the old htmlstyle
'is saved here. This enables us to restore if it turns out
'that we can't go through with the new page style - for
'instance if there are no crosstable stylesheets available.
    mvarOldPageType = vData
End Property
Public Property Get OldPageType() As String

'Syntax: Debug.Print X.OldPageType
    OldPageType = mvarOldPageType
End Property
Public Sub MakeIframeCss()
Attribute MakeIframeCss.VB_Description = "Controls what is necessary for using a separate stylesheet for Iframes (shtmltype = ""iframe"" or ""muliframe"")."
'Does what is necessary to use a separate stylesheet for Iframes.
Dim sSource As String
Dim sTarget As String
Dim vAnswer As Variant
Dim fForm As Form

On Error GoTo ErrorHandler

'If there's no IframeCss selected we make a collection of
'the available stylesheets and ask the user to pick one.
If cLayouts(lAL).PathIframeCssSource = Empty Then
'   Make the collection of available stylesheets
    MakeIFCssCollection
    
'   If there are no stylesheets available we exit
    If colIframeStyles.Count = 0 Then
        MsgBox "There are no available stylesheets for Iframes.", vbInformation, "Sorry"
        Set colIframeStyles = Nothing
        Exit Sub
    End If
    
    sAction = "Select Stylesheet For Iframe"
'   The user is asked to select a stylesheet for the Iframe
    frmLayouts.Show vbModal, fMainForm
    sAction = Empty
    
'   If none were selected we abort
    If bAbort Then
        Set colIframeStyles = Nothing
        bAbort = False
        Exit Sub
    End If
End If

With cLayouts(lAL)
    Set .Iframe = New Iframe
        
    sTarget = .PathWebCss & "\" & .IframeCssName
    .PathWebIframeCss = .PathWebCss
    sSource = .PathIframeCssSource
    If FileCheck(sTarget) Then
        vAnswer = MsgBox("PalMate will now replace an older version of the " & _
        "stylesheet " & .IframeCssName & ". The file will be " & _
        "replaced anyway when you preview the page, so if you want to save it " & _
        "select ""No"" below." & vbNewLine & vbNewLine & _
        "Replace now?", vbQuestion + vbYesNo, "Replace " & .IframeCssName & " Now?")
        If vAnswer = vbYes Then
            Call CopyFile(sSource, sTarget)
        Else
            If Len(sFilesToRemember) = 0 Then
                sFilesToRemember = sTarget
            Else
                sFilesToRemember = sFilesToRemember & ", " & sTarget
            End If
        End If
    End If
    
    Call .Iframe.HandleCss(cLayouts(lAL).PathIframeCssSource)

'   Finds the project's frmPgnText form and initialises
'   the treeview window for the I-frame stylesheet.
    For Each fForm In Forms
        If fForm.Caption = .CaptionName Then
            fForm.InitIframeTree
            Exit For
        End If
    Next
End With

Set colIframeStyles = Nothing


Exit Sub

ErrorHandler:
Set colIframeStyles = Nothing
MsgBox Err.Description & vbNewLine & _
"Error in procedure MakeIframeCs in class ""Webpage"".", vbCritical, "Error"
End Sub

Public Sub MakePropertyList()
Attribute MakePropertyList.VB_Description = "Builds a collection with the webpage project's properties for the properties window."
'Makes a collection (PropertyList) with the webpage project's properties

Dim cBlock As CssBlock
Dim vObject As Variant
Dim lCount As Long
Dim sHtmlType As String

On Error GoTo ErrorHandler

Set Me.PropertyList = Nothing
Set Me.PropertyList = New Collection
    
With cLayouts(lAL)
    sHtmlType = .Ini2.HtmlType
'   Header
    PropertyList.Add "Below is a list of files. Changed or new files must be uploaded, " & _
    "but of course there's no need to upload files like e.g. images if " & _
    "they are already on the server and haven't changed."
    
    PropertyList.Add vbNewLine
    
'   Style description
    PropertyList.Add "STYLE:"
    PropertyList.Add .Key
    If Len(.Description) > 0 Then
        PropertyList.Add vbNewLine
        PropertyList.Add "STYLE DESCRIPTION:"
        PropertyList.Add .Description
    End If
    PropertyList.Add vbNewLine
    
'   HTML files to upload
    PropertyList.Add "HTML FILES TO UPLOAD:"
    PropertyList.Add "Path: " & .PathHtml
    For Each vObject In Me.HtmlFileNames
        PropertyList.Add vObject
    Next
    If sHtmlType = "magazine" Then
        PropertyList.Add "In addition there will be an htm file for each gamelink!!!"
    End If
    PropertyList.Add vbNewLine
    
    If .Ini2.JsFile = "on" Then
    PropertyList.Add "JAVASCRIPT FILES TO UPLOAD:"
    PropertyList.Add .Key & ".js"
    PropertyList.Add vbNewLine
    End If
    
    
'   Stylesheets to upload
    PropertyList.Add "STYLESHEETS TO UPLOAD:"
    If Me.CrossTableNoLinks = False Then
        PropertyList.Add "Path: " & .PathWebCss
        'P4 change
        If cLayouts(lAL).Ini2.HtmlType <> "magazine" Then
            PropertyList.Add .StyleSheetName & "  - URL: " & """" & .Ini3.sStyleSheet & """"
        Else
            PropertyList.Add .StyleSheetName & "  - URL: " & """" & .Ini3.MagazineCss & """"
        End If
    End If
    If sHtmlType = "batch" Then
        PropertyList.Add .CrossStylesheetName & "  - URL: " & """" & .Ini3.CrossTableCss & """"
    End If
    If sHtmlType = "iframe" Or sHtmlType = "muliframe" Or sHtmlType = "magviewer" Then
        If Not (.Iframe Is Nothing) Then
            PropertyList.Add .IframeCssName & "  - URL: " & """" & .Ini3.IframeCss & """"
        End If
    End If
    PropertyList.Add vbNewLine
    
'   PGN files to upload
    If Me.CrossTableNoLinks = False Then
        If .Ini1.PgnLink > 0 Then
            PropertyList.Add "PGN FILES TO UPLOAD:"
            PropertyList.Add "Path: " & Me.PgnFiles(lAP).PgnDir
            For Each vObject In Me.PgnFiles
                PropertyList.Add vObject.Key & "   URL: " & """" & .Ini3.PgnUrl & """"
            Next
            PropertyList.Add vbNewLine
        End If
    End If
    
'   Images to upload
    PropertyList.Add "IMAGES TO UPLOAD:"
    PropertyList.Add "Must be on the server to display the page(s) properly."

    If Me.CrossTableNoLinks = False Then
        PropertyList.Add vbNewLine
        PropertyList.Add "Chessboard:  " & .PathBoardImage & "  - URL: " & """" & .Ini3.BoardImage & """"
        PropertyList.Add "Chess pieces images in:  " & .Pathpieces & "  - URL: " & """" & .Ini3.ImgUrl & """"
        PropertyList.Add "Control panel(s):  " & .PathConpanel & "  - URL: " & """" & .Ini3.ConpanUrl & "/" & .Ini3.ControlPanelName
        If .Ini2.SymbolMethod = "gif" Then
            PropertyList.Add "Annotation symbols in:  " & .PathSymbols & "  - URL: " & """" & .Ini3.SymUrl & """"
        End If
    End If

    If .Ini2.Flags = "on" Then
        PropertyList.Add "Flag images in:  " & .PathFlags & "  - URL: " & """" & .Ini3.FlagUrl & """"
    End If
    
'   PGN link gif
    If .Ini1.PgnLink = 2 Then
        PropertyList.Add "Pgn link image: pgn.gif: " & "   URL: " & """" & .Ini3.ImgUrl & "/pgn.gif" & """"
    End If

'   Images used by stylesheets
    If cWebPages(lAW).CrossTableNoLinks = False Then
        For Each cBlock In .StyleSheet
            If Len(cBlock.PathBackgroundImage) > 0 Then
                PropertyList.Add "Stylesheet Background:  " & cBlock.PathBackgroundImage & "  - URL relative to stylesheet: " & """" & cBlock.BackgroundImage & """"
            End If
        Next
    End If
    
    If sHtmlType = "batch" Then
        For lCount = 1 To .CrossStyle.Count
            If Len(.CrossStyle(lCount).PathBackgroundImage) > 0 Then
                PropertyList.Add "Crosstable Stylesheet Background:  " & .CrossStyle(lCount).PathBackgroundImage & "  - URL relative to stylesheet: " & """" & .CrossStyle(lCount).BackgroundImage & """"
            End If
        Next
    End If
    
    PropertyList.Add vbNewLine
    
'   Header & Footer files
    If Len(.Ini3.HeaderFile) > 0 Or Len(.Ini3.FooterFile) > 0 Then
        PropertyList.Add "HEADER AND FOOTER FILES TO UPLOAD:"
        PropertyList.Add "Must be on the server to display the page(s) properly."
        PropertyList.Add vbNewLine
        PropertyList.Add "Path: " & Me.PgnFiles(lAP).PgnDir
        If Len(.Ini3.HeaderFile) > 0 Then
            PropertyList.Add .Ini3.HeaderFile
        End If
        If Len(.Ini3.FooterFile) > 0 Then
            PropertyList.Add .Ini3.FooterFile
        End If
        PropertyList.Add vbNewLine
    End If
    
'   Copy of ini file
    .WriteNewIni
    PropertyList.Add "**********************************"
    PropertyList.Add "PALVIEW INI FILE (no need to upload this!)"
    PropertyList.Add vbNewLine
    PropertyList.Add .NewIni
    .NewIni = Empty
    PropertyList.Add vbNewLine
    
'   Copy of stylesheets
    PropertyList.Add "**********************************"
    If sHtmlType <> "batch" Or Me.CrossLinkTable Then
        PropertyList.Add "WEBPAGE STYLESHEET"
        PropertyList.Add "Must be on the server to display the page(s) properly."
        PropertyList.Add vbNewLine
        .StyleSheet.WriteNewCss
        PropertyList.Add .StyleSheet.NewCss
        .StyleSheet.NewCss = Empty
        PropertyList.Add vbNewLine
    End If
    If Me.CrossTableNoLinks Or Me.CrossLinkTable Then
        PropertyList.Add "**********************************"
        PropertyList.Add "CROSSTABLE STYLESHEET"
        PropertyList.Add "Must be on the server to display the page properly."
        PropertyList.Add vbNewLine
        .CrossStyle.WriteNewCss
        PropertyList.Add .CrossStyle.NewCss
        .CrossStyle.NewCss = Empty
    End If
    If sHtmlType = "iframe" Or sHtmlType = "muliframe" Or sHtmlType = "magviewer" Then
        If Not (.Iframe Is Nothing) Then
            PropertyList.Add "IFRAME STYLESHEET"
            PropertyList.Add "Must be on the server to display the page properly."
            PropertyList.Add vbNewLine
            .Iframe.WriteNewCss
            PropertyList.Add .Iframe.NewCss
            .Iframe.NewCss = Empty
        End If
    End If
End With

Set vObject = Nothing
Set cBlock = Nothing

Exit Sub
ErrorHandler:
Set vObject = Nothing
Set cBlock = Nothing
MsgBox Err.Description & vbNewLine & _
"Error making list with webpage properties. Procedure MakePropertyList in Class Webpage.", vbCritical, "Error"
End Sub
Public Property Set PropertyList(ByVal vData As Object)
Attribute PropertyList.VB_Description = "Collection of the webpage projects properties. Used to for the properties window."
    Set mvarPropertyList = vData
End Property
Public Property Get PropertyList() As Collection
    Set PropertyList = mvarPropertyList
End Property
Public Property Let PropWindowVisible(ByVal vData As Boolean)
Attribute PropWindowVisible.VB_Description = "Flag. True if window (copy of frmDocument) with webpage properties is visivble/open."
    mvarPropWindowVisible = vData
End Property
Public Property Get PropWindowVisible() As Boolean
    PropWindowVisible = mvarPropWindowVisible
End Property
Public Property Let ActiveSheet(ByVal vData As String)
Attribute ActiveSheet.VB_Description = "The project's active stylesheet. This can for instance be either the ordinary stylesheet or the crosstable stylesheet. The property is used as a flag to determine which stylesheet is presently the active one."
    mvarActiveSheet = vData
End Property
Public Property Get ActiveSheet() As String
    ActiveSheet = mvarActiveSheet
End Property
Public Property Let FormCreated(ByVal vData As Boolean)
Attribute FormCreated.VB_Description = "True if there's an active form (frmPgnText)."
    mvarFormCreated = vData
End Property
Public Property Get FormCreated() As Boolean
    FormCreated = mvarFormCreated
End Property
Public Sub SavePage()
Attribute SavePage.VB_Description = "Processes the project so the files are saved."

On Error GoTo ErrorHandler

bpubSaveProject = True

With cLayouts(lAL)
    .StyleSheet.Changed = True
    .Ini1.Changed = True
    .Ini2.Changed = True
    .Ini3.Changed = True
    If Not (.CrossStyle Is Nothing) Then
        .CrossStyle.Changed = True
    End If
End With

cLayouts.SaveLayout

SaveProject
bpubSaveProject = False

Exit Sub
ErrorHandler:
MsgBox Err.Description & vbNewLine & "An error occurred saving the web page.", vbCritical, "Error"

End Sub
Public Property Let Changed(ByVal vData As Boolean)
Attribute Changed.VB_Description = "True if anything (layout etc.) has been changed since the last save-action."
    mvarChanged = vData
    If mvarChanged = True Then
        Me.Saved = False
    End If
End Property
Public Property Get Changed() As Boolean
    Changed = mvarChanged
End Property
Public Property Let Saved(ByVal vData As Boolean)
Attribute Saved.VB_Description = "True if the project has been saved since the last change. False if the layout or pgn file has been changed since the last save-action."
    mvarSaved = vData
    If mvarSaved Then
        Me.Changed = False
    End If
End Property
Public Property Get Saved() As Boolean
    Saved = mvarSaved
End Property
Public Property Let CrossTableNoLinks(ByVal vData As Boolean)
Attribute CrossTableNoLinks.VB_Description = "True if it is a page with a crosstable with NO links to game pages."
    mvarCrossTableNoLinks = vData
End Property
Public Property Get CrossTableNoLinks() As Boolean
    CrossTableNoLinks = mvarCrossTableNoLinks
End Property
Public Property Let CrossLinkTable(ByVal vData As Boolean)
Attribute CrossLinkTable.VB_Description = "True if the page contains a crosstable with links to game pages."
    mvarCrossLinkTable = vData
    UpdateMenu
End Property
Public Property Get CrossLinkTable() As Boolean
    CrossLinkTable = mvarCrossLinkTable
End Property
Public Sub ConvertToCrosstable()
Attribute ConvertToCrosstable.VB_Description = "Converts a webpage to a non-linked crosstable page."
'Converts a webpage to a crosstable page, with or without games.
Dim fForm As Form
Dim vAnswer As Variant
Dim sTarget As String

On Error GoTo ErrorHandler

Screen.MousePointer = vbHourglass

Me.Layout.Ini1.RefreshTime = 0

'Calls the public procedure in Module1 to
'make a collection of available crosstable stylesheets.
MakeCssCollection

With cLayouts(lAL)
    Set .CrossStyle = Nothing
    Set .CrossStyle = New CrossStyle
    
    If colCrossStyles.Count > 0 Then
        Screen.MousePointer = vbDefault
        sAction = "Select Crosstable Stylesheet"
        frmLayouts.Show vbModal, fMainForm
        If bAbort Then
            sAction = Empty
            Set .CrossStyle = Nothing
            cWebPages.BuildHtmlNameCollection
            Screen.MousePointer = vbDefault
            Exit Sub
        End If
    Else
        MsgBox "Sorry, but PalMate couldn't find a free stylesheet for the crosstable.", vbInformation, "Sorry"
        Me.CrossLinkTable = False
        Me.CrossTableNoLinks = False
        .Ini2.CrossLink = "off"
        .Ini2.HtmlType = Me.OldPageType
        Set colCrossStyles = Nothing
        UpdateMenu
        Exit Sub
    End If

'   Local DOS target directory
    .PathWebCrossCss = .PathWebCss
'   Local DOS source path to crosstable directory
    .PathCrossSource = App.path & "\CrossCss\" & .CrossStylesheetName
    
    If .Ini2.CrossLink = "on" Then
        Me.CrossLinkTable = True
        Me.CrossTableNoLinks = False
    Else
        Me.CrossTableNoLinks = True
        Me.CrossLinkTable = False
    End If
    
'   Finds the project's frmPgnText form and initialises
'   the treeview window for the crosstable stylesheet.
    For Each fForm In Forms
        If fForm.Caption = .CaptionName Then
            fForm.InitCrossTree
            Exit For
        End If
    Next
    
    sTarget = .PathWebCrossCss & "\" & .CrossStylesheetName
    If FileCheck(sTarget) Then
        vAnswer = MsgBox("PalMate is now going to replace an older file named " & .CrossStylesheetName & " in " & _
        "the stylesheet target directory. If you select ""No"" it will be replaced later when you preview " & _
        "or save the page, but you'll have a chance to save it." & vbNewLine & vbNewLine & _
        "Replace now?", vbYesNo + vbExclamation, "Replace " & .CrossStylesheetName & " Now?")
        If vAnswer = vbYes Then
            Call CopyFile(.PathCrossSource, .PathWebCrossCss & "\" & .CrossStylesheetName)
        End If
    End If
End With

Set fForm = Nothing
Set colCrossStyles = Nothing
vAnswer = Empty
Screen.MousePointer = vbDefault

Exit Sub

ErrorHandler:
Screen.MousePointer = vbDefault
Set fForm = Nothing
MsgBox Err.Description & vbNewLine & _
"Error converting page to a crosstable page without links. Procedure ConvertToCrosstable.", vbCritical, "Error"
End Sub
Public Property Let Previewed(ByVal vData As Boolean)
Attribute Previewed.VB_Description = "Flag. If processed once by Palview the flag is set = true. Used when checking for older html and css files with identical names as the new. If a page is processed for the first time and an older html and/or css file exists, we prompt before overwriting."
    mvarPreviewed = vData
End Property
Public Property Get Previewed() As Boolean
    Previewed = mvarPreviewed
End Property
Public Property Set HtmlFileNames(ByVal vData As Object)
Attribute HtmlFileNames.VB_Description = "The name (or names) of the HTML file(s) that will be saved. These names are initially made from the pgn file names, but can be changed by the user. The only exception is with a page with frames - then only the ""top file's"" name can be changed."
    Set mvarHtmlFileNames = vData
End Property
Public Property Get HtmlFileNames() As Collection
    Set HtmlFileNames = mvarHtmlFileNames
End Property
Public Property Let PathWebCss(ByVal vData As String)
Attribute PathWebCss.VB_Description = "Local DOS path to the directory in which the final CSS file will be saved."
    mvarPathWebCss = vData
End Property
Public Property Get PathWebCss() As String
    PathWebCss = mvarPathWebCss
End Property
Public Property Let PathHtml(ByVal vData As String)
Attribute PathHtml.VB_Description = "Local DOS path to HTML directory - the folder in which the HTML file will be saved."
    mvarPathHtml = vData
End Property
Public Property Get PathHtml() As String
    PathHtml = mvarPathHtml
End Property
Public Property Let MultiplePgn(ByVal vData As Boolean)
Attribute MultiplePgn.VB_Description = "True if multiple pgn files are to be converted. False if only one."
    mvarMultiplePgn = vData
End Property
Public Property Get MultiplePgn() As Boolean
    MultiplePgn = mvarMultiplePgn
End Property
Public Property Set PgnFiles(ByVal vData As Object)
    Set mvarPgnFiles = vData
End Property
Public Property Get PgnFiles() As PgnFiles
    Set PgnFiles = mvarPgnFiles
End Property
Public Property Set Layout(ByVal vData As Object)
    Set mvarLayout = vData
End Property
Public Property Get Layout() As Layout
    Set Layout = mvarLayout
End Property

Private Sub Class_Initialize()
    #If DebugMode Then
        'get the next available class ID, and print out
        'that the class was created successfully
        mlClassDebugID = GetNextClassDebugID()
        Debug.Print "'" & TypeName(Me) & "' instance " & mlClassDebugID & " created"
    #End If
    
  'create the mMagazine object when the WebPage class is created
  Set mvarMagazine = New Magazine
End Sub


Private Sub Class_Terminate()
  
On Error Resume Next

With mvarMagazine
    If Len(.OrigBackup) > 0 Then
        Kill App.path & "\Backup\" & .HtmlTemplateName
    End If
End With

Set mvarMagazine = Nothing

#If DebugMode Then
    Debug.Print "'" & TypeName(Me) & "' instance " & CStr(mlClassDebugID) & " is terminating"
#End If

End Sub


#If DebugMode Then
    Public Property Get ClassDebugID()
        'if we are in debug mode, surface this property that consumers can query
        ClassDebugID = mlClassDebugID
    End Property
#End If

