VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "WebPages"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"WebPage"
Attribute VB_Ext_KEY = "Member0" ,"WebPage"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private mCol As Collection

Public Sub BuildHtmlNameCollection()
Attribute BuildHtmlNameCollection.VB_Description = "Builds the collection with HTML file names made from the pgn file names. The file name (or names) are displayed on the WebPage form."
'Builds the collection with HTML file
'name(s). This/these are displayed on
'the WebPage project form.
'At creation time the names are made
'from the selected pgn file names.

Dim lCount As Long
Dim lCount2 As Long
Dim lNameLen As Long
Dim sFileName As String


On Error GoTo ErrorHandler

With Me(lAW)
    'If the collection of html files already
    'contains some names, the user has probably
    'changed his basic layout, so we delete the
    'old collection before a new is built.
    If .HtmlFileNames.Count > 0 Then
        Set .HtmlFileNames = Nothing
        Set .HtmlFileNames = New Collection
    End If
    
    'P4 addition - magviewer
    If cLayouts(lAL).Ini2.HtmlType = "magviewer" Then
        If Len(cLayouts(lAL).Ini3.ViewerName) > 0 Then
            .HtmlFileNames.Add cLayouts(lAL).Ini3.ViewerName
        Else
            .HtmlFileNames.Add cLayouts(lAL).Key & ".htm"
        End If
    End If
    'End P4 addition
    
    If .PgnFiles.Count > 0 Then
        For lCount = 1 To .PgnFiles.Count
            'If the pgnfile's collection of associated html
            'filenames isn't empty we remove the old collection
            'and create a new one, just as we did above with the
            'webpage's collection of all html names.
            If .PgnFiles(lCount).HtmlNames.Count > 0 Then
                Set .PgnFiles(lCount).HtmlNames = Nothing
                Set .PgnFiles(lCount).HtmlNames = New Collection
            End If
            
            'The pgn filename is converted to *.htm.
            'In case it is a long file name, we get a short
            'name from the OS.
            sFileName = MakeHtmlName(.PgnFiles(lCount).FilePath)
            .HtmlFileNames.Add sFileName
            .PgnFiles(lCount).HtmlNames.Add sFileName
            
            'The name of the html to open (there could be more than one!)
            'is saved.
            .PgnFiles(lCount).HtmlFirstPage = sFileName
            
            'We find the number of characters to keep from the original
            'filename.
            lNameLen = Len(sFileName) - 4
            
            'If it is a framed page there'll be 3 pages in total and
            'we add the remaining two to the list.
            If cLayouts(lAL).Ini2.HtmlType = "frames" Then
                sFileName = Left$(sFileName, lNameLen) & "b.htm"
                .HtmlFileNames.Add sFileName
                .PgnFiles(lCount).HtmlNames.Add sFileName
                sFileName = Left$(sFileName, lNameLen) & "g.htm"
                .HtmlFileNames.Add sFileName
                .PgnFiles(lCount).HtmlNames.Add sFileName
            End If
            
            'If the htmlstyle is "muliframe" we first check if there's
            'more than one game in the pgn file. If there's only one
            'game the htmlstyle is changed to "iframe" as Palview would do.
            'If there is more than one game we add the necessary files,
            'which are "g0.htm", "g1.htm", "g2.htm" etc.
            If cLayouts(lAL).Ini2.HtmlType = "muliframe" Then
                cWebPages(lAW).PgnFiles(lCount).MakeGameList
                If .PgnFiles(lCount).GameNumbers.Count = 1 Then
                    cLayouts(lAL).Ini2.HtmlType = "iframe"
                Else
                    For lCount2 = 1 To .PgnFiles(lCount).GameNumbers.Count
                        .HtmlFileNames.Add "g" & lCount2 - 1 & ".htm"
                        .PgnFiles(lCount).HtmlNames.Add "g" & lCount2 - 1 & ".htm"
                    Next
                End If
            End If
            
            'If htmstyle is "iframe" one extra file is added to the list.
            If cLayouts(lAL).Ini2.HtmlType = "iframe" Then
                sFileName = Left$(sFileName, lNameLen) & "g.htm"
                .HtmlFileNames.Add sFileName
                .PgnFiles(lCount).HtmlNames.Add sFileName
            End If
            
            'If it is a crosstable page with links to game pages
            'we need to know the number of games in the pgn file
            'because the game files will be named g0.htm, g1.htm etc.
            If cLayouts(lAL).Ini2.HtmlType = "batch" And cLayouts(lAL).Ini2.CrossLink = "on" Then
                'If the pgn file hasn't been parsed before we do it now
                'to determine the number of games.
                If .PgnFiles(lAP).GameNumbers Is Nothing Then
                    .PgnFiles(lAP).MakeGameList
                End If
                'For each game a html file name is constructed.
                For lCount2 = 0 To .PgnFiles(lAP).GameNumbers.Count - 1
                    sFileName = "g" & lCount2 & ".htm"
                    .HtmlFileNames.Add sFileName
                Next
                Set .PgnFiles(lAP).HtmlNames = .HtmlFileNames
            End If
        Next
    End If
End With

Exit Sub
ErrorHandler:
MsgBox Err.Description & vbNewLine & _
"Error building collection of html filenames to upload. Procedure BuildHtmlNameCollection.", vbCritical, "Error"
bAbort = True
End Sub

Public Sub MakeNewPage()
Attribute MakeNewPage.VB_Description = "Creates a new webpage project."
'Creates/builds a new webpage project and adds it to the
'collection.

Dim sPageName As String
Dim sHtmlType As String
Dim cPgn As Pgn
Dim cMag As Magazine
Dim vAnswer As Variant
Dim sNameNumber As String
Dim lCount As Long

On Error GoTo ErrorHandler

'If a layout collection hasn't been created,
'we do it now.
If cLayouts Is Nothing Then
    Set cLayouts = New Layouts
End If

'P4 addition/change. If there were more than 1 webproject and
'one was closed (not the last opened) and a new one was opened
'an error was triggered, because the key of last page in the
'collection was duplicated. This has now been fixed by incrementing
'not the collection's Count-value, but the last number in the key
'of the last webproject.
If Me.Count > 0 Then
    sPageName = Me(Me.Count).Key
    lCount = 1
    Do
        sNameNumber = Mid$(sPageName, Len(sPageName) - lCount + 1, 1)
        If sNameNumber = Chr(32) Then
            sNameNumber = Right$(sPageName, lCount - 1)
            Exit Do
        End If
        lCount = lCount + 1
    Loop
Else
    sNameNumber = "0"
End If
sPageName = "WebPage " & Val(sNameNumber) + 1 'Me.Count + 1

'We add the new webpage to the webpage collection
Me.Add sPageName, sPageName
sPageName = Empty   'Frees memory
lAW = Me.Count      'Indexnumber of active project

'Opens a list with available layouts from which the user
'must pick one for his webpage project.
Module1.ReadLayoutList

'If the user aborted
If bAbort Then
    GoTo Terminate
End If

With Me(lAW)
    'The webpage's layout is set = the layout we
    'just selected or added to the layouts collection.
    Set .Layout = cLayouts(lAL)

    'Now is the time to get information about the pgn
    'file or files to use for the webpage. After all
    'this is what it is all about!
    'However if we're adding a crosstable page to an existing
    'project, the pgn file is known already.

    'P4 addition: if it is a magviewer, pgn files
    'are not selected.
    Set .PgnFiles = New PgnFiles

    sHtmlType = .Layout.Ini2.HtmlType
    If sHtmlType <> "magviewer" Then
        'Select pgn file(s)
        If sHtmlType <> "magazine" Then
            frmPgnFiles.Show vbModal, fMainForm
        Else
            frmPgnFiles.HandlePgn
        End If
        
        'If the user aborted
        If bAbort Then
            GoTo Terminate
        End If
        
        'If any old player names was read from the style's ini file
        'the names are read into the pgn file's player name collection.
        If .Layout.Ini3.Player.Count > 0 Then
            .PgnFiles(lAP).Players.ImportNames
        End If
        
        'P4 addition. If it is a magazine, the user must point us to the
        'HTML template file that is to be modyfied to create a magazine.
        If sHtmlType = "magazine" Then
            Set cMag = New Magazine
            .Magazine.MakeNewMag
        End If
    End If

    'Initialises the collection that will hold
    'the HTML file name(s).
    Set .HtmlFileNames = New Collection
End With

If bAbort Then
    GoTo Terminate
End If

'Initialises the htmlname collection of each pgn class.
'This will hold the associated html filenames.

'P4 addition:
'For a magviewer we ask the user for a name and don't
'create the names from the pgn files.

With cLayouts(lAL)
    If .Ini2.HtmlType <> "magviewer" Then
        For Each cPgn In Me(lAW).PgnFiles
            Set cPgn.HtmlNames = New Collection
        Next
    Else
        If Len(.Ini3.ViewerName) = 0 Then
            .Ini3.ViewerName = .Key & ".htm"
        End If
    End If
End With

Set cPgn = Nothing  'Frees memory
BuildHtmlNameCollection


If bAbort Then
    GoTo Terminate
End If

'P4 change. If a magviewer it gets its paths from the magazine
If cLayouts(lAL).Ini2.HtmlType <> "magviewer" Then
    Me(lAW).PathHtml = Me(lAW).Layout.PathHtml
    Me(lAW).PathWebCss = Me(lAW).Layout.PathWebCss
Else
    Me(lAW).PathHtml = Me(lAW - 1).Layout.PathHtml
    Me(lAW).PathWebCss = Me(lAW - 1).Layout.PathWebCss
    cLayouts(lAL).Ini2.JsFile = "on"    'Magviewer always has separate javascript file
End If

If bAbort Then
    GoTo Terminate
End If


With cLayouts(lAL)
'   If it is a crosstable page
    If .Ini2.HtmlType = "batch" Then
        If .Ini2.CrossLink = "on" Then
            Me(lAW).CrossLinkTable = True
        Else
            Me(lAW).CrossTableNoLinks = True
        End If
    End If
End With

Exit Sub
ErrorHandler:
Set cPgn = Nothing
MsgBox Err.Description & vbNewLine & "Unexpected error in procedure NewWebPage.", vbCritical, "Error"
Exit Sub
Terminate:
Set cPgn = Nothing
bAbort = True

End Sub

Public Function Add(Key As String, Optional sKey As String) As WebPage
    'create a new object
    Dim objNewMember As WebPage
    Set objNewMember = New WebPage


    'set the properties passed into the method
    objNewMember.Key = Key
    'objNewMember.Key = Key




    If Len(sKey) = 0 Then
        mCol.Add objNewMember
    Else
        mCol.Add objNewMember, sKey
    End If


    'return the object created
    Set Add = objNewMember
    Set objNewMember = Nothing

End Function
Public Property Get Item(vntIndexKey As Variant) As WebPage
Attribute Item.VB_UserMemId = 0
  Set Item = mCol(vntIndexKey)
End Property
Public Property Get Count() As Long
    Count = mCol.Count
End Property
Public Sub Remove(vntIndexKey As Variant)
    mCol.Remove vntIndexKey
End Sub
Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    'this property allows you to enumerate
    'this collection with the For...Each syntax
    Set NewEnum = mCol.[_NewEnum]
End Property
Private Sub Class_Initialize()
    Set mCol = New Collection
End Sub
Private Sub Class_Terminate()
    'destroys collection when this class is terminated
    Set mCol = Nothing
End Sub

