VERSION 5.00
Begin VB.Form frmLiveBroadcast 
   Caption         =   "Live Broadcast Options"
   ClientHeight    =   2250
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4245
   Icon            =   "frmLiveBroadcast.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2250
   ScaleWidth      =   4245
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton cmdHelp 
      Height          =   315
      Left            =   1680
      Picture         =   "frmLiveBroadcast.frx":06EA
      Style           =   1  'Graphical
      TabIndex        =   7
      ToolTipText     =   "Left click for PalMate help; right click for Palview help."
      Top             =   1770
      Width           =   255
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   315
      Left            =   2037
      TabIndex        =   6
      Top             =   1770
      Width           =   950
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   315
      Left            =   3090
      TabIndex        =   5
      Top             =   1770
      Width           =   950
   End
   Begin VB.Frame frRefreshTime 
      Caption         =   "Refresh Interval In Seconds"
      Height          =   885
      Left            =   120
      TabIndex        =   1
      Top             =   690
      Width           =   3900
      Begin VB.TextBox txtRefreshTime 
         Alignment       =   2  'Center
         Height          =   300
         Left            =   2400
         TabIndex        =   2
         Top             =   330
         Width           =   585
      End
      Begin VB.Label Label1 
         Caption         =   "seconds"
         Height          =   315
         Index           =   0
         Left            =   3030
         TabIndex        =   4
         Top             =   360
         Width           =   735
      End
      Begin VB.Label lblRefreshTime 
         Caption         =   "Refresh page automatically every"
         Height          =   465
         Left            =   120
         TabIndex        =   3
         Top             =   300
         Width           =   1635
      End
   End
   Begin VB.CheckBox chkLivePage 
      Caption         =   "This webpage is for live broadcast"
      Height          =   345
      Left            =   120
      TabIndex        =   0
      Top             =   180
      Width           =   3795
   End
End
Attribute VB_Name = "frmLiveBroadcast"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Compare Text
Option Explicit
Dim lSeconds As Long

Private Sub cmdHelp_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim sHelpUrl As String
Dim sFile As String
Dim sHtmlType As String

On Error GoTo ErrorHandler

sHtmlType = cLayouts(lAL).Ini2.HtmlType

Select Case Button
    Case 2
        If sHtmlType = "overview" Or sHtmlType = "overdb" Then
            sHelpUrl = sPathPalManual & "live.htm"
        Else
            sHelpUrl = sPathPalManual & "ini" & sDelim & "refreshtime.htm"
        End If
    Case Else
        sFile = "livepage.htm"
        sHelpUrl = App.path & "\help\" & sFile
End Select

Me.Hide

Call ShowHelp(sHelpUrl)

Me.Show vbModal, fMainForm

Exit Sub

ErrorHandler:
MsgBox Err.Description & vbNewLine & _
"Error displaying help.", vbCritical, "Error"

End Sub

Private Sub Form_Load()

On Error GoTo ErrorHandler

With chkLivePage
    If cLayouts(lAL).Ini2.HtmlType = "overview" Or cLayouts(lAL).Ini2.HtmlType = "overdb" Then
        .Value = vbChecked
        .Enabled = False
        .ToolTipText = "The basic layout (overview) is for live broadcast only"
    Else
        If cLayouts(lAL).Ini1.RefreshTime > 0 Then
            .Value = vbChecked
        End If
    End If
    
    lSeconds = cLayouts(lAL).Ini1.RefreshTime
    
    If lSeconds > 0 Then .Value = vbChecked
    
    If .Value = vbUnchecked Then
        txtRefreshTime.Enabled = False
        txtRefreshTime.BackColor = vbButtonFace
    End If
End With

Exit Sub

ErrorHandler:
MsgBox Err.Description & vbNewLine & _
"Error loading form for live broadcast.", vbCritical, "Error"

End Sub

Private Sub cmdOK_Click()
Dim lColumns As Long

On Error GoTo ErrorHandler

If chkLivePage.Value = vbUnchecked Then
    cLayouts(lAL).Ini1.RefreshTime = 0
    If fMainForm.mnuPageNs4Comp.Checked = False Then
        fMainForm.mnuPageLanguageSelection.Visible = True
    Else
        fMainForm.mnuPageLanguageSelection.Visible = False
    End If
    Unload Me
    Exit Sub
End If

lSeconds = Val(txtRefreshTime.Text)

If lSeconds < 1 Or lSeconds > 3600 Then
    MsgBox "The refresh interval must be a value between 1 and 3600", vbExclamation, "Invalid Refresh Interval"
    Exit Sub
End If

cLayouts(lAL).Ini1.RefreshTime = lSeconds

If cLayouts(lAL).Ini2.JsFile = "on" Then
    cLayouts(lAL).Ini2.JsFile = "off"
    MsgBox "Writing the javascript to a separate file is not possible " & _
    "with live pages and has been disabled", vbInformation, "Separate JavaScript Disabled"
End If

With fMainForm.mnuPageLanguageSelection
    .Checked = False
    .Visible = False
End With
cLayouts(lAL).Ini2.MultiLang = "off"

Unload Me

Exit Sub

ErrorHandler:
MsgBox Err.Description & vbNewLine & _
"Error writing settings for live broadcast.", vbCritical, "Error"

End Sub


Private Sub chkLivePage_Click()

With txtRefreshTime
    If chkLivePage.Value = vbChecked Then
        .Enabled = True
        .BackColor = vbWhite
        If Len(.Text) = 0 Then
            .Text = cLayouts(lAL).Ini1.RefreshTime
            If Val(.Text) = 0 Then
                .Text = "60"
                lSeconds = Val(.Text)
            End If
        End If
    Else
        .Enabled = False
        .BackColor = vbButtonFace
        .Text = Empty
    End If
End With

End Sub

Private Sub txtRefreshTime_GotFocus()
txtRefreshTime.SelLength = Len(txtRefreshTime.Text)
End Sub

Private Sub txtRefreshTime_KeyPress(KeyAscii As Integer)
If KeyAscii = 8 Then Exit Sub
If KeyAscii < 48 Or KeyAscii > 57 Then KeyAscii = 0
End Sub

Private Sub cmdCancel_Click()
Unload Me

End Sub

